library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_signed.all;
entity net_wasamon_blokus_javarock_blokusboard is
  port (
    output_port_getSym : OUT std_logic_vector(7 downto 0);
    notify_method_busy : OUT std_logic;
    output_port_get : OUT std_logic_vector(31 downto 0);
    init_method_busy : OUT std_logic;
    getSym_method_busy : OUT std_logic;
    output_port_getPattern : OUT std_logic_vector(7 downto 0);
    output_port_isValid : OUT std_logic;
    move_method_busy : OUT std_logic;
    get_method_busy : OUT std_logic;
    isValid_method_busy : OUT std_logic;
    getPattern_method_busy : OUT std_logic;
    notify_method_request : IN std_logic;
    getSym_method_request : IN std_logic;
    input_port_move_c : IN std_logic_vector(31 downto 0);
    isValid_method_request : IN std_logic;
    input_port_isValid_c : IN std_logic_vector(31 downto 0);
    clk : IN std_logic;
    input_port_move_rot : IN std_logic_vector(31 downto 0);
    init_method_request : IN std_logic;
    input_port_move_id : IN std_logic_vector(31 downto 0);
    input_port_get_y : IN std_logic_vector(31 downto 0);
    input_port_get_x : IN std_logic_vector(31 downto 0);
    input_port_isValid_rot : IN std_logic_vector(31 downto 0);
    input_port_isValid_id : IN std_logic_vector(31 downto 0);
    input_port_getPattern_r : IN std_logic_vector(31 downto 0);
    input_port_getSym_y : IN std_logic_vector(31 downto 0);
    input_port_getSym_x : IN std_logic_vector(31 downto 0);
    input_port_move_y : IN std_logic_vector(31 downto 0);
    input_port_move_x : IN std_logic_vector(31 downto 0);
    getPattern_method_request : IN std_logic;
    move_method_request : IN std_logic;
    input_port_getPattern_k : IN std_logic_vector(31 downto 0);
    input_port_isValid_y : IN std_logic_vector(31 downto 0);
    input_port_getPattern_i : IN std_logic_vector(31 downto 0);
    input_port_isValid_x : IN std_logic_vector(31 downto 0);
    reset : IN std_logic;
    get_method_request : IN std_logic
  );
end net_wasamon_blokus_javarock_blokusboard;

architecture RTL of net_wasamon_blokus_javarock_blokusboard is
  component simpledualportram
    generic (
      DEPTH : integer := 10;
      WIDTH : integer := 32
    );
    port (
      clk : IN std_logic;
      we : IN std_logic_vector(0 downto 0);
      raddr : IN std_logic_vector(DEPTH-1 downto 0);
      rdata : OUT std_logic_vector(WIDTH-1 downto 0);
      waddr : IN std_logic_vector(DEPTH-1 downto 0);
      wdata : IN std_logic_vector(WIDTH-1 downto 0)
    );
  end component;
  component vhdl_block_pattern_length_table
    port (
      clk : IN std_logic;
      reset : IN std_logic;
      data_raddr : IN std_logic_vector(31 downto 0);
      data_rdata : OUT std_logic_vector(7 downto 0)
    );
  end component;
  component vhdl_block_pattern_sym_table
    port (
      clk : IN std_logic;
      reset : IN std_logic;
      data_raddr : IN std_logic_vector(31 downto 0);
      data_rdata : OUT std_logic_vector(7 downto 0)
    );
  end component;
  component vhdl_block_pattern_table
    port (
      clk : IN std_logic;
      reset : IN std_logic;
      data_raddr : IN std_logic_vector(31 downto 0);
      data_rdata : OUT std_logic_vector(7 downto 0)
    );
  end component;
  constant sym_WIDTH : integer := 7-0+1;
  constant check_y_DEPTH : integer := 3;
  constant check_x_length : integer := 5;
  constant sym_DEPTH : integer := 8;
  constant map_WIDTH : integer := 31-0+1;
  constant map_length : integer := 256;
  constant ORANGE : integer := 2;
  constant check_x_WIDTH : integer := 31-0+1;
  constant COLS : integer := 14;
  constant sym_length : integer := 256;
  constant NONE : integer := 0;
  constant map_DEPTH : integer := 8;
  constant BLUE : integer := 1;
  constant check_x_DEPTH : integer := 3;
  constant check_y_length : integer := 5;
  constant ROWS : integer := 14;
  constant check_y_WIDTH : integer := 31-0+1;
  signal check_y_we_field_wdata_reset : std_logic_vector(0 downto 0) := (others => '0');
  signal check_y_we_field_wdata_reset_strobe : std_logic := '0';
  signal check_y_we_field_wdata_writer_state_counter_setup_setup_3 : std_logic_vector(0 downto 0) := (others => '0');
  signal check_y_we_field_wdata_writer_strobe_state_counter_setup_setup_3 : std_logic := '0';
  signal check_y_we_field_rdata : std_logic_vector(0 downto 0) := (others => '0');
  signal check_y_we_field_wdata : std_logic_vector(0 downto 0) := (others => '0');
  signal symTable_data_raddr_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal symTable_data_raddr_field_wdata_reset_strobe : std_logic := '0';
  signal symTable_data_raddr_field_wdata_writer_move_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal symTable_data_raddr_field_wdata_writer_strobe_move_method_state : std_logic := '0';
  signal symTable_data_raddr_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal symTable_data_raddr_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal lenTable_data_raddr_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal lenTable_data_raddr_field_wdata_reset_strobe : std_logic := '0';
  signal lenTable_data_raddr_field_wdata_writer_move_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal lenTable_data_raddr_field_wdata_writer_strobe_move_method_state : std_logic := '0';
  signal lenTable_data_raddr_field_wdata_writer_setup_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal lenTable_data_raddr_field_wdata_writer_strobe_setup_method_state : std_logic := '0';
  signal lenTable_data_raddr_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal lenTable_data_raddr_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_isInsideAndEmpty_method_request_field_wdata_reset : std_logic := '0';
  signal this_isInsideAndEmpty_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_isInsideAndEmpty_method_request_field_wdata_writer_state_counter_isValid_isValid_1 : std_logic := '0';
  signal this_isInsideAndEmpty_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_1 : std_logic := '0';
  signal this_isInsideAndEmpty_method_request_field_rdata : std_logic := '0';
  signal this_isInsideAndEmpty_method_request_field_wdata : std_logic := '0';
  signal map_rdata_field_wdata_reset : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal map_rdata_field_wdata_reset_strobe : std_logic := '0';
  signal map_rdata_field_rdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal map_rdata_field_wdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal table_data_rdata_field_wdata_reset : std_logic_vector(7 downto 0) := (others => '0');
  signal table_data_rdata_field_wdata_reset_strobe : std_logic := '0';
  signal table_data_rdata_field_rdata : std_logic_vector(7 downto 0) := (others => '0');
  signal table_data_rdata_field_wdata : std_logic_vector(7 downto 0) := (others => '0');
  signal sym_we_field_wdata_reset : std_logic_vector(0 downto 0) := (others => '0');
  signal sym_we_field_wdata_reset_strobe : std_logic := '0';
  signal sym_we_field_wdata_writer_state_counter_init_init_2 : std_logic_vector(0 downto 0) := (others => '0');
  signal sym_we_field_wdata_writer_strobe_state_counter_init_init_2 : std_logic := '0';
  signal sym_we_field_wdata_writer_put_method_state : std_logic_vector(0 downto 0) := (others => '0');
  signal sym_we_field_wdata_writer_strobe_put_method_state : std_logic := '0';
  signal sym_we_field_rdata : std_logic_vector(0 downto 0) := (others => '0');
  signal sym_we_field_wdata : std_logic_vector(0 downto 0) := (others => '0');
  signal sym_wdata_field_wdata_reset : std_logic_vector(7-0+1-1 downto 0) := (others => '0');
  signal sym_wdata_field_wdata_reset_strobe : std_logic := '0';
  signal sym_wdata_field_wdata_writer_put_method_state : std_logic_vector(7-0+1-1 downto 0) := (others => '0');
  signal sym_wdata_field_wdata_writer_strobe_put_method_state : std_logic := '0';
  signal sym_wdata_field_wdata_writer_state_counter_init_init_2 : std_logic_vector(7-0+1-1 downto 0) := (others => '0');
  signal sym_wdata_field_wdata_writer_strobe_state_counter_init_init_2 : std_logic := '0';
  signal sym_wdata_field_rdata : std_logic_vector(7-0+1-1 downto 0) := (others => '0');
  signal sym_wdata_field_wdata : std_logic_vector(7-0+1-1 downto 0) := (others => '0');
  signal this_isVertexSharing_method_request_field_wdata_reset : std_logic := '0';
  signal this_isVertexSharing_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_isVertexSharing_method_request_field_wdata_writer_state_counter_isValid_isValid_7 : std_logic := '0';
  signal this_isVertexSharing_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_7 : std_logic := '0';
  signal this_isVertexSharing_method_request_field_rdata : std_logic := '0';
  signal this_isVertexSharing_method_request_field_wdata : std_logic := '0';
  signal map_waddr_field_wdata_reset : std_logic_vector(8-1 downto 0) := (others => '0');
  signal map_waddr_field_wdata_reset_strobe : std_logic := '0';
  signal map_waddr_field_wdata_writer_state_counter_init_init_2 : std_logic_vector(8-1 downto 0) := (others => '0');
  signal map_waddr_field_wdata_writer_strobe_state_counter_init_init_2 : std_logic := '0';
  signal map_waddr_field_wdata_writer_put_method_state : std_logic_vector(8-1 downto 0) := (others => '0');
  signal map_waddr_field_wdata_writer_strobe_put_method_state : std_logic := '0';
  signal map_waddr_field_rdata : std_logic_vector(8-1 downto 0) := (others => '0');
  signal map_waddr_field_wdata : std_logic_vector(8-1 downto 0) := (others => '0');
  signal check_y_rdata_field_wdata_reset : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal check_y_rdata_field_wdata_reset_strobe : std_logic := '0';
  signal check_y_rdata_field_rdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal check_y_rdata_field_wdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal this_wait_method_request_field_wdata_reset : std_logic := '0';
  signal this_wait_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_wait_method_request_field_rdata : std_logic := '0';
  signal this_wait_method_request_field_wdata : std_logic := '0';
  signal check_x_rdata_field_wdata_reset : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal check_x_rdata_field_wdata_reset_strobe : std_logic := '0';
  signal check_x_rdata_field_rdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal check_x_rdata_field_wdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_c_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_c_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_isDuplicated_c_field_wdata_writer_isEdgeSharing_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_c_field_wdata_writer_strobe_isEdgeSharing_method_state : std_logic := '0';
  signal this_input_port_isDuplicated_c_field_wdata_writer_isVertexSharing_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_c_field_wdata_writer_strobe_isVertexSharing_method_state : std_logic := '0';
  signal this_input_port_isDuplicated_c_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_c_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal check_y_waddr_field_wdata_reset : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_y_waddr_field_wdata_reset_strobe : std_logic := '0';
  signal check_y_waddr_field_wdata_writer_state_counter_setup_setup_3 : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_y_waddr_field_wdata_writer_strobe_state_counter_setup_setup_3 : std_logic := '0';
  signal check_y_waddr_field_rdata : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_y_waddr_field_wdata : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_x_waddr_field_wdata_reset : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_x_waddr_field_wdata_reset_strobe : std_logic := '0';
  signal check_x_waddr_field_wdata_writer_state_counter_setup_setup_3 : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_x_waddr_field_wdata_writer_strobe_state_counter_setup_setup_3 : std_logic := '0';
  signal check_x_waddr_field_rdata : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_x_waddr_field_wdata : std_logic_vector(3-1 downto 0) := (others => '0');
  signal this_setup_method_request_field_wdata_reset : std_logic := '0';
  signal this_setup_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_setup_method_request_field_wdata_writer_isValid_method_state : std_logic := '0';
  signal this_setup_method_request_field_wdata_writer_strobe_isValid_method_state : std_logic := '0';
  signal this_setup_method_request_field_rdata : std_logic := '0';
  signal this_setup_method_request_field_wdata : std_logic := '0';
  signal this_input_port_isVertexSharing_c_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isVertexSharing_c_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_isVertexSharing_c_field_wdata_writer_state_counter_isValid_isValid_7 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isVertexSharing_c_field_wdata_writer_strobe_state_counter_isValid_isValid_7 : std_logic := '0';
  signal this_input_port_isVertexSharing_c_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isVertexSharing_c_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_y_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_y_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_setup_y_field_wdata_writer_isValid_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_y_field_wdata_writer_strobe_isValid_method_state : std_logic := '0';
  signal this_input_port_setup_y_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_y_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_isDuplicated_method_request_field_wdata_reset : std_logic := '0';
  signal this_isDuplicated_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_isDuplicated_method_request_field_wdata_writer_isEdgeSharing_method_state : std_logic := '0';
  signal this_isDuplicated_method_request_field_wdata_writer_strobe_isEdgeSharing_method_state : std_logic := '0';
  signal this_isDuplicated_method_request_field_wdata_writer_isVertexSharing_method_state : std_logic := '0';
  signal this_isDuplicated_method_request_field_wdata_writer_strobe_isVertexSharing_method_state : std_logic := '0';
  signal this_isDuplicated_method_request_field_rdata : std_logic := '0';
  signal this_isDuplicated_method_request_field_wdata : std_logic := '0';
  signal this_input_port_setup_x_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_x_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_setup_x_field_wdata_writer_isValid_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_x_field_wdata_writer_strobe_isValid_method_state : std_logic := '0';
  signal this_input_port_setup_x_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_x_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_id_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_id_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_setup_id_field_wdata_writer_isValid_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_id_field_wdata_writer_strobe_isValid_method_state : std_logic := '0';
  signal this_input_port_setup_id_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_id_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_y_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_y_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_put_y_field_wdata_writer_state_counter_move_move_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_y_field_wdata_writer_strobe_state_counter_move_move_4 : std_logic := '0';
  signal this_input_port_put_y_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_y_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_x_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_x_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_put_x_field_wdata_writer_state_counter_move_move_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_x_field_wdata_writer_strobe_state_counter_move_move_4 : std_logic := '0';
  signal this_input_port_put_x_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_x_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal sym_rdata_field_wdata_reset : std_logic_vector(7-0+1-1 downto 0) := (others => '0');
  signal sym_rdata_field_wdata_reset_strobe : std_logic := '0';
  signal sym_rdata_field_rdata : std_logic_vector(7-0+1-1 downto 0) := (others => '0');
  signal sym_rdata_field_wdata : std_logic_vector(7-0+1-1 downto 0) := (others => '0');
  signal this_input_port_put_s_field_wdata_reset : std_logic_vector(7 downto 0) := (others => '0');
  signal this_input_port_put_s_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_put_s_field_wdata_writer_state_counter_move_move_4 : std_logic_vector(7 downto 0) := (others => '0');
  signal this_input_port_put_s_field_wdata_writer_strobe_state_counter_move_move_4 : std_logic := '0';
  signal this_input_port_put_s_field_rdata : std_logic_vector(7 downto 0) := (others => '0');
  signal this_input_port_put_s_field_wdata : std_logic_vector(7 downto 0) := (others => '0');
  signal map_raddr_field_wdata_reset : std_logic_vector(8-1 downto 0) := (others => '0');
  signal map_raddr_field_wdata_reset_strobe : std_logic := '0';
  signal map_raddr_field_wdata_writer_get_method_state : std_logic_vector(8-1 downto 0) := (others => '0');
  signal map_raddr_field_wdata_writer_strobe_get_method_state : std_logic := '0';
  signal map_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_8 : std_logic_vector(8-1 downto 0) := (others => '0');
  signal map_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_8 : std_logic := '0';
  signal map_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_8 : std_logic_vector(8-1 downto 0) := (others => '0');
  signal map_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_8 : std_logic := '0';
  signal map_raddr_field_rdata : std_logic_vector(8-1 downto 0) := (others => '0');
  signal map_raddr_field_wdata : std_logic_vector(8-1 downto 0) := (others => '0');
  signal table_data_raddr_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal table_data_raddr_field_wdata_reset_strobe : std_logic := '0';
  signal table_data_raddr_field_wdata_writer_state_counter_move_move_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal table_data_raddr_field_wdata_writer_strobe_state_counter_move_move_4 : std_logic := '0';
  signal table_data_raddr_field_wdata_writer_state_counter_setup_setup_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal table_data_raddr_field_wdata_writer_strobe_state_counter_setup_setup_3 : std_logic := '0';
  signal table_data_raddr_field_wdata_writer_getPattern_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal table_data_raddr_field_wdata_writer_strobe_getPattern_method_state : std_logic := '0';
  signal table_data_raddr_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal table_data_raddr_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal lenTable_data_rdata_field_wdata_reset : std_logic_vector(7 downto 0) := (others => '0');
  signal lenTable_data_rdata_field_wdata_reset_strobe : std_logic := '0';
  signal lenTable_data_rdata_field_rdata : std_logic_vector(7 downto 0) := (others => '0');
  signal lenTable_data_rdata_field_wdata : std_logic_vector(7 downto 0) := (others => '0');
  signal symTable_data_rdata_field_wdata_reset : std_logic_vector(7 downto 0) := (others => '0');
  signal symTable_data_rdata_field_wdata_reset_strobe : std_logic := '0';
  signal symTable_data_rdata_field_rdata : std_logic_vector(7 downto 0) := (others => '0');
  signal symTable_data_rdata_field_wdata : std_logic_vector(7 downto 0) := (others => '0');
  signal check_x_we_field_wdata_reset : std_logic_vector(0 downto 0) := (others => '0');
  signal check_x_we_field_wdata_reset_strobe : std_logic := '0';
  signal check_x_we_field_wdata_writer_state_counter_setup_setup_3 : std_logic_vector(0 downto 0) := (others => '0');
  signal check_x_we_field_wdata_writer_strobe_state_counter_setup_setup_3 : std_logic := '0';
  signal check_x_we_field_rdata : std_logic_vector(0 downto 0) := (others => '0');
  signal check_x_we_field_wdata : std_logic_vector(0 downto 0) := (others => '0');
  signal sym_waddr_field_wdata_reset : std_logic_vector(8-1 downto 0) := (others => '0');
  signal sym_waddr_field_wdata_reset_strobe : std_logic := '0';
  signal sym_waddr_field_wdata_writer_state_counter_init_init_2 : std_logic_vector(8-1 downto 0) := (others => '0');
  signal sym_waddr_field_wdata_writer_strobe_state_counter_init_init_2 : std_logic := '0';
  signal sym_waddr_field_wdata_writer_put_method_state : std_logic_vector(8-1 downto 0) := (others => '0');
  signal sym_waddr_field_wdata_writer_strobe_put_method_state : std_logic := '0';
  signal sym_waddr_field_rdata : std_logic_vector(8-1 downto 0) := (others => '0');
  signal sym_waddr_field_wdata : std_logic_vector(8-1 downto 0) := (others => '0');
  signal check_y_raddr_field_wdata_reset : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_y_raddr_field_wdata_reset_strobe : std_logic := '0';
  signal check_y_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_y_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 : std_logic := '0';
  signal check_y_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_2 : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_y_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_2 : std_logic := '0';
  signal check_y_raddr_field_rdata : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_y_raddr_field_wdata : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_x_raddr_field_wdata_reset : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_x_raddr_field_wdata_reset_strobe : std_logic := '0';
  signal check_x_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_x_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 : std_logic := '0';
  signal check_x_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_2 : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_x_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_2 : std_logic := '0';
  signal check_x_raddr_field_rdata : std_logic_vector(3-1 downto 0) := (others => '0');
  signal check_x_raddr_field_wdata : std_logic_vector(3-1 downto 0) := (others => '0');
  signal this_input_port_decode_code_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_decode_code_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_decode_code_field_wdata_writer_state_counter_move_move_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_decode_code_field_wdata_writer_strobe_state_counter_move_move_4 : std_logic := '0';
  signal this_input_port_decode_code_field_wdata_writer_state_counter_setup_setup_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_decode_code_field_wdata_writer_strobe_state_counter_setup_setup_3 : std_logic := '0';
  signal this_input_port_decode_code_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_decode_code_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_c_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_c_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_put_c_field_wdata_writer_state_counter_move_move_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_c_field_wdata_writer_strobe_state_counter_move_move_4 : std_logic := '0';
  signal this_input_port_put_c_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_put_c_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_put_method_request_field_wdata_reset : std_logic := '0';
  signal this_put_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_put_method_request_field_wdata_writer_state_counter_move_move_4 : std_logic := '0';
  signal this_put_method_request_field_wdata_writer_strobe_state_counter_move_move_4 : std_logic := '0';
  signal this_put_method_request_field_rdata : std_logic := '0';
  signal this_put_method_request_field_wdata : std_logic := '0';
  signal map_wdata_field_wdata_reset : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal map_wdata_field_wdata_reset_strobe : std_logic := '0';
  signal map_wdata_field_wdata_writer_put_method_state : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal map_wdata_field_wdata_writer_strobe_put_method_state : std_logic := '0';
  signal map_wdata_field_wdata_writer_state_counter_init_init_2 : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal map_wdata_field_wdata_writer_strobe_state_counter_init_init_2 : std_logic := '0';
  signal map_wdata_field_rdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal map_wdata_field_wdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal this_decode_method_request_field_wdata_reset : std_logic := '0';
  signal this_decode_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_decode_method_request_field_wdata_writer_state_counter_move_move_4 : std_logic := '0';
  signal this_decode_method_request_field_wdata_writer_strobe_state_counter_move_move_4 : std_logic := '0';
  signal this_decode_method_request_field_wdata_writer_state_counter_setup_setup_3 : std_logic := '0';
  signal this_decode_method_request_field_wdata_writer_strobe_state_counter_setup_setup_3 : std_logic := '0';
  signal this_decode_method_request_field_rdata : std_logic := '0';
  signal this_decode_method_request_field_wdata : std_logic := '0';
  signal check_len_field_wdata_reset : std_logic_vector(31 downto 0) := conv_std_logic_vector(0, 31-0+1);
  signal check_len_field_wdata_reset_strobe : std_logic := '0';
  signal check_len_field_wdata_writer_move_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal check_len_field_wdata_writer_strobe_move_method_state : std_logic := '0';
  signal check_len_field_wdata_writer_setup_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal check_len_field_wdata_writer_strobe_setup_method_state : std_logic := '0';
  signal check_len_field_rdata : std_logic_vector(31 downto 0) := conv_std_logic_vector(0, 31-0+1);
  signal check_len_field_wdata : std_logic_vector(31 downto 0) := conv_std_logic_vector(0, 31-0+1);
  signal map_we_field_wdata_reset : std_logic_vector(0 downto 0) := (others => '0');
  signal map_we_field_wdata_reset_strobe : std_logic := '0';
  signal map_we_field_wdata_writer_state_counter_init_init_2 : std_logic_vector(0 downto 0) := (others => '0');
  signal map_we_field_wdata_writer_strobe_state_counter_init_init_2 : std_logic := '0';
  signal map_we_field_wdata_writer_put_method_state : std_logic_vector(0 downto 0) := (others => '0');
  signal map_we_field_wdata_writer_strobe_put_method_state : std_logic := '0';
  signal map_we_field_rdata : std_logic_vector(0 downto 0) := (others => '0');
  signal map_we_field_wdata : std_logic_vector(0 downto 0) := (others => '0');
  signal check_y_wdata_field_wdata_reset : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal check_y_wdata_field_wdata_reset_strobe : std_logic := '0';
  signal check_y_wdata_field_wdata_writer_state_counter_setup_setup_3 : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal check_y_wdata_field_wdata_writer_strobe_state_counter_setup_setup_3 : std_logic := '0';
  signal check_y_wdata_field_rdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal check_y_wdata_field_wdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal check_x_wdata_field_wdata_reset : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal check_x_wdata_field_wdata_reset_strobe : std_logic := '0';
  signal check_x_wdata_field_wdata_writer_state_counter_setup_setup_3 : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal check_x_wdata_field_wdata_writer_strobe_state_counter_setup_setup_3 : std_logic := '0';
  signal check_x_wdata_field_rdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal check_x_wdata_field_wdata : std_logic_vector(31-0+1-1 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_dy_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_dy_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_isDuplicated_dy_field_wdata_writer_isEdgeSharing_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_dy_field_wdata_writer_strobe_isEdgeSharing_method_state : std_logic := '0';
  signal this_input_port_isDuplicated_dy_field_wdata_writer_isVertexSharing_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_dy_field_wdata_writer_strobe_isVertexSharing_method_state : std_logic := '0';
  signal this_input_port_isDuplicated_dy_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_dy_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_dx_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_dx_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_isDuplicated_dx_field_wdata_writer_isEdgeSharing_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_dx_field_wdata_writer_strobe_isEdgeSharing_method_state : std_logic := '0';
  signal this_input_port_isDuplicated_dx_field_wdata_writer_isVertexSharing_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_dx_field_wdata_writer_strobe_isVertexSharing_method_state : std_logic := '0';
  signal this_input_port_isDuplicated_dx_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isDuplicated_dx_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isEdgeSharing_c_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isEdgeSharing_c_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_isEdgeSharing_c_field_wdata_writer_state_counter_isValid_isValid_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isEdgeSharing_c_field_wdata_writer_strobe_state_counter_isValid_isValid_4 : std_logic := '0';
  signal this_input_port_isEdgeSharing_c_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isEdgeSharing_c_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_rot_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_rot_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_setup_rot_field_wdata_writer_isValid_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_rot_field_wdata_writer_strobe_isValid_method_state : std_logic := '0';
  signal this_input_port_setup_rot_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setup_rot_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_isEdgeSharing_method_request_field_wdata_reset : std_logic := '0';
  signal this_isEdgeSharing_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_isEdgeSharing_method_request_field_wdata_writer_state_counter_isValid_isValid_4 : std_logic := '0';
  signal this_isEdgeSharing_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_4 : std_logic := '0';
  signal this_isEdgeSharing_method_request_field_rdata : std_logic := '0';
  signal this_isEdgeSharing_method_request_field_wdata : std_logic := '0';
  signal sym_raddr_field_wdata_reset : std_logic_vector(8-1 downto 0) := (others => '0');
  signal sym_raddr_field_wdata_reset_strobe : std_logic := '0';
  signal sym_raddr_field_wdata_writer_getSym_method_state : std_logic_vector(8-1 downto 0) := (others => '0');
  signal sym_raddr_field_wdata_writer_strobe_getSym_method_state : std_logic := '0';
  signal sym_raddr_field_rdata : std_logic_vector(8-1 downto 0) := (others => '0');
  signal sym_raddr_field_wdata : std_logic_vector(8-1 downto 0) := (others => '0');
  signal this_input_port_getSym_y : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_notify_notify_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_getSym_x : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_move_y : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_move_x : std_logic_vector(31 downto 0) := (others => '0');
  signal i_setup_2 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_isDuplicated_call_state_counter_isEdgeSharing_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_output_port_isInsideAndEmpty : std_logic := '0';
  signal this_input_port_move_c : std_logic_vector(31 downto 0) := (others => '0');
  signal isValid_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal d_notify_flag : std_logic := '0';
  signal this_decode_call_state_counter_setup_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_init_4 : std_logic_vector(2 downto 0) := (others => '0');
  signal d_move_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_init_3 : std_logic_vector(2 downto 0) := (others => '0');
  signal isDuplicated_if_flag_isDuplicated_6_isDuplicated_2 : std_logic := '0';
  signal v_decode_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_getPattern_1 : std_logic_vector(2 downto 0) := (others => '0');
  signal getSym_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_move_method_request : std_logic := '0';
  signal this_isDuplicated_method_busy : std_logic := '0';
  signal this_isValid_method_request : std_logic := '0';
  signal flag3_isVertexSharing_0 : std_logic := '0';
  signal state_counter_move_move_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_move_move_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal isValid_if_flag_isValid_2_isValid_0 : std_logic := '0';
  signal this_notify_method_busy : std_logic := '0';
  signal state_counter_get_get_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_move_move_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_isDuplicated_10 : std_logic_vector(2 downto 0) := (others => '0');
  signal i_isDuplicated_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal isEdgeSharing_if_flag_isEdgeSharing_2_isEdgeSharing_0 : std_logic := '0';
  signal decode_cond_expr_decode_2_decode_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isInsideAndEmpty_isInsideAndEmpty_8 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isInsideAndEmpty_isInsideAndEmpty_7 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_output_port_isVertexSharing : std_logic := '0';
  signal x_isInsideAndEmpty_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isInsideAndEmpty_isInsideAndEmpty_5 : std_logic_vector(31 downto 0) := (others => '0');
  signal flag3_isEdgeSharing_0 : std_logic := '0';
  signal state_counter_isInsideAndEmpty_isInsideAndEmpty_2 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_isDuplicated_4 : std_logic_vector(2 downto 0) := (others => '0');
  signal state_counter_isInsideAndEmpty_isInsideAndEmpty_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_isDuplicated_3 : std_logic_vector(2 downto 0) := (others => '0');
  signal state_counter_isInsideAndEmpty_isInsideAndEmpty_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_decode_method_busy : std_logic := '0';
  signal this_input_port_isValid_id : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_setup_setup_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_setup_setup_2 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_setup_setup_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal v_setup_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal getPattern_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isInsideAndEmpty_isInsideAndEmpty_11 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_isVertexSharing_call_state_counter_isValid_7 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_isInsideAndEmpty_call_state_counter_isValid_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_move_5 : std_logic_vector(2 downto 0) := (others => '0');
  signal flag1_isVertexSharing_0 : std_logic := '0';
  signal array_index_operation_state_counter_move_2 : std_logic_vector(2 downto 0) := (others => '0');
  signal array_index_operation_state_counter_move_1 : std_logic_vector(2 downto 0) := (others => '0');
  signal state_counter_decode_decode_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_decode_decode_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal notify_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_decode_call_state_counter_move_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_init_method_busy : std_logic := '0';
  signal isInsideAndEmpty_if_flag_isInsideAndEmpty_9_isInsideAndEmpty_5 : std_logic := '0';
  signal this_init_method_request : std_logic := '0';
  signal init_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isDuplicated_isDuplicated_8 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isDuplicated_isDuplicated_7 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isDuplicated_isDuplicated_5 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_setup_6 : std_logic_vector(2 downto 0) := (others => '0');
  signal this_output_port_isEdgeSharing : std_logic := '0';
  signal array_index_operation_state_counter_setup_5 : std_logic_vector(2 downto 0) := (others => '0');
  signal i_init_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isDuplicated_isDuplicated_2 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_setup_4 : std_logic_vector(2 downto 0) := (others => '0');
  signal state_counter_isDuplicated_isDuplicated_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isDuplicated_isDuplicated_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_isEdgeSharing_method_busy : std_logic := '0';
  signal this_setup_method_busy : std_logic := '0';
  signal isDuplicated_if_flag_isDuplicated_9_isDuplicated_7 : std_logic := '0';
  signal array_index_operation_state_counter_setup_1 : std_logic_vector(2 downto 0) := (others => '0');
  signal this_move_method_busy : std_logic := '0';
  signal state_counter_isDuplicated_isDuplicated_11 : std_logic_vector(31 downto 0) := (others => '0');
  signal i_isInsideAndEmpty_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal d_setup_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_move_id : std_logic_vector(31 downto 0) := (others => '0');
  signal flag0_isEdgeSharing_0 : std_logic := '0';
  signal isValid_if_flag_isValid_5_isValid_0 : std_logic := '0';
  signal isInsideAndEmpty_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal isVertexSharing_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isValid_rot : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_get_y : std_logic_vector(31 downto 0) := (others => '0');
  signal v_move_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_get_x : std_logic_vector(31 downto 0) := (others => '0');
  signal this_output_port_isDuplicated : std_logic := '0';
  signal y_isInsideAndEmpty_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getSym_getSym_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_output_port_decode : std_logic_vector(31 downto 0) := (others => '0');
  signal wait_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_isVertexSharing_method_busy : std_logic := '0';
  signal x_isDuplicated_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_move_rot : std_logic_vector(31 downto 0) := (others => '0');
  signal mx_move_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_isInsideAndEmpty_10 : std_logic_vector(2 downto 0) := (others => '0');
  signal i_move_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal get_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isEdgeSharing_isEdgeSharing_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal sym_move_0 : std_logic_vector(7 downto 0) := (others => '0');
  signal state_counter_isEdgeSharing_isEdgeSharing_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isEdgeSharing_isEdgeSharing_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isEdgeSharing_isEdgeSharing_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal isValid_if_flag_isValid_8_isValid_0 : std_logic := '0';
  signal array_index_operation_state_counter_getSym_1 : std_logic_vector(2 downto 0) := (others => '0');
  signal this_isDuplicated_call_state_counter_isVertexSharing_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_getPattern_r : std_logic_vector(31 downto 0) := (others => '0');
  signal flag2_isVertexSharing_0 : std_logic := '0';
  signal this_setup_call_state_counter_isValid_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isValid_y : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_getPattern_k : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isValid_x : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_getPattern_i : std_logic_vector(31 downto 0) := (others => '0');
  signal this_isValid_method_busy : std_logic := '0';
  signal this_isEdgeSharing_call_state_counter_isValid_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal isEdgeSharing_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_isValid_c : std_logic_vector(31 downto 0) := (others => '0');
  signal move_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_get_method_request : std_logic := '0';
  signal flag1_isEdgeSharing_0 : std_logic := '0';
  signal state_counter_isValid_isValid_9 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isValid_isValid_7 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isValid_isValid_6 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isValid_isValid_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isValid_isValid_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isValid_isValid_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isValid_isValid_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getPattern_getPattern_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal isDuplicated_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_getPattern_method_request : std_logic := '0';
  signal flag0_isVertexSharing_0 : std_logic := '0';
  signal state_counter_isVertexSharing_isVertexSharing_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isVertexSharing_isVertexSharing_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_isVertexSharing_isVertexSharing_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_isInsideAndEmpty_4 : std_logic_vector(2 downto 0) := (others => '0');
  signal state_counter_isVertexSharing_isVertexSharing_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal array_index_operation_state_counter_isInsideAndEmpty_3 : std_logic_vector(2 downto 0) := (others => '0');
  signal isInsideAndEmpty_if_flag_isInsideAndEmpty_6_isInsideAndEmpty_2 : std_logic := '0';
  signal this_put_method_busy : std_logic := '0';
  signal this_isInsideAndEmpty_method_busy : std_logic := '0';
  signal put_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal my_move_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal decode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_getSym_method_request : std_logic := '0';
  signal this_notify_method_request : std_logic := '0';
  signal this_getSym_method_busy : std_logic := '0';
  signal array_index_operation_state_counter_put_2 : std_logic_vector(2 downto 0) := (others => '0');
  signal isVertexSharing_if_flag_isVertexSharing_2_isVertexSharing_0 : std_logic := '0';
  signal array_index_operation_state_counter_put_1 : std_logic_vector(2 downto 0) := (others => '0');
  signal this_get_method_busy : std_logic := '0';
  signal state_counter_init_init_2 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_init_init_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_put_put_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_init_init_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal setup_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_wait_wait_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_wait_method_busy : std_logic := '0';
  signal this_getPattern_method_busy : std_logic := '0';
  signal this_put_call_state_counter_move_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal notify_flag : std_logic := '0';
  signal array_index_operation_state_counter_get_1 : std_logic_vector(2 downto 0) := (others => '0');
  signal y_isDuplicated_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal flag2_isEdgeSharing_0 : std_logic := '0';
begin
  U_sym : simpledualportram
  generic map(
    DEPTH => sym_DEPTH,
    WIDTH => sym_WIDTH
  )
  port map(
    clk => clk,
    we => sym_we_field_rdata,
    raddr => sym_raddr_field_rdata,
    rdata => sym_rdata_field_wdata,
    waddr => sym_waddr_field_rdata,
    wdata => sym_wdata_field_rdata
  );
  U_symTable : vhdl_block_pattern_sym_table
  port map(
    clk => clk,
    reset => reset,
    data_raddr => symTable_data_raddr_field_rdata,
    data_rdata => symTable_data_rdata_field_wdata
  );
  U_lenTable : vhdl_block_pattern_length_table
  port map(
    clk => clk,
    reset => reset,
    data_raddr => lenTable_data_raddr_field_rdata,
    data_rdata => lenTable_data_rdata_field_wdata
  );
  U_check_y : simpledualportram
  generic map(
    DEPTH => check_y_DEPTH,
    WIDTH => check_y_WIDTH
  )
  port map(
    clk => clk,
    we => check_y_we_field_rdata,
    raddr => check_y_raddr_field_rdata,
    rdata => check_y_rdata_field_wdata,
    waddr => check_y_waddr_field_rdata,
    wdata => check_y_wdata_field_rdata
  );
  U_table : vhdl_block_pattern_table
  port map(
    clk => clk,
    reset => reset,
    data_raddr => table_data_raddr_field_rdata,
    data_rdata => table_data_rdata_field_wdata
  );
  U_check_x : simpledualportram
  generic map(
    DEPTH => check_x_DEPTH,
    WIDTH => check_x_WIDTH
  )
  port map(
    clk => clk,
    we => check_x_we_field_rdata,
    raddr => check_x_raddr_field_rdata,
    rdata => check_x_rdata_field_wdata,
    waddr => check_x_waddr_field_rdata,
    wdata => check_x_wdata_field_rdata
  );
  U_map : simpledualportram
  generic map(
    DEPTH => map_DEPTH,
    WIDTH => map_WIDTH
  )
  port map(
    clk => clk,
    we => map_we_field_rdata,
    raddr => map_raddr_field_rdata,
    rdata => map_rdata_field_wdata,
    waddr => map_waddr_field_rdata,
    wdata => map_wdata_field_rdata
  );
  this_notify_method_request <= notify_method_request;
  notify_method_busy <= this_notify_method_busy;
  this_init_method_request <= init_method_request;
  init_method_busy <= this_init_method_busy;
  this_input_port_get_x <= conv_std_logic_vector(conv_integer(input_port_get_x), this_input_port_get_x'length);
  this_input_port_get_y <= conv_std_logic_vector(conv_integer(input_port_get_y), this_input_port_get_y'length);
  this_get_method_request <= get_method_request;
  get_method_busy <= this_get_method_busy;
  this_input_port_getSym_x <= conv_std_logic_vector(conv_integer(input_port_getSym_x), this_input_port_getSym_x'length);
  this_input_port_getSym_y <= conv_std_logic_vector(conv_integer(input_port_getSym_y), this_input_port_getSym_y'length);
  this_getSym_method_request <= getSym_method_request;
  getSym_method_busy <= this_getSym_method_busy;
  this_input_port_isValid_x <= conv_std_logic_vector(conv_integer(input_port_isValid_x), this_input_port_isValid_x'length);
  this_input_port_isValid_y <= conv_std_logic_vector(conv_integer(input_port_isValid_y), this_input_port_isValid_y'length);
  this_input_port_isValid_c <= conv_std_logic_vector(conv_integer(input_port_isValid_c), this_input_port_isValid_c'length);
  this_input_port_isValid_id <= conv_std_logic_vector(conv_integer(input_port_isValid_id), this_input_port_isValid_id'length);
  this_input_port_isValid_rot <= conv_std_logic_vector(conv_integer(input_port_isValid_rot), this_input_port_isValid_rot'length);
  this_isValid_method_request <= isValid_method_request;
  isValid_method_busy <= this_isValid_method_busy;
  this_input_port_move_x <= conv_std_logic_vector(conv_integer(input_port_move_x), this_input_port_move_x'length);
  this_input_port_move_y <= conv_std_logic_vector(conv_integer(input_port_move_y), this_input_port_move_y'length);
  this_input_port_move_c <= conv_std_logic_vector(conv_integer(input_port_move_c), this_input_port_move_c'length);
  this_input_port_move_id <= conv_std_logic_vector(conv_integer(input_port_move_id), this_input_port_move_id'length);
  this_input_port_move_rot <= conv_std_logic_vector(conv_integer(input_port_move_rot), this_input_port_move_rot'length);
  this_move_method_request <= move_method_request;
  move_method_busy <= this_move_method_busy;
  this_input_port_getPattern_k <= conv_std_logic_vector(conv_integer(input_port_getPattern_k), this_input_port_getPattern_k'length);
  this_input_port_getPattern_r <= conv_std_logic_vector(conv_integer(input_port_getPattern_r), this_input_port_getPattern_r'length);
  this_input_port_getPattern_i <= conv_std_logic_vector(conv_integer(input_port_getPattern_i), this_input_port_getPattern_i'length);
  this_getPattern_method_request <= getPattern_method_request;
  getPattern_method_busy <= this_getPattern_method_busy;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_y_we_field_wdata <= check_y_we_field_wdata_reset;
      elsif (check_y_we_field_wdata_reset_strobe = '1') then
        check_y_we_field_wdata <= check_y_we_field_wdata_reset;
      elsif (check_y_we_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') then
        check_y_we_field_wdata <= check_y_we_field_wdata_writer_state_counter_setup_setup_3;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_y_we_field_wdata_reset_strobe <= '1';
      else
        check_y_we_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_setup_setup_3) = 8) then
        check_y_we_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '1';
      else
        check_y_we_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '0';
      end if;
    end if;
  end process;
  check_y_we_field_rdata <= check_y_we_field_wdata_reset when (reset = '1') else
        check_y_we_field_wdata_reset when (check_y_we_field_wdata_reset_strobe = '1') else
        check_y_we_field_wdata_writer_state_counter_setup_setup_3 when (check_y_we_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') else
        check_y_we_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        symTable_data_raddr_field_wdata <= symTable_data_raddr_field_wdata_reset;
      elsif (symTable_data_raddr_field_wdata_reset_strobe = '1') then
        symTable_data_raddr_field_wdata <= symTable_data_raddr_field_wdata_reset;
      elsif (symTable_data_raddr_field_wdata_writer_strobe_move_method_state = '1') then
        symTable_data_raddr_field_wdata <= symTable_data_raddr_field_wdata_writer_move_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        symTable_data_raddr_field_wdata_reset_strobe <= '1';
      else
        symTable_data_raddr_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(move_method_state) = 4) then
        symTable_data_raddr_field_wdata_writer_strobe_move_method_state <= '1';
      else
        symTable_data_raddr_field_wdata_writer_strobe_move_method_state <= '0';
      end if;
    end if;
  end process;
  symTable_data_raddr_field_rdata <= symTable_data_raddr_field_wdata_reset when (reset = '1') else
        symTable_data_raddr_field_wdata_reset when (symTable_data_raddr_field_wdata_reset_strobe = '1') else
        symTable_data_raddr_field_wdata_writer_move_method_state when (symTable_data_raddr_field_wdata_writer_strobe_move_method_state = '1') else
        symTable_data_raddr_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        lenTable_data_raddr_field_wdata <= lenTable_data_raddr_field_wdata_reset;
      elsif (lenTable_data_raddr_field_wdata_reset_strobe = '1') then
        lenTable_data_raddr_field_wdata <= lenTable_data_raddr_field_wdata_reset;
      elsif (lenTable_data_raddr_field_wdata_writer_strobe_move_method_state = '1') then
        lenTable_data_raddr_field_wdata <= lenTable_data_raddr_field_wdata_writer_move_method_state;
      elsif (lenTable_data_raddr_field_wdata_writer_strobe_setup_method_state = '1') then
        lenTable_data_raddr_field_wdata <= lenTable_data_raddr_field_wdata_writer_setup_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        lenTable_data_raddr_field_wdata_reset_strobe <= '1';
      else
        lenTable_data_raddr_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(move_method_state) = 2) then
        lenTable_data_raddr_field_wdata_writer_strobe_move_method_state <= '1';
      else
        lenTable_data_raddr_field_wdata_writer_strobe_move_method_state <= '0';
      end if;
      if (conv_integer(setup_method_state) = 2) then
        lenTable_data_raddr_field_wdata_writer_strobe_setup_method_state <= '1';
      else
        lenTable_data_raddr_field_wdata_writer_strobe_setup_method_state <= '0';
      end if;
    end if;
  end process;
  lenTable_data_raddr_field_rdata <= lenTable_data_raddr_field_wdata_reset when (reset = '1') else
        lenTable_data_raddr_field_wdata_reset when (lenTable_data_raddr_field_wdata_reset_strobe = '1') else
        lenTable_data_raddr_field_wdata_writer_move_method_state when (lenTable_data_raddr_field_wdata_writer_strobe_move_method_state = '1') else
        lenTable_data_raddr_field_wdata_writer_setup_method_state when (lenTable_data_raddr_field_wdata_writer_strobe_setup_method_state = '1') else
        lenTable_data_raddr_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_isInsideAndEmpty_method_request_field_wdata <= this_isInsideAndEmpty_method_request_field_wdata_reset;
      elsif (this_isInsideAndEmpty_method_request_field_wdata_reset_strobe = '1') then
        this_isInsideAndEmpty_method_request_field_wdata <= this_isInsideAndEmpty_method_request_field_wdata_reset;
      elsif (this_isInsideAndEmpty_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_1 = '1') then
        this_isInsideAndEmpty_method_request_field_wdata <= this_isInsideAndEmpty_method_request_field_wdata_writer_state_counter_isValid_isValid_1;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_isInsideAndEmpty_method_request_field_wdata_reset_strobe <= '1';
      else
        this_isInsideAndEmpty_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_isValid_isValid_1) = 1 or conv_integer(state_counter_isValid_isValid_1) = 1) then
        this_isInsideAndEmpty_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_1 <= '1';
      else
        this_isInsideAndEmpty_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_1 <= '0';
      end if;
    end if;
  end process;
  this_isInsideAndEmpty_method_request_field_rdata <= this_isInsideAndEmpty_method_request_field_wdata_reset when (reset = '1') else
        this_isInsideAndEmpty_method_request_field_wdata_reset when (this_isInsideAndEmpty_method_request_field_wdata_reset_strobe = '1') else
        this_isInsideAndEmpty_method_request_field_wdata_writer_state_counter_isValid_isValid_1 when (this_isInsideAndEmpty_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_1 = '1') else
        this_isInsideAndEmpty_method_request_field_wdata;
  
  map_rdata_field_rdata <= map_rdata_field_wdata;
  
  table_data_rdata_field_rdata <= table_data_rdata_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        sym_we_field_wdata <= sym_we_field_wdata_reset;
      elsif (sym_we_field_wdata_reset_strobe = '1') then
        sym_we_field_wdata <= sym_we_field_wdata_reset;
      elsif (sym_we_field_wdata_writer_strobe_state_counter_init_init_2 = '1') then
        sym_we_field_wdata <= sym_we_field_wdata_writer_state_counter_init_init_2;
      elsif (sym_we_field_wdata_writer_strobe_put_method_state = '1') then
        sym_we_field_wdata <= sym_we_field_wdata_writer_put_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        sym_we_field_wdata_reset_strobe <= '1';
      else
        sym_we_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_init_init_2) = 2) then
        sym_we_field_wdata_writer_strobe_state_counter_init_init_2 <= '1';
      else
        sym_we_field_wdata_writer_strobe_state_counter_init_init_2 <= '0';
      end if;
      if (conv_integer(put_method_state) = 3) then
        sym_we_field_wdata_writer_strobe_put_method_state <= '1';
      else
        sym_we_field_wdata_writer_strobe_put_method_state <= '0';
      end if;
    end if;
  end process;
  sym_we_field_rdata <= sym_we_field_wdata_reset when (reset = '1') else
        sym_we_field_wdata_reset when (sym_we_field_wdata_reset_strobe = '1') else
        sym_we_field_wdata_writer_state_counter_init_init_2 when (sym_we_field_wdata_writer_strobe_state_counter_init_init_2 = '1') else
        sym_we_field_wdata_writer_put_method_state when (sym_we_field_wdata_writer_strobe_put_method_state = '1') else
        sym_we_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        sym_wdata_field_wdata <= sym_wdata_field_wdata_reset;
      elsif (sym_wdata_field_wdata_reset_strobe = '1') then
        sym_wdata_field_wdata <= sym_wdata_field_wdata_reset;
      elsif (sym_wdata_field_wdata_writer_strobe_put_method_state = '1') then
        sym_wdata_field_wdata <= sym_wdata_field_wdata_writer_put_method_state;
      elsif (sym_wdata_field_wdata_writer_strobe_state_counter_init_init_2 = '1') then
        sym_wdata_field_wdata <= sym_wdata_field_wdata_writer_state_counter_init_init_2;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        sym_wdata_field_wdata_reset_strobe <= '1';
      else
        sym_wdata_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(put_method_state) = 3) then
        sym_wdata_field_wdata_writer_strobe_put_method_state <= '1';
      else
        sym_wdata_field_wdata_writer_strobe_put_method_state <= '0';
      end if;
      if (conv_integer(state_counter_init_init_2) = 2) then
        sym_wdata_field_wdata_writer_strobe_state_counter_init_init_2 <= '1';
      else
        sym_wdata_field_wdata_writer_strobe_state_counter_init_init_2 <= '0';
      end if;
    end if;
  end process;
  sym_wdata_field_rdata <= sym_wdata_field_wdata_reset when (reset = '1') else
        sym_wdata_field_wdata_reset when (sym_wdata_field_wdata_reset_strobe = '1') else
        sym_wdata_field_wdata_writer_put_method_state when (sym_wdata_field_wdata_writer_strobe_put_method_state = '1') else
        sym_wdata_field_wdata_writer_state_counter_init_init_2 when (sym_wdata_field_wdata_writer_strobe_state_counter_init_init_2 = '1') else
        sym_wdata_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_isVertexSharing_method_request_field_wdata <= this_isVertexSharing_method_request_field_wdata_reset;
      elsif (this_isVertexSharing_method_request_field_wdata_reset_strobe = '1') then
        this_isVertexSharing_method_request_field_wdata <= this_isVertexSharing_method_request_field_wdata_reset;
      elsif (this_isVertexSharing_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_7 = '1') then
        this_isVertexSharing_method_request_field_wdata <= this_isVertexSharing_method_request_field_wdata_writer_state_counter_isValid_isValid_7;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_isVertexSharing_method_request_field_wdata_reset_strobe <= '1';
      else
        this_isVertexSharing_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_isValid_isValid_7) = 1 or conv_integer(state_counter_isValid_isValid_7) = 1) then
        this_isVertexSharing_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_7 <= '1';
      else
        this_isVertexSharing_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_7 <= '0';
      end if;
    end if;
  end process;
  this_isVertexSharing_method_request_field_rdata <= this_isVertexSharing_method_request_field_wdata_reset when (reset = '1') else
        this_isVertexSharing_method_request_field_wdata_reset when (this_isVertexSharing_method_request_field_wdata_reset_strobe = '1') else
        this_isVertexSharing_method_request_field_wdata_writer_state_counter_isValid_isValid_7 when (this_isVertexSharing_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_7 = '1') else
        this_isVertexSharing_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        map_waddr_field_wdata <= map_waddr_field_wdata_reset;
      elsif (map_waddr_field_wdata_reset_strobe = '1') then
        map_waddr_field_wdata <= map_waddr_field_wdata_reset;
      elsif (map_waddr_field_wdata_writer_strobe_state_counter_init_init_2 = '1') then
        map_waddr_field_wdata <= map_waddr_field_wdata_writer_state_counter_init_init_2;
      elsif (map_waddr_field_wdata_writer_strobe_put_method_state = '1') then
        map_waddr_field_wdata <= map_waddr_field_wdata_writer_put_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        map_waddr_field_wdata_reset_strobe <= '1';
      else
        map_waddr_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_init_init_2) = 1) then
        map_waddr_field_wdata_writer_strobe_state_counter_init_init_2 <= '1';
      else
        map_waddr_field_wdata_writer_strobe_state_counter_init_init_2 <= '0';
      end if;
      if (conv_integer(put_method_state) = 2) then
        map_waddr_field_wdata_writer_strobe_put_method_state <= '1';
      else
        map_waddr_field_wdata_writer_strobe_put_method_state <= '0';
      end if;
    end if;
  end process;
  map_waddr_field_rdata <= map_waddr_field_wdata_reset when (reset = '1') else
        map_waddr_field_wdata_reset when (map_waddr_field_wdata_reset_strobe = '1') else
        map_waddr_field_wdata_writer_state_counter_init_init_2 when (map_waddr_field_wdata_writer_strobe_state_counter_init_init_2 = '1') else
        map_waddr_field_wdata_writer_put_method_state when (map_waddr_field_wdata_writer_strobe_put_method_state = '1') else
        map_waddr_field_wdata;
  
  check_y_rdata_field_rdata <= check_y_rdata_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_wait_method_request_field_wdata <= this_wait_method_request_field_wdata_reset;
      elsif (this_wait_method_request_field_wdata_reset_strobe = '1') then
        this_wait_method_request_field_wdata <= this_wait_method_request_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_wait_method_request_field_wdata_reset_strobe <= '1';
      else
        this_wait_method_request_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  this_wait_method_request_field_rdata <= this_wait_method_request_field_wdata_reset when (reset = '1') else
        this_wait_method_request_field_wdata_reset when (this_wait_method_request_field_wdata_reset_strobe = '1') else
        this_wait_method_request_field_wdata;
  
  check_x_rdata_field_rdata <= check_x_rdata_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_isDuplicated_c_field_wdata <= this_input_port_isDuplicated_c_field_wdata_reset;
      elsif (this_input_port_isDuplicated_c_field_wdata_reset_strobe = '1') then
        this_input_port_isDuplicated_c_field_wdata <= this_input_port_isDuplicated_c_field_wdata_reset;
      elsif (this_input_port_isDuplicated_c_field_wdata_writer_strobe_isEdgeSharing_method_state = '1') then
        this_input_port_isDuplicated_c_field_wdata <= this_input_port_isDuplicated_c_field_wdata_writer_isEdgeSharing_method_state;
      elsif (this_input_port_isDuplicated_c_field_wdata_writer_strobe_isVertexSharing_method_state = '1') then
        this_input_port_isDuplicated_c_field_wdata <= this_input_port_isDuplicated_c_field_wdata_writer_isVertexSharing_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_isDuplicated_c_field_wdata_reset_strobe <= '1';
      else
        this_input_port_isDuplicated_c_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(isEdgeSharing_method_state) = 2 or conv_integer(isEdgeSharing_method_state) = 4 or conv_integer(isEdgeSharing_method_state) = 6 or conv_integer(isEdgeSharing_method_state) = 8) then
        this_input_port_isDuplicated_c_field_wdata_writer_strobe_isEdgeSharing_method_state <= '1';
      else
        this_input_port_isDuplicated_c_field_wdata_writer_strobe_isEdgeSharing_method_state <= '0';
      end if;
      if (conv_integer(isVertexSharing_method_state) = 2 or conv_integer(isVertexSharing_method_state) = 4 or conv_integer(isVertexSharing_method_state) = 6 or conv_integer(isVertexSharing_method_state) = 8) then
        this_input_port_isDuplicated_c_field_wdata_writer_strobe_isVertexSharing_method_state <= '1';
      else
        this_input_port_isDuplicated_c_field_wdata_writer_strobe_isVertexSharing_method_state <= '0';
      end if;
    end if;
  end process;
  this_input_port_isDuplicated_c_field_rdata <= this_input_port_isDuplicated_c_field_wdata_reset when (reset = '1') else
        this_input_port_isDuplicated_c_field_wdata_reset when (this_input_port_isDuplicated_c_field_wdata_reset_strobe = '1') else
        this_input_port_isDuplicated_c_field_wdata_writer_isEdgeSharing_method_state when (this_input_port_isDuplicated_c_field_wdata_writer_strobe_isEdgeSharing_method_state = '1') else
        this_input_port_isDuplicated_c_field_wdata_writer_isVertexSharing_method_state when (this_input_port_isDuplicated_c_field_wdata_writer_strobe_isVertexSharing_method_state = '1') else
        this_input_port_isDuplicated_c_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_y_waddr_field_wdata <= check_y_waddr_field_wdata_reset;
      elsif (check_y_waddr_field_wdata_reset_strobe = '1') then
        check_y_waddr_field_wdata <= check_y_waddr_field_wdata_reset;
      elsif (check_y_waddr_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') then
        check_y_waddr_field_wdata <= check_y_waddr_field_wdata_writer_state_counter_setup_setup_3;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_y_waddr_field_wdata_reset_strobe <= '1';
      else
        check_y_waddr_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_setup_setup_3) = 8) then
        check_y_waddr_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '1';
      else
        check_y_waddr_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '0';
      end if;
    end if;
  end process;
  check_y_waddr_field_rdata <= check_y_waddr_field_wdata_reset when (reset = '1') else
        check_y_waddr_field_wdata_reset when (check_y_waddr_field_wdata_reset_strobe = '1') else
        check_y_waddr_field_wdata_writer_state_counter_setup_setup_3 when (check_y_waddr_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') else
        check_y_waddr_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_x_waddr_field_wdata <= check_x_waddr_field_wdata_reset;
      elsif (check_x_waddr_field_wdata_reset_strobe = '1') then
        check_x_waddr_field_wdata <= check_x_waddr_field_wdata_reset;
      elsif (check_x_waddr_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') then
        check_x_waddr_field_wdata <= check_x_waddr_field_wdata_writer_state_counter_setup_setup_3;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_x_waddr_field_wdata_reset_strobe <= '1';
      else
        check_x_waddr_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_setup_setup_3) = 5) then
        check_x_waddr_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '1';
      else
        check_x_waddr_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '0';
      end if;
    end if;
  end process;
  check_x_waddr_field_rdata <= check_x_waddr_field_wdata_reset when (reset = '1') else
        check_x_waddr_field_wdata_reset when (check_x_waddr_field_wdata_reset_strobe = '1') else
        check_x_waddr_field_wdata_writer_state_counter_setup_setup_3 when (check_x_waddr_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') else
        check_x_waddr_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_setup_method_request_field_wdata <= this_setup_method_request_field_wdata_reset;
      elsif (this_setup_method_request_field_wdata_reset_strobe = '1') then
        this_setup_method_request_field_wdata <= this_setup_method_request_field_wdata_reset;
      elsif (this_setup_method_request_field_wdata_writer_strobe_isValid_method_state = '1') then
        this_setup_method_request_field_wdata <= this_setup_method_request_field_wdata_writer_isValid_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_setup_method_request_field_wdata_reset_strobe <= '1';
      else
        this_setup_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(isValid_method_state) = 2 or conv_integer(isValid_method_state) = 2) then
        this_setup_method_request_field_wdata_writer_strobe_isValid_method_state <= '1';
      else
        this_setup_method_request_field_wdata_writer_strobe_isValid_method_state <= '0';
      end if;
    end if;
  end process;
  this_setup_method_request_field_rdata <= this_setup_method_request_field_wdata_reset when (reset = '1') else
        this_setup_method_request_field_wdata_reset when (this_setup_method_request_field_wdata_reset_strobe = '1') else
        this_setup_method_request_field_wdata_writer_isValid_method_state when (this_setup_method_request_field_wdata_writer_strobe_isValid_method_state = '1') else
        this_setup_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_isVertexSharing_c_field_wdata <= this_input_port_isVertexSharing_c_field_wdata_reset;
      elsif (this_input_port_isVertexSharing_c_field_wdata_reset_strobe = '1') then
        this_input_port_isVertexSharing_c_field_wdata <= this_input_port_isVertexSharing_c_field_wdata_reset;
      elsif (this_input_port_isVertexSharing_c_field_wdata_writer_strobe_state_counter_isValid_isValid_7 = '1') then
        this_input_port_isVertexSharing_c_field_wdata <= this_input_port_isVertexSharing_c_field_wdata_writer_state_counter_isValid_isValid_7;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_isVertexSharing_c_field_wdata_reset_strobe <= '1';
      else
        this_input_port_isVertexSharing_c_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_isValid_isValid_7) = 1) then
        this_input_port_isVertexSharing_c_field_wdata_writer_strobe_state_counter_isValid_isValid_7 <= '1';
      else
        this_input_port_isVertexSharing_c_field_wdata_writer_strobe_state_counter_isValid_isValid_7 <= '0';
      end if;
    end if;
  end process;
  this_input_port_isVertexSharing_c_field_rdata <= this_input_port_isVertexSharing_c_field_wdata_reset when (reset = '1') else
        this_input_port_isVertexSharing_c_field_wdata_reset when (this_input_port_isVertexSharing_c_field_wdata_reset_strobe = '1') else
        this_input_port_isVertexSharing_c_field_wdata_writer_state_counter_isValid_isValid_7 when (this_input_port_isVertexSharing_c_field_wdata_writer_strobe_state_counter_isValid_isValid_7 = '1') else
        this_input_port_isVertexSharing_c_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_setup_y_field_wdata <= this_input_port_setup_y_field_wdata_reset;
      elsif (this_input_port_setup_y_field_wdata_reset_strobe = '1') then
        this_input_port_setup_y_field_wdata <= this_input_port_setup_y_field_wdata_reset;
      elsif (this_input_port_setup_y_field_wdata_writer_strobe_isValid_method_state = '1') then
        this_input_port_setup_y_field_wdata <= this_input_port_setup_y_field_wdata_writer_isValid_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_setup_y_field_wdata_reset_strobe <= '1';
      else
        this_input_port_setup_y_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(isValid_method_state) = 2) then
        this_input_port_setup_y_field_wdata_writer_strobe_isValid_method_state <= '1';
      else
        this_input_port_setup_y_field_wdata_writer_strobe_isValid_method_state <= '0';
      end if;
    end if;
  end process;
  this_input_port_setup_y_field_rdata <= this_input_port_setup_y_field_wdata_reset when (reset = '1') else
        this_input_port_setup_y_field_wdata_reset when (this_input_port_setup_y_field_wdata_reset_strobe = '1') else
        this_input_port_setup_y_field_wdata_writer_isValid_method_state when (this_input_port_setup_y_field_wdata_writer_strobe_isValid_method_state = '1') else
        this_input_port_setup_y_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_isDuplicated_method_request_field_wdata <= this_isDuplicated_method_request_field_wdata_reset;
      elsif (this_isDuplicated_method_request_field_wdata_reset_strobe = '1') then
        this_isDuplicated_method_request_field_wdata <= this_isDuplicated_method_request_field_wdata_reset;
      elsif (this_isDuplicated_method_request_field_wdata_writer_strobe_isEdgeSharing_method_state = '1') then
        this_isDuplicated_method_request_field_wdata <= this_isDuplicated_method_request_field_wdata_writer_isEdgeSharing_method_state;
      elsif (this_isDuplicated_method_request_field_wdata_writer_strobe_isVertexSharing_method_state = '1') then
        this_isDuplicated_method_request_field_wdata <= this_isDuplicated_method_request_field_wdata_writer_isVertexSharing_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_isDuplicated_method_request_field_wdata_reset_strobe <= '1';
      else
        this_isDuplicated_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(isEdgeSharing_method_state) = 2 or conv_integer(isEdgeSharing_method_state) = 2 or conv_integer(isEdgeSharing_method_state) = 4 or conv_integer(isEdgeSharing_method_state) = 4 or conv_integer(isEdgeSharing_method_state) = 6 or conv_integer(isEdgeSharing_method_state) = 6 or conv_integer(isEdgeSharing_method_state) = 8 or conv_integer(isEdgeSharing_method_state) = 8) then
        this_isDuplicated_method_request_field_wdata_writer_strobe_isEdgeSharing_method_state <= '1';
      else
        this_isDuplicated_method_request_field_wdata_writer_strobe_isEdgeSharing_method_state <= '0';
      end if;
      if (conv_integer(isVertexSharing_method_state) = 2 or conv_integer(isVertexSharing_method_state) = 2 or conv_integer(isVertexSharing_method_state) = 4 or conv_integer(isVertexSharing_method_state) = 4 or conv_integer(isVertexSharing_method_state) = 6 or conv_integer(isVertexSharing_method_state) = 6 or conv_integer(isVertexSharing_method_state) = 8 or conv_integer(isVertexSharing_method_state) = 8) then
        this_isDuplicated_method_request_field_wdata_writer_strobe_isVertexSharing_method_state <= '1';
      else
        this_isDuplicated_method_request_field_wdata_writer_strobe_isVertexSharing_method_state <= '0';
      end if;
    end if;
  end process;
  this_isDuplicated_method_request_field_rdata <= this_isDuplicated_method_request_field_wdata_reset when (reset = '1') else
        this_isDuplicated_method_request_field_wdata_reset when (this_isDuplicated_method_request_field_wdata_reset_strobe = '1') else
        this_isDuplicated_method_request_field_wdata_writer_isEdgeSharing_method_state when (this_isDuplicated_method_request_field_wdata_writer_strobe_isEdgeSharing_method_state = '1') else
        this_isDuplicated_method_request_field_wdata_writer_isVertexSharing_method_state when (this_isDuplicated_method_request_field_wdata_writer_strobe_isVertexSharing_method_state = '1') else
        this_isDuplicated_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_setup_x_field_wdata <= this_input_port_setup_x_field_wdata_reset;
      elsif (this_input_port_setup_x_field_wdata_reset_strobe = '1') then
        this_input_port_setup_x_field_wdata <= this_input_port_setup_x_field_wdata_reset;
      elsif (this_input_port_setup_x_field_wdata_writer_strobe_isValid_method_state = '1') then
        this_input_port_setup_x_field_wdata <= this_input_port_setup_x_field_wdata_writer_isValid_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_setup_x_field_wdata_reset_strobe <= '1';
      else
        this_input_port_setup_x_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(isValid_method_state) = 2) then
        this_input_port_setup_x_field_wdata_writer_strobe_isValid_method_state <= '1';
      else
        this_input_port_setup_x_field_wdata_writer_strobe_isValid_method_state <= '0';
      end if;
    end if;
  end process;
  this_input_port_setup_x_field_rdata <= this_input_port_setup_x_field_wdata_reset when (reset = '1') else
        this_input_port_setup_x_field_wdata_reset when (this_input_port_setup_x_field_wdata_reset_strobe = '1') else
        this_input_port_setup_x_field_wdata_writer_isValid_method_state when (this_input_port_setup_x_field_wdata_writer_strobe_isValid_method_state = '1') else
        this_input_port_setup_x_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_setup_id_field_wdata <= this_input_port_setup_id_field_wdata_reset;
      elsif (this_input_port_setup_id_field_wdata_reset_strobe = '1') then
        this_input_port_setup_id_field_wdata <= this_input_port_setup_id_field_wdata_reset;
      elsif (this_input_port_setup_id_field_wdata_writer_strobe_isValid_method_state = '1') then
        this_input_port_setup_id_field_wdata <= this_input_port_setup_id_field_wdata_writer_isValid_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_setup_id_field_wdata_reset_strobe <= '1';
      else
        this_input_port_setup_id_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(isValid_method_state) = 2) then
        this_input_port_setup_id_field_wdata_writer_strobe_isValid_method_state <= '1';
      else
        this_input_port_setup_id_field_wdata_writer_strobe_isValid_method_state <= '0';
      end if;
    end if;
  end process;
  this_input_port_setup_id_field_rdata <= this_input_port_setup_id_field_wdata_reset when (reset = '1') else
        this_input_port_setup_id_field_wdata_reset when (this_input_port_setup_id_field_wdata_reset_strobe = '1') else
        this_input_port_setup_id_field_wdata_writer_isValid_method_state when (this_input_port_setup_id_field_wdata_writer_strobe_isValid_method_state = '1') else
        this_input_port_setup_id_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_put_y_field_wdata <= this_input_port_put_y_field_wdata_reset;
      elsif (this_input_port_put_y_field_wdata_reset_strobe = '1') then
        this_input_port_put_y_field_wdata <= this_input_port_put_y_field_wdata_reset;
      elsif (this_input_port_put_y_field_wdata_writer_strobe_state_counter_move_move_4 = '1') then
        this_input_port_put_y_field_wdata <= this_input_port_put_y_field_wdata_writer_state_counter_move_move_4;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_put_y_field_wdata_reset_strobe <= '1';
      else
        this_input_port_put_y_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_move_move_4) = 9) then
        this_input_port_put_y_field_wdata_writer_strobe_state_counter_move_move_4 <= '1';
      else
        this_input_port_put_y_field_wdata_writer_strobe_state_counter_move_move_4 <= '0';
      end if;
    end if;
  end process;
  this_input_port_put_y_field_rdata <= this_input_port_put_y_field_wdata_reset when (reset = '1') else
        this_input_port_put_y_field_wdata_reset when (this_input_port_put_y_field_wdata_reset_strobe = '1') else
        this_input_port_put_y_field_wdata_writer_state_counter_move_move_4 when (this_input_port_put_y_field_wdata_writer_strobe_state_counter_move_move_4 = '1') else
        this_input_port_put_y_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_put_x_field_wdata <= this_input_port_put_x_field_wdata_reset;
      elsif (this_input_port_put_x_field_wdata_reset_strobe = '1') then
        this_input_port_put_x_field_wdata <= this_input_port_put_x_field_wdata_reset;
      elsif (this_input_port_put_x_field_wdata_writer_strobe_state_counter_move_move_4 = '1') then
        this_input_port_put_x_field_wdata <= this_input_port_put_x_field_wdata_writer_state_counter_move_move_4;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_put_x_field_wdata_reset_strobe <= '1';
      else
        this_input_port_put_x_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_move_move_4) = 9) then
        this_input_port_put_x_field_wdata_writer_strobe_state_counter_move_move_4 <= '1';
      else
        this_input_port_put_x_field_wdata_writer_strobe_state_counter_move_move_4 <= '0';
      end if;
    end if;
  end process;
  this_input_port_put_x_field_rdata <= this_input_port_put_x_field_wdata_reset when (reset = '1') else
        this_input_port_put_x_field_wdata_reset when (this_input_port_put_x_field_wdata_reset_strobe = '1') else
        this_input_port_put_x_field_wdata_writer_state_counter_move_move_4 when (this_input_port_put_x_field_wdata_writer_strobe_state_counter_move_move_4 = '1') else
        this_input_port_put_x_field_wdata;
  
  sym_rdata_field_rdata <= sym_rdata_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_put_s_field_wdata <= this_input_port_put_s_field_wdata_reset;
      elsif (this_input_port_put_s_field_wdata_reset_strobe = '1') then
        this_input_port_put_s_field_wdata <= this_input_port_put_s_field_wdata_reset;
      elsif (this_input_port_put_s_field_wdata_writer_strobe_state_counter_move_move_4 = '1') then
        this_input_port_put_s_field_wdata <= this_input_port_put_s_field_wdata_writer_state_counter_move_move_4;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_put_s_field_wdata_reset_strobe <= '1';
      else
        this_input_port_put_s_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_move_move_4) = 9) then
        this_input_port_put_s_field_wdata_writer_strobe_state_counter_move_move_4 <= '1';
      else
        this_input_port_put_s_field_wdata_writer_strobe_state_counter_move_move_4 <= '0';
      end if;
    end if;
  end process;
  this_input_port_put_s_field_rdata <= this_input_port_put_s_field_wdata_reset when (reset = '1') else
        this_input_port_put_s_field_wdata_reset when (this_input_port_put_s_field_wdata_reset_strobe = '1') else
        this_input_port_put_s_field_wdata_writer_state_counter_move_move_4 when (this_input_port_put_s_field_wdata_writer_strobe_state_counter_move_move_4 = '1') else
        this_input_port_put_s_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        map_raddr_field_wdata <= map_raddr_field_wdata_reset;
      elsif (map_raddr_field_wdata_reset_strobe = '1') then
        map_raddr_field_wdata <= map_raddr_field_wdata_reset;
      elsif (map_raddr_field_wdata_writer_strobe_get_method_state = '1') then
        map_raddr_field_wdata <= map_raddr_field_wdata_writer_get_method_state;
      elsif (map_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_8 = '1') then
        map_raddr_field_wdata <= map_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_8;
      elsif (map_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_8 = '1') then
        map_raddr_field_wdata <= map_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_8;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        map_raddr_field_wdata_reset_strobe <= '1';
      else
        map_raddr_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(get_method_state) = 2) then
        map_raddr_field_wdata_writer_strobe_get_method_state <= '1';
      else
        map_raddr_field_wdata_writer_strobe_get_method_state <= '0';
      end if;
      if (conv_integer(state_counter_isInsideAndEmpty_isInsideAndEmpty_8) = 1) then
        map_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= '1';
      else
        map_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= '0';
      end if;
      if (conv_integer(state_counter_isDuplicated_isDuplicated_8) = 1) then
        map_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_8 <= '1';
      else
        map_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_8 <= '0';
      end if;
    end if;
  end process;
  map_raddr_field_rdata <= map_raddr_field_wdata_reset when (reset = '1') else
        map_raddr_field_wdata_reset when (map_raddr_field_wdata_reset_strobe = '1') else
        map_raddr_field_wdata_writer_get_method_state when (map_raddr_field_wdata_writer_strobe_get_method_state = '1') else
        map_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_8 when (map_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_8 = '1') else
        map_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_8 when (map_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_8 = '1') else
        map_raddr_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        table_data_raddr_field_wdata <= table_data_raddr_field_wdata_reset;
      elsif (table_data_raddr_field_wdata_reset_strobe = '1') then
        table_data_raddr_field_wdata <= table_data_raddr_field_wdata_reset;
      elsif (table_data_raddr_field_wdata_writer_strobe_state_counter_move_move_4 = '1') then
        table_data_raddr_field_wdata <= table_data_raddr_field_wdata_writer_state_counter_move_move_4;
      elsif (table_data_raddr_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') then
        table_data_raddr_field_wdata <= table_data_raddr_field_wdata_writer_state_counter_setup_setup_3;
      elsif (table_data_raddr_field_wdata_writer_strobe_getPattern_method_state = '1') then
        table_data_raddr_field_wdata <= table_data_raddr_field_wdata_writer_getPattern_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        table_data_raddr_field_wdata_reset_strobe <= '1';
      else
        table_data_raddr_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_move_move_4) = 1) then
        table_data_raddr_field_wdata_writer_strobe_state_counter_move_move_4 <= '1';
      else
        table_data_raddr_field_wdata_writer_strobe_state_counter_move_move_4 <= '0';
      end if;
      if (conv_integer(state_counter_setup_setup_3) = 1) then
        table_data_raddr_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '1';
      else
        table_data_raddr_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '0';
      end if;
      if (conv_integer(getPattern_method_state) = 2) then
        table_data_raddr_field_wdata_writer_strobe_getPattern_method_state <= '1';
      else
        table_data_raddr_field_wdata_writer_strobe_getPattern_method_state <= '0';
      end if;
    end if;
  end process;
  table_data_raddr_field_rdata <= table_data_raddr_field_wdata_reset when (reset = '1') else
        table_data_raddr_field_wdata_reset when (table_data_raddr_field_wdata_reset_strobe = '1') else
        table_data_raddr_field_wdata_writer_state_counter_move_move_4 when (table_data_raddr_field_wdata_writer_strobe_state_counter_move_move_4 = '1') else
        table_data_raddr_field_wdata_writer_state_counter_setup_setup_3 when (table_data_raddr_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') else
        table_data_raddr_field_wdata_writer_getPattern_method_state when (table_data_raddr_field_wdata_writer_strobe_getPattern_method_state = '1') else
        table_data_raddr_field_wdata;
  
  lenTable_data_rdata_field_rdata <= lenTable_data_rdata_field_wdata;
  
  symTable_data_rdata_field_rdata <= symTable_data_rdata_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_x_we_field_wdata <= check_x_we_field_wdata_reset;
      elsif (check_x_we_field_wdata_reset_strobe = '1') then
        check_x_we_field_wdata <= check_x_we_field_wdata_reset;
      elsif (check_x_we_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') then
        check_x_we_field_wdata <= check_x_we_field_wdata_writer_state_counter_setup_setup_3;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_x_we_field_wdata_reset_strobe <= '1';
      else
        check_x_we_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_setup_setup_3) = 5) then
        check_x_we_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '1';
      else
        check_x_we_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '0';
      end if;
    end if;
  end process;
  check_x_we_field_rdata <= check_x_we_field_wdata_reset when (reset = '1') else
        check_x_we_field_wdata_reset when (check_x_we_field_wdata_reset_strobe = '1') else
        check_x_we_field_wdata_writer_state_counter_setup_setup_3 when (check_x_we_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') else
        check_x_we_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        sym_waddr_field_wdata <= sym_waddr_field_wdata_reset;
      elsif (sym_waddr_field_wdata_reset_strobe = '1') then
        sym_waddr_field_wdata <= sym_waddr_field_wdata_reset;
      elsif (sym_waddr_field_wdata_writer_strobe_state_counter_init_init_2 = '1') then
        sym_waddr_field_wdata <= sym_waddr_field_wdata_writer_state_counter_init_init_2;
      elsif (sym_waddr_field_wdata_writer_strobe_put_method_state = '1') then
        sym_waddr_field_wdata <= sym_waddr_field_wdata_writer_put_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        sym_waddr_field_wdata_reset_strobe <= '1';
      else
        sym_waddr_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_init_init_2) = 2) then
        sym_waddr_field_wdata_writer_strobe_state_counter_init_init_2 <= '1';
      else
        sym_waddr_field_wdata_writer_strobe_state_counter_init_init_2 <= '0';
      end if;
      if (conv_integer(put_method_state) = 3) then
        sym_waddr_field_wdata_writer_strobe_put_method_state <= '1';
      else
        sym_waddr_field_wdata_writer_strobe_put_method_state <= '0';
      end if;
    end if;
  end process;
  sym_waddr_field_rdata <= sym_waddr_field_wdata_reset when (reset = '1') else
        sym_waddr_field_wdata_reset when (sym_waddr_field_wdata_reset_strobe = '1') else
        sym_waddr_field_wdata_writer_state_counter_init_init_2 when (sym_waddr_field_wdata_writer_strobe_state_counter_init_init_2 = '1') else
        sym_waddr_field_wdata_writer_put_method_state when (sym_waddr_field_wdata_writer_strobe_put_method_state = '1') else
        sym_waddr_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_y_raddr_field_wdata <= check_y_raddr_field_wdata_reset;
      elsif (check_y_raddr_field_wdata_reset_strobe = '1') then
        check_y_raddr_field_wdata <= check_y_raddr_field_wdata_reset;
      elsif (check_y_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 = '1') then
        check_y_raddr_field_wdata <= check_y_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_2;
      elsif (check_y_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_2 = '1') then
        check_y_raddr_field_wdata <= check_y_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_2;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_y_raddr_field_wdata_reset_strobe <= '1';
      else
        check_y_raddr_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_isInsideAndEmpty_isInsideAndEmpty_2) = 3) then
        check_y_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= '1';
      else
        check_y_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= '0';
      end if;
      if (conv_integer(state_counter_isDuplicated_isDuplicated_2) = 3) then
        check_y_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_2 <= '1';
      else
        check_y_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_2 <= '0';
      end if;
    end if;
  end process;
  check_y_raddr_field_rdata <= check_y_raddr_field_wdata_reset when (reset = '1') else
        check_y_raddr_field_wdata_reset when (check_y_raddr_field_wdata_reset_strobe = '1') else
        check_y_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 when (check_y_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 = '1') else
        check_y_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_2 when (check_y_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_2 = '1') else
        check_y_raddr_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_x_raddr_field_wdata <= check_x_raddr_field_wdata_reset;
      elsif (check_x_raddr_field_wdata_reset_strobe = '1') then
        check_x_raddr_field_wdata <= check_x_raddr_field_wdata_reset;
      elsif (check_x_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 = '1') then
        check_x_raddr_field_wdata <= check_x_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_2;
      elsif (check_x_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_2 = '1') then
        check_x_raddr_field_wdata <= check_x_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_2;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_x_raddr_field_wdata_reset_strobe <= '1';
      else
        check_x_raddr_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_isInsideAndEmpty_isInsideAndEmpty_2) = 1) then
        check_x_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= '1';
      else
        check_x_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= '0';
      end if;
      if (conv_integer(state_counter_isDuplicated_isDuplicated_2) = 1) then
        check_x_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_2 <= '1';
      else
        check_x_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_2 <= '0';
      end if;
    end if;
  end process;
  check_x_raddr_field_rdata <= check_x_raddr_field_wdata_reset when (reset = '1') else
        check_x_raddr_field_wdata_reset when (check_x_raddr_field_wdata_reset_strobe = '1') else
        check_x_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 when (check_x_raddr_field_wdata_writer_strobe_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 = '1') else
        check_x_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_2 when (check_x_raddr_field_wdata_writer_strobe_state_counter_isDuplicated_isDuplicated_2 = '1') else
        check_x_raddr_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_decode_code_field_wdata <= this_input_port_decode_code_field_wdata_reset;
      elsif (this_input_port_decode_code_field_wdata_reset_strobe = '1') then
        this_input_port_decode_code_field_wdata <= this_input_port_decode_code_field_wdata_reset;
      elsif (this_input_port_decode_code_field_wdata_writer_strobe_state_counter_move_move_4 = '1') then
        this_input_port_decode_code_field_wdata <= this_input_port_decode_code_field_wdata_writer_state_counter_move_move_4;
      elsif (this_input_port_decode_code_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') then
        this_input_port_decode_code_field_wdata <= this_input_port_decode_code_field_wdata_writer_state_counter_setup_setup_3;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_decode_code_field_wdata_reset_strobe <= '1';
      else
        this_input_port_decode_code_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_move_move_4) = 3 or conv_integer(state_counter_move_move_4) = 6) then
        this_input_port_decode_code_field_wdata_writer_strobe_state_counter_move_move_4 <= '1';
      else
        this_input_port_decode_code_field_wdata_writer_strobe_state_counter_move_move_4 <= '0';
      end if;
      if (conv_integer(state_counter_setup_setup_3) = 3 or conv_integer(state_counter_setup_setup_3) = 6) then
        this_input_port_decode_code_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '1';
      else
        this_input_port_decode_code_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '0';
      end if;
    end if;
  end process;
  this_input_port_decode_code_field_rdata <= this_input_port_decode_code_field_wdata_reset when (reset = '1') else
        this_input_port_decode_code_field_wdata_reset when (this_input_port_decode_code_field_wdata_reset_strobe = '1') else
        this_input_port_decode_code_field_wdata_writer_state_counter_move_move_4 when (this_input_port_decode_code_field_wdata_writer_strobe_state_counter_move_move_4 = '1') else
        this_input_port_decode_code_field_wdata_writer_state_counter_setup_setup_3 when (this_input_port_decode_code_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') else
        this_input_port_decode_code_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_put_c_field_wdata <= this_input_port_put_c_field_wdata_reset;
      elsif (this_input_port_put_c_field_wdata_reset_strobe = '1') then
        this_input_port_put_c_field_wdata <= this_input_port_put_c_field_wdata_reset;
      elsif (this_input_port_put_c_field_wdata_writer_strobe_state_counter_move_move_4 = '1') then
        this_input_port_put_c_field_wdata <= this_input_port_put_c_field_wdata_writer_state_counter_move_move_4;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_put_c_field_wdata_reset_strobe <= '1';
      else
        this_input_port_put_c_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_move_move_4) = 9) then
        this_input_port_put_c_field_wdata_writer_strobe_state_counter_move_move_4 <= '1';
      else
        this_input_port_put_c_field_wdata_writer_strobe_state_counter_move_move_4 <= '0';
      end if;
    end if;
  end process;
  this_input_port_put_c_field_rdata <= this_input_port_put_c_field_wdata_reset when (reset = '1') else
        this_input_port_put_c_field_wdata_reset when (this_input_port_put_c_field_wdata_reset_strobe = '1') else
        this_input_port_put_c_field_wdata_writer_state_counter_move_move_4 when (this_input_port_put_c_field_wdata_writer_strobe_state_counter_move_move_4 = '1') else
        this_input_port_put_c_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_put_method_request_field_wdata <= this_put_method_request_field_wdata_reset;
      elsif (this_put_method_request_field_wdata_reset_strobe = '1') then
        this_put_method_request_field_wdata <= this_put_method_request_field_wdata_reset;
      elsif (this_put_method_request_field_wdata_writer_strobe_state_counter_move_move_4 = '1') then
        this_put_method_request_field_wdata <= this_put_method_request_field_wdata_writer_state_counter_move_move_4;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_put_method_request_field_wdata_reset_strobe <= '1';
      else
        this_put_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_move_move_4) = 9 or conv_integer(state_counter_move_move_4) = 9) then
        this_put_method_request_field_wdata_writer_strobe_state_counter_move_move_4 <= '1';
      else
        this_put_method_request_field_wdata_writer_strobe_state_counter_move_move_4 <= '0';
      end if;
    end if;
  end process;
  this_put_method_request_field_rdata <= this_put_method_request_field_wdata_reset when (reset = '1') else
        this_put_method_request_field_wdata_reset when (this_put_method_request_field_wdata_reset_strobe = '1') else
        this_put_method_request_field_wdata_writer_state_counter_move_move_4 when (this_put_method_request_field_wdata_writer_strobe_state_counter_move_move_4 = '1') else
        this_put_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        map_wdata_field_wdata <= map_wdata_field_wdata_reset;
      elsif (map_wdata_field_wdata_reset_strobe = '1') then
        map_wdata_field_wdata <= map_wdata_field_wdata_reset;
      elsif (map_wdata_field_wdata_writer_strobe_put_method_state = '1') then
        map_wdata_field_wdata <= map_wdata_field_wdata_writer_put_method_state;
      elsif (map_wdata_field_wdata_writer_strobe_state_counter_init_init_2 = '1') then
        map_wdata_field_wdata <= map_wdata_field_wdata_writer_state_counter_init_init_2;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        map_wdata_field_wdata_reset_strobe <= '1';
      else
        map_wdata_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(put_method_state) = 2) then
        map_wdata_field_wdata_writer_strobe_put_method_state <= '1';
      else
        map_wdata_field_wdata_writer_strobe_put_method_state <= '0';
      end if;
      if (conv_integer(state_counter_init_init_2) = 1) then
        map_wdata_field_wdata_writer_strobe_state_counter_init_init_2 <= '1';
      else
        map_wdata_field_wdata_writer_strobe_state_counter_init_init_2 <= '0';
      end if;
    end if;
  end process;
  map_wdata_field_rdata <= map_wdata_field_wdata_reset when (reset = '1') else
        map_wdata_field_wdata_reset when (map_wdata_field_wdata_reset_strobe = '1') else
        map_wdata_field_wdata_writer_put_method_state when (map_wdata_field_wdata_writer_strobe_put_method_state = '1') else
        map_wdata_field_wdata_writer_state_counter_init_init_2 when (map_wdata_field_wdata_writer_strobe_state_counter_init_init_2 = '1') else
        map_wdata_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_decode_method_request_field_wdata <= this_decode_method_request_field_wdata_reset;
      elsif (this_decode_method_request_field_wdata_reset_strobe = '1') then
        this_decode_method_request_field_wdata <= this_decode_method_request_field_wdata_reset;
      elsif (this_decode_method_request_field_wdata_writer_strobe_state_counter_move_move_4 = '1') then
        this_decode_method_request_field_wdata <= this_decode_method_request_field_wdata_writer_state_counter_move_move_4;
      elsif (this_decode_method_request_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') then
        this_decode_method_request_field_wdata <= this_decode_method_request_field_wdata_writer_state_counter_setup_setup_3;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_decode_method_request_field_wdata_reset_strobe <= '1';
      else
        this_decode_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_move_move_4) = 3 or conv_integer(state_counter_move_move_4) = 3 or conv_integer(state_counter_move_move_4) = 6 or conv_integer(state_counter_move_move_4) = 6) then
        this_decode_method_request_field_wdata_writer_strobe_state_counter_move_move_4 <= '1';
      else
        this_decode_method_request_field_wdata_writer_strobe_state_counter_move_move_4 <= '0';
      end if;
      if (conv_integer(state_counter_setup_setup_3) = 3 or conv_integer(state_counter_setup_setup_3) = 3 or conv_integer(state_counter_setup_setup_3) = 6 or conv_integer(state_counter_setup_setup_3) = 6) then
        this_decode_method_request_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '1';
      else
        this_decode_method_request_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '0';
      end if;
    end if;
  end process;
  this_decode_method_request_field_rdata <= this_decode_method_request_field_wdata_reset when (reset = '1') else
        this_decode_method_request_field_wdata_reset when (this_decode_method_request_field_wdata_reset_strobe = '1') else
        this_decode_method_request_field_wdata_writer_state_counter_move_move_4 when (this_decode_method_request_field_wdata_writer_strobe_state_counter_move_move_4 = '1') else
        this_decode_method_request_field_wdata_writer_state_counter_setup_setup_3 when (this_decode_method_request_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') else
        this_decode_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_len_field_wdata <= check_len_field_wdata_reset;
      elsif (check_len_field_wdata_reset_strobe = '1') then
        check_len_field_wdata <= check_len_field_wdata_reset;
      elsif (check_len_field_wdata_writer_strobe_move_method_state = '1') then
        check_len_field_wdata <= check_len_field_wdata_writer_move_method_state;
      elsif (check_len_field_wdata_writer_strobe_setup_method_state = '1') then
        check_len_field_wdata <= check_len_field_wdata_writer_setup_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_len_field_wdata_reset_strobe <= '1';
      else
        check_len_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(move_method_state) = 3) then
        check_len_field_wdata_writer_strobe_move_method_state <= '1';
      else
        check_len_field_wdata_writer_strobe_move_method_state <= '0';
      end if;
      if (conv_integer(setup_method_state) = 3) then
        check_len_field_wdata_writer_strobe_setup_method_state <= '1';
      else
        check_len_field_wdata_writer_strobe_setup_method_state <= '0';
      end if;
    end if;
  end process;
  check_len_field_rdata <= check_len_field_wdata_reset when (reset = '1') else
        check_len_field_wdata_reset when (check_len_field_wdata_reset_strobe = '1') else
        check_len_field_wdata_writer_move_method_state when (check_len_field_wdata_writer_strobe_move_method_state = '1') else
        check_len_field_wdata_writer_setup_method_state when (check_len_field_wdata_writer_strobe_setup_method_state = '1') else
        check_len_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        map_we_field_wdata <= map_we_field_wdata_reset;
      elsif (map_we_field_wdata_reset_strobe = '1') then
        map_we_field_wdata <= map_we_field_wdata_reset;
      elsif (map_we_field_wdata_writer_strobe_state_counter_init_init_2 = '1') then
        map_we_field_wdata <= map_we_field_wdata_writer_state_counter_init_init_2;
      elsif (map_we_field_wdata_writer_strobe_put_method_state = '1') then
        map_we_field_wdata <= map_we_field_wdata_writer_put_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        map_we_field_wdata_reset_strobe <= '1';
      else
        map_we_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_init_init_2) = 1) then
        map_we_field_wdata_writer_strobe_state_counter_init_init_2 <= '1';
      else
        map_we_field_wdata_writer_strobe_state_counter_init_init_2 <= '0';
      end if;
      if (conv_integer(put_method_state) = 2) then
        map_we_field_wdata_writer_strobe_put_method_state <= '1';
      else
        map_we_field_wdata_writer_strobe_put_method_state <= '0';
      end if;
    end if;
  end process;
  map_we_field_rdata <= map_we_field_wdata_reset when (reset = '1') else
        map_we_field_wdata_reset when (map_we_field_wdata_reset_strobe = '1') else
        map_we_field_wdata_writer_state_counter_init_init_2 when (map_we_field_wdata_writer_strobe_state_counter_init_init_2 = '1') else
        map_we_field_wdata_writer_put_method_state when (map_we_field_wdata_writer_strobe_put_method_state = '1') else
        map_we_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_y_wdata_field_wdata <= check_y_wdata_field_wdata_reset;
      elsif (check_y_wdata_field_wdata_reset_strobe = '1') then
        check_y_wdata_field_wdata <= check_y_wdata_field_wdata_reset;
      elsif (check_y_wdata_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') then
        check_y_wdata_field_wdata <= check_y_wdata_field_wdata_writer_state_counter_setup_setup_3;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_y_wdata_field_wdata_reset_strobe <= '1';
      else
        check_y_wdata_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_setup_setup_3) = 8) then
        check_y_wdata_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '1';
      else
        check_y_wdata_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '0';
      end if;
    end if;
  end process;
  check_y_wdata_field_rdata <= check_y_wdata_field_wdata_reset when (reset = '1') else
        check_y_wdata_field_wdata_reset when (check_y_wdata_field_wdata_reset_strobe = '1') else
        check_y_wdata_field_wdata_writer_state_counter_setup_setup_3 when (check_y_wdata_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') else
        check_y_wdata_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_x_wdata_field_wdata <= check_x_wdata_field_wdata_reset;
      elsif (check_x_wdata_field_wdata_reset_strobe = '1') then
        check_x_wdata_field_wdata <= check_x_wdata_field_wdata_reset;
      elsif (check_x_wdata_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') then
        check_x_wdata_field_wdata <= check_x_wdata_field_wdata_writer_state_counter_setup_setup_3;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        check_x_wdata_field_wdata_reset_strobe <= '1';
      else
        check_x_wdata_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_setup_setup_3) = 5) then
        check_x_wdata_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '1';
      else
        check_x_wdata_field_wdata_writer_strobe_state_counter_setup_setup_3 <= '0';
      end if;
    end if;
  end process;
  check_x_wdata_field_rdata <= check_x_wdata_field_wdata_reset when (reset = '1') else
        check_x_wdata_field_wdata_reset when (check_x_wdata_field_wdata_reset_strobe = '1') else
        check_x_wdata_field_wdata_writer_state_counter_setup_setup_3 when (check_x_wdata_field_wdata_writer_strobe_state_counter_setup_setup_3 = '1') else
        check_x_wdata_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_isDuplicated_dy_field_wdata <= this_input_port_isDuplicated_dy_field_wdata_reset;
      elsif (this_input_port_isDuplicated_dy_field_wdata_reset_strobe = '1') then
        this_input_port_isDuplicated_dy_field_wdata <= this_input_port_isDuplicated_dy_field_wdata_reset;
      elsif (this_input_port_isDuplicated_dy_field_wdata_writer_strobe_isEdgeSharing_method_state = '1') then
        this_input_port_isDuplicated_dy_field_wdata <= this_input_port_isDuplicated_dy_field_wdata_writer_isEdgeSharing_method_state;
      elsif (this_input_port_isDuplicated_dy_field_wdata_writer_strobe_isVertexSharing_method_state = '1') then
        this_input_port_isDuplicated_dy_field_wdata <= this_input_port_isDuplicated_dy_field_wdata_writer_isVertexSharing_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_isDuplicated_dy_field_wdata_reset_strobe <= '1';
      else
        this_input_port_isDuplicated_dy_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(isEdgeSharing_method_state) = 2 or conv_integer(isEdgeSharing_method_state) = 4 or conv_integer(isEdgeSharing_method_state) = 6 or conv_integer(isEdgeSharing_method_state) = 8) then
        this_input_port_isDuplicated_dy_field_wdata_writer_strobe_isEdgeSharing_method_state <= '1';
      else
        this_input_port_isDuplicated_dy_field_wdata_writer_strobe_isEdgeSharing_method_state <= '0';
      end if;
      if (conv_integer(isVertexSharing_method_state) = 2 or conv_integer(isVertexSharing_method_state) = 4 or conv_integer(isVertexSharing_method_state) = 6 or conv_integer(isVertexSharing_method_state) = 8) then
        this_input_port_isDuplicated_dy_field_wdata_writer_strobe_isVertexSharing_method_state <= '1';
      else
        this_input_port_isDuplicated_dy_field_wdata_writer_strobe_isVertexSharing_method_state <= '0';
      end if;
    end if;
  end process;
  this_input_port_isDuplicated_dy_field_rdata <= this_input_port_isDuplicated_dy_field_wdata_reset when (reset = '1') else
        this_input_port_isDuplicated_dy_field_wdata_reset when (this_input_port_isDuplicated_dy_field_wdata_reset_strobe = '1') else
        this_input_port_isDuplicated_dy_field_wdata_writer_isEdgeSharing_method_state when (this_input_port_isDuplicated_dy_field_wdata_writer_strobe_isEdgeSharing_method_state = '1') else
        this_input_port_isDuplicated_dy_field_wdata_writer_isVertexSharing_method_state when (this_input_port_isDuplicated_dy_field_wdata_writer_strobe_isVertexSharing_method_state = '1') else
        this_input_port_isDuplicated_dy_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_isDuplicated_dx_field_wdata <= this_input_port_isDuplicated_dx_field_wdata_reset;
      elsif (this_input_port_isDuplicated_dx_field_wdata_reset_strobe = '1') then
        this_input_port_isDuplicated_dx_field_wdata <= this_input_port_isDuplicated_dx_field_wdata_reset;
      elsif (this_input_port_isDuplicated_dx_field_wdata_writer_strobe_isEdgeSharing_method_state = '1') then
        this_input_port_isDuplicated_dx_field_wdata <= this_input_port_isDuplicated_dx_field_wdata_writer_isEdgeSharing_method_state;
      elsif (this_input_port_isDuplicated_dx_field_wdata_writer_strobe_isVertexSharing_method_state = '1') then
        this_input_port_isDuplicated_dx_field_wdata <= this_input_port_isDuplicated_dx_field_wdata_writer_isVertexSharing_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_isDuplicated_dx_field_wdata_reset_strobe <= '1';
      else
        this_input_port_isDuplicated_dx_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(isEdgeSharing_method_state) = 2 or conv_integer(isEdgeSharing_method_state) = 4 or conv_integer(isEdgeSharing_method_state) = 6 or conv_integer(isEdgeSharing_method_state) = 8) then
        this_input_port_isDuplicated_dx_field_wdata_writer_strobe_isEdgeSharing_method_state <= '1';
      else
        this_input_port_isDuplicated_dx_field_wdata_writer_strobe_isEdgeSharing_method_state <= '0';
      end if;
      if (conv_integer(isVertexSharing_method_state) = 2 or conv_integer(isVertexSharing_method_state) = 4 or conv_integer(isVertexSharing_method_state) = 6 or conv_integer(isVertexSharing_method_state) = 8) then
        this_input_port_isDuplicated_dx_field_wdata_writer_strobe_isVertexSharing_method_state <= '1';
      else
        this_input_port_isDuplicated_dx_field_wdata_writer_strobe_isVertexSharing_method_state <= '0';
      end if;
    end if;
  end process;
  this_input_port_isDuplicated_dx_field_rdata <= this_input_port_isDuplicated_dx_field_wdata_reset when (reset = '1') else
        this_input_port_isDuplicated_dx_field_wdata_reset when (this_input_port_isDuplicated_dx_field_wdata_reset_strobe = '1') else
        this_input_port_isDuplicated_dx_field_wdata_writer_isEdgeSharing_method_state when (this_input_port_isDuplicated_dx_field_wdata_writer_strobe_isEdgeSharing_method_state = '1') else
        this_input_port_isDuplicated_dx_field_wdata_writer_isVertexSharing_method_state when (this_input_port_isDuplicated_dx_field_wdata_writer_strobe_isVertexSharing_method_state = '1') else
        this_input_port_isDuplicated_dx_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_isEdgeSharing_c_field_wdata <= this_input_port_isEdgeSharing_c_field_wdata_reset;
      elsif (this_input_port_isEdgeSharing_c_field_wdata_reset_strobe = '1') then
        this_input_port_isEdgeSharing_c_field_wdata <= this_input_port_isEdgeSharing_c_field_wdata_reset;
      elsif (this_input_port_isEdgeSharing_c_field_wdata_writer_strobe_state_counter_isValid_isValid_4 = '1') then
        this_input_port_isEdgeSharing_c_field_wdata <= this_input_port_isEdgeSharing_c_field_wdata_writer_state_counter_isValid_isValid_4;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_isEdgeSharing_c_field_wdata_reset_strobe <= '1';
      else
        this_input_port_isEdgeSharing_c_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_isValid_isValid_4) = 1) then
        this_input_port_isEdgeSharing_c_field_wdata_writer_strobe_state_counter_isValid_isValid_4 <= '1';
      else
        this_input_port_isEdgeSharing_c_field_wdata_writer_strobe_state_counter_isValid_isValid_4 <= '0';
      end if;
    end if;
  end process;
  this_input_port_isEdgeSharing_c_field_rdata <= this_input_port_isEdgeSharing_c_field_wdata_reset when (reset = '1') else
        this_input_port_isEdgeSharing_c_field_wdata_reset when (this_input_port_isEdgeSharing_c_field_wdata_reset_strobe = '1') else
        this_input_port_isEdgeSharing_c_field_wdata_writer_state_counter_isValid_isValid_4 when (this_input_port_isEdgeSharing_c_field_wdata_writer_strobe_state_counter_isValid_isValid_4 = '1') else
        this_input_port_isEdgeSharing_c_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_setup_rot_field_wdata <= this_input_port_setup_rot_field_wdata_reset;
      elsif (this_input_port_setup_rot_field_wdata_reset_strobe = '1') then
        this_input_port_setup_rot_field_wdata <= this_input_port_setup_rot_field_wdata_reset;
      elsif (this_input_port_setup_rot_field_wdata_writer_strobe_isValid_method_state = '1') then
        this_input_port_setup_rot_field_wdata <= this_input_port_setup_rot_field_wdata_writer_isValid_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_setup_rot_field_wdata_reset_strobe <= '1';
      else
        this_input_port_setup_rot_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(isValid_method_state) = 2) then
        this_input_port_setup_rot_field_wdata_writer_strobe_isValid_method_state <= '1';
      else
        this_input_port_setup_rot_field_wdata_writer_strobe_isValid_method_state <= '0';
      end if;
    end if;
  end process;
  this_input_port_setup_rot_field_rdata <= this_input_port_setup_rot_field_wdata_reset when (reset = '1') else
        this_input_port_setup_rot_field_wdata_reset when (this_input_port_setup_rot_field_wdata_reset_strobe = '1') else
        this_input_port_setup_rot_field_wdata_writer_isValid_method_state when (this_input_port_setup_rot_field_wdata_writer_strobe_isValid_method_state = '1') else
        this_input_port_setup_rot_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_isEdgeSharing_method_request_field_wdata <= this_isEdgeSharing_method_request_field_wdata_reset;
      elsif (this_isEdgeSharing_method_request_field_wdata_reset_strobe = '1') then
        this_isEdgeSharing_method_request_field_wdata <= this_isEdgeSharing_method_request_field_wdata_reset;
      elsif (this_isEdgeSharing_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_4 = '1') then
        this_isEdgeSharing_method_request_field_wdata <= this_isEdgeSharing_method_request_field_wdata_writer_state_counter_isValid_isValid_4;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_isEdgeSharing_method_request_field_wdata_reset_strobe <= '1';
      else
        this_isEdgeSharing_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_isValid_isValid_4) = 1 or conv_integer(state_counter_isValid_isValid_4) = 1) then
        this_isEdgeSharing_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_4 <= '1';
      else
        this_isEdgeSharing_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_4 <= '0';
      end if;
    end if;
  end process;
  this_isEdgeSharing_method_request_field_rdata <= this_isEdgeSharing_method_request_field_wdata_reset when (reset = '1') else
        this_isEdgeSharing_method_request_field_wdata_reset when (this_isEdgeSharing_method_request_field_wdata_reset_strobe = '1') else
        this_isEdgeSharing_method_request_field_wdata_writer_state_counter_isValid_isValid_4 when (this_isEdgeSharing_method_request_field_wdata_writer_strobe_state_counter_isValid_isValid_4 = '1') else
        this_isEdgeSharing_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        sym_raddr_field_wdata <= sym_raddr_field_wdata_reset;
      elsif (sym_raddr_field_wdata_reset_strobe = '1') then
        sym_raddr_field_wdata <= sym_raddr_field_wdata_reset;
      elsif (sym_raddr_field_wdata_writer_strobe_getSym_method_state = '1') then
        sym_raddr_field_wdata <= sym_raddr_field_wdata_writer_getSym_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        sym_raddr_field_wdata_reset_strobe <= '1';
      else
        sym_raddr_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(getSym_method_state) = 2) then
        sym_raddr_field_wdata_writer_strobe_getSym_method_state <= '1';
      else
        sym_raddr_field_wdata_writer_strobe_getSym_method_state <= '0';
      end if;
    end if;
  end process;
  sym_raddr_field_rdata <= sym_raddr_field_wdata_reset when (reset = '1') else
        sym_raddr_field_wdata_reset when (sym_raddr_field_wdata_reset_strobe = '1') else
        sym_raddr_field_wdata_writer_getSym_method_state when (sym_raddr_field_wdata_writer_strobe_getSym_method_state = '1') else
        sym_raddr_field_wdata;
  process(clk) --decode
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_decode_decode_0 <= (others => '0');
        v_decode_0 <= (others => '0');
        state_counter_decode_decode_1 <= (others => '0');
        decode_cond_expr_decode_2_decode_0 <= (others => '0');
        this_decode_method_busy <= '0';
        decode_method_state <= (others => '0');
        this_output_port_decode <= (others => '0');
      else
        case conv_integer(decode_method_state) is
          when 0 =>
            if(this_decode_method_request_field_rdata = '1') then
              this_decode_method_busy <= '1';
              decode_method_state <= decode_method_state + 1;
            else
              this_decode_method_busy <= '0';
            end if;
          when 1 =>
            if(this_decode_method_request_field_rdata = '0') then
              decode_method_state <= decode_method_state + 1;
            end if;
          when 2 => 
            v_decode_0 <= conv_std_logic_vector(0, v_decode_0'length);
            decode_method_state <= decode_method_state + 1;
          when 3 => 
            case conv_integer(state_counter_decode_decode_1) is
              when 0 =>
                if (this_input_port_decode_code_field_rdata = 0) then
                  state_counter_decode_decode_1 <= conv_std_logic_vector(1, state_counter_decode_decode_1'length);
                elsif (this_input_port_decode_code_field_rdata = 1) then
                  state_counter_decode_decode_1 <= conv_std_logic_vector(3, state_counter_decode_decode_1'length);
                elsif (this_input_port_decode_code_field_rdata = 2) then
                  state_counter_decode_decode_1 <= conv_std_logic_vector(5, state_counter_decode_decode_1'length);
                elsif (this_input_port_decode_code_field_rdata = 6) then
                  state_counter_decode_decode_1 <= conv_std_logic_vector(7, state_counter_decode_decode_1'length);
                elsif (this_input_port_decode_code_field_rdata = 7) then
                  state_counter_decode_decode_1 <= conv_std_logic_vector(9, state_counter_decode_decode_1'length);
                else
                  state_counter_decode_decode_1 <= conv_std_logic_vector(11, state_counter_decode_decode_1'length);
                end if;
              when 1 =>
                v_decode_0 <= conv_std_logic_vector(0, v_decode_0'length);
                state_counter_decode_decode_1 <= state_counter_decode_decode_1 + 1;
              when 2 =>
                state_counter_decode_decode_1 <= (others => '0');
                decode_method_state <= decode_method_state + 1;
              when 3 =>
                v_decode_0 <= conv_std_logic_vector(1, v_decode_0'length);
                state_counter_decode_decode_1 <= state_counter_decode_decode_1 + 1;
              when 4 =>
                state_counter_decode_decode_1 <= (others => '0');
                decode_method_state <= decode_method_state + 1;
              when 5 =>
                v_decode_0 <= conv_std_logic_vector(2, v_decode_0'length);
                state_counter_decode_decode_1 <= state_counter_decode_decode_1 + 1;
              when 6 =>
                state_counter_decode_decode_1 <= (others => '0');
                decode_method_state <= decode_method_state + 1;
              when 7 =>
                v_decode_0 <= conv_std_logic_vector(-2, v_decode_0'length);
                state_counter_decode_decode_1 <= state_counter_decode_decode_1 + 1;
              when 8 =>
                state_counter_decode_decode_1 <= (others => '0');
                decode_method_state <= decode_method_state + 1;
              when 9 =>
                v_decode_0 <= conv_std_logic_vector(-1, v_decode_0'length);
                state_counter_decode_decode_1 <= state_counter_decode_decode_1 + 1;
              when 10 =>
                state_counter_decode_decode_1 <= (others => '0');
                decode_method_state <= decode_method_state + 1;
              when 11 =>
                state_counter_decode_decode_1 <= (others => '0');
                decode_method_state <= decode_method_state + 1;
              when others =>
                state_counter_decode_decode_1 <= (others => '0');
                decode_method_state <= decode_method_state + 1;
            end case;
          when 4 => 
            this_output_port_decode <= conv_std_logic_vector(conv_integer(v_decode_0), this_output_port_decode'length);
            decode_method_state <= (others => '0');
          when 5 =>
            this_decode_method_busy <= '0';
            decode_method_state <= (others => '0');
          when others => decode_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --decode
  process(clk) --get
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_get_get_0 <= (others => '0');
        array_index_operation_state_counter_get_1 <= (others => '0');
        this_get_method_busy <= '0';
        get_method_state <= (others => '0');
        output_port_get <= (others => '0');
      else
        case conv_integer(get_method_state) is
          when 0 =>
            if(this_get_method_request = '1') then
              this_get_method_busy <= '1';
              get_method_state <= get_method_state + 1;
            else
              this_get_method_busy <= '0';
            end if;
          when 1 =>
            if(this_get_method_request = '0') then
              get_method_state <= get_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(array_index_operation_state_counter_get_1) is
              when 0 =>
                map_raddr_field_wdata_writer_get_method_state <= conv_std_logic_vector((conv_integer(input_port_get_y(31 - 4 downto 0) & conv_std_logic_vector(0, 4))) + conv_integer(input_port_get_x), map_raddr_field_wdata'length);
                array_index_operation_state_counter_get_1 <= array_index_operation_state_counter_get_1 + 1;
              when 1 =>
                array_index_operation_state_counter_get_1 <= (others => '0');
                get_method_state <= get_method_state + 1;
              when others => array_index_operation_state_counter_get_1 <= (others => '0');
            end case;
          when 3 => 
            output_port_get <= conv_std_logic_vector(conv_integer(map_rdata_field_rdata), output_port_get'length);
            get_method_state <= (others => '0');
          when 4 =>
            this_get_method_busy <= '0';
            get_method_state <= (others => '0');
          when others => get_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --get
  process(clk) --move
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_move_move_0 <= (others => '0');
        d_move_0 <= (others => '0');
        v_move_0 <= (others => '0');
        mx_move_0 <= (others => '0');
        my_move_0 <= (others => '0');
        sym_move_0 <= (others => '0');
        array_index_operation_state_counter_move_1 <= (others => '0');
        array_index_operation_state_counter_move_2 <= (others => '0');
        state_counter_move_move_3 <= (others => '0');
        i_move_3 <= (others => '0');
        state_counter_move_move_4 <= (others => '0');
        array_index_operation_state_counter_move_5 <= (others => '0');
        this_decode_call_state_counter_move_4 <= (others => '0');
        this_decode_call_state_counter_move_4 <= (others => '0');
        this_decode_call_state_counter_move_4 <= (others => '0');
        this_decode_call_state_counter_move_4 <= (others => '0');
        this_put_call_state_counter_move_4 <= (others => '0');
        this_put_call_state_counter_move_4 <= (others => '0');
        this_move_method_busy <= '0';
        move_method_state <= (others => '0');
        check_len_field_wdata_reset <= conv_std_logic_vector(0, 31-0+1);
        this_decode_method_request_field_wdata_reset <= '0';
        this_decode_method_request_field_wdata_reset <= '0';
        this_put_method_request_field_wdata_reset <= '0';
      else
        case conv_integer(move_method_state) is
          when 0 =>
            if(this_move_method_request = '1') then
              this_move_method_busy <= '1';
              move_method_state <= move_method_state + 1;
            else
              this_move_method_busy <= '0';
            end if;
          when 1 =>
            if(this_move_method_request = '0') then
              move_method_state <= move_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(array_index_operation_state_counter_move_1) is
              when 0 =>
                lenTable_data_raddr_field_wdata_writer_move_method_state <= conv_std_logic_vector(conv_integer(input_port_move_id), lenTable_data_raddr_field_wdata'length);
                array_index_operation_state_counter_move_1 <= array_index_operation_state_counter_move_1 + 1;
              when 1 =>
                array_index_operation_state_counter_move_1 <= (others => '0');
                move_method_state <= move_method_state + 1;
              when others => array_index_operation_state_counter_move_1 <= (others => '0');
            end case;
          when 3 => 
            check_len_field_wdata_writer_move_method_state <= conv_std_logic_vector(conv_integer(lenTable_data_rdata_field_rdata), check_len_field_wdata'length);
            move_method_state <= move_method_state + 1;
          when 4 => 
            case conv_integer(array_index_operation_state_counter_move_2) is
              when 0 =>
                symTable_data_raddr_field_wdata_writer_move_method_state <= conv_std_logic_vector(conv_integer(input_port_move_id), symTable_data_raddr_field_wdata'length);
                array_index_operation_state_counter_move_2 <= array_index_operation_state_counter_move_2 + 1;
              when 1 =>
                array_index_operation_state_counter_move_2 <= (others => '0');
                move_method_state <= move_method_state + 1;
              when others => array_index_operation_state_counter_move_2 <= (others => '0');
            end case;
          when 5 => 
            sym_move_0 <= conv_std_logic_vector(conv_integer(symTable_data_rdata_field_rdata), sym_move_0'length);
            move_method_state <= move_method_state + 1;
          when 6 => 
            case conv_integer(state_counter_move_move_3) is
              when 0 => state_counter_move_move_3 <= state_counter_move_move_3 + 1;
              when 1 =>
                i_move_3 <= conv_std_logic_vector(0, i_move_3'length);
                state_counter_move_move_3 <= state_counter_move_move_3 + 1;
              when 2 =>
                if (conv_integer(i_move_3) < conv_integer(check_len_field_rdata)) then
                  state_counter_move_move_3 <= state_counter_move_move_3 + 1;
                  state_counter_move_move_4 <= conv_std_logic_vector(1, state_counter_move_move_4'length);
                else
                  move_method_state <= move_method_state + 1;
                  state_counter_move_move_3 <= (others => '0');
                end if;
              when 3 =>
                case conv_integer(state_counter_move_move_4) is
                  when 0 => state_counter_move_move_4 <= state_counter_move_move_4 + 1;
                  when 1 =>
                    case conv_integer(array_index_operation_state_counter_move_5) is
                      when 0 =>
                        table_data_raddr_field_wdata_writer_state_counter_move_move_4 <= conv_std_logic_vector((conv_integer(input_port_move_id(31 - 5 downto 0) & conv_std_logic_vector(0, 5))) + (conv_integer(input_port_move_id(31 - 3 downto 0) & conv_std_logic_vector(0, 3))) + (conv_integer(input_port_move_rot(31 - 2 downto 0) & conv_std_logic_vector(0, 2))) + conv_integer(input_port_move_rot) + conv_integer(i_move_3), table_data_raddr_field_wdata'length);
                        array_index_operation_state_counter_move_5 <= array_index_operation_state_counter_move_5 + 1;
                      when 1 =>
                        array_index_operation_state_counter_move_5 <= (others => '0');
                        state_counter_move_move_4 <= state_counter_move_move_4 + 1;
                      when others => array_index_operation_state_counter_move_5 <= (others => '0');
                    end case;
                  when 2 =>
                    d_move_0 <= conv_std_logic_vector(conv_integer(table_data_rdata_field_rdata), d_move_0'length);
                    state_counter_move_move_4 <= state_counter_move_move_4 + 1;
                  when 3 =>
                    case conv_integer(this_decode_call_state_counter_move_4) is
                      when 0 =>
                        if (this_decode_method_busy = '0') then
                          this_decode_method_request_field_wdata_writer_state_counter_move_move_4 <= '1';
                          this_decode_call_state_counter_move_4 <= conv_std_logic_vector(1, this_decode_call_state_counter_move_4'length);
                        end if;
                      when 1 =>
                        this_input_port_decode_code_field_wdata_writer_state_counter_move_move_4 <= conv_std_logic_vector(conv_integer(conv_std_logic_vector((conv_integer(conv_std_logic_vector(0, 3) & d_move_0(31 downto 3))), 32) and conv_std_logic_vector(7, 32)), this_input_port_decode_code_field_wdata'length);
                        this_decode_method_request_field_wdata_writer_state_counter_move_move_4 <= '0';
                          this_decode_call_state_counter_move_4 <= conv_std_logic_vector(2, this_decode_call_state_counter_move_4'length);
                      when 2 =>
                        if (this_decode_method_request_field_wdata = '0' and this_decode_method_busy = '0') then
                          this_decode_call_state_counter_move_4 <= (others => '0');
                          state_counter_move_move_4 <= state_counter_move_move_4 + 1;
                        end if;
                      when others => this_decode_call_state_counter_move_4 <= (others => '0');
                    end case;
                  when 4 =>
                    v_move_0 <= conv_std_logic_vector(conv_integer(this_output_port_decode), v_move_0'length);
                    state_counter_move_move_4 <= state_counter_move_move_4 + 1;
                  when 5 =>
                    mx_move_0 <= conv_std_logic_vector(conv_integer(v_move_0) + conv_integer(input_port_move_x), mx_move_0'length);
                    state_counter_move_move_4 <= state_counter_move_move_4 + 1;
                  when 6 =>
                    case conv_integer(this_decode_call_state_counter_move_4) is
                      when 0 =>
                        if (this_decode_method_busy = '0') then
                          this_decode_method_request_field_wdata_writer_state_counter_move_move_4 <= '1';
                          this_decode_call_state_counter_move_4 <= conv_std_logic_vector(1, this_decode_call_state_counter_move_4'length);
                        end if;
                      when 1 =>
                        this_input_port_decode_code_field_wdata_writer_state_counter_move_move_4 <= conv_std_logic_vector(conv_integer(d_move_0 and conv_std_logic_vector(7, 32)), this_input_port_decode_code_field_wdata'length);
                        this_decode_method_request_field_wdata_writer_state_counter_move_move_4 <= '0';
                          this_decode_call_state_counter_move_4 <= conv_std_logic_vector(2, this_decode_call_state_counter_move_4'length);
                      when 2 =>
                        if (this_decode_method_request_field_wdata = '0' and this_decode_method_busy = '0') then
                          this_decode_call_state_counter_move_4 <= (others => '0');
                          state_counter_move_move_4 <= state_counter_move_move_4 + 1;
                        end if;
                      when others => this_decode_call_state_counter_move_4 <= (others => '0');
                    end case;
                  when 7 =>
                    v_move_0 <= conv_std_logic_vector(conv_integer(this_output_port_decode), v_move_0'length);
                    state_counter_move_move_4 <= state_counter_move_move_4 + 1;
                  when 8 =>
                    my_move_0 <= conv_std_logic_vector(conv_integer(v_move_0) + conv_integer(input_port_move_y), my_move_0'length);
                    state_counter_move_move_4 <= state_counter_move_move_4 + 1;
                  when 9 =>
                    case conv_integer(this_put_call_state_counter_move_4) is
                      when 0 =>
                        if (this_put_method_busy = '0') then
                          this_put_method_request_field_wdata_writer_state_counter_move_move_4 <= '1';
                          this_put_call_state_counter_move_4 <= conv_std_logic_vector(1, this_put_call_state_counter_move_4'length);
                        end if;
                      when 1 =>
                        this_input_port_put_c_field_wdata_writer_state_counter_move_move_4 <= conv_std_logic_vector(conv_integer(input_port_move_c), this_input_port_put_c_field_wdata'length);
                        this_input_port_put_x_field_wdata_writer_state_counter_move_move_4 <= conv_std_logic_vector(conv_integer(mx_move_0), this_input_port_put_x_field_wdata'length);
                        this_input_port_put_y_field_wdata_writer_state_counter_move_move_4 <= conv_std_logic_vector(conv_integer(my_move_0), this_input_port_put_y_field_wdata'length);
                        this_input_port_put_s_field_wdata_writer_state_counter_move_move_4 <= conv_std_logic_vector(conv_integer(sym_move_0), this_input_port_put_s_field_wdata'length);
                        this_put_method_request_field_wdata_writer_state_counter_move_move_4 <= '0';
                          this_put_call_state_counter_move_4 <= conv_std_logic_vector(2, this_put_call_state_counter_move_4'length);
                      when 2 =>
                        if (this_put_method_request_field_wdata = '0' and this_put_method_busy = '0') then
                          this_put_call_state_counter_move_4 <= (others => '0');
                          state_counter_move_move_4 <= state_counter_move_move_4 + 1;
                        end if;
                      when others => this_put_call_state_counter_move_4 <= (others => '0');
                    end case;
                  when 10 =>
                    state_counter_move_move_3 <= state_counter_move_move_3 + 1;
                    state_counter_move_move_4 <= (others => '0');
                  when others => state_counter_move_move_4 <= (others => '0');
                end case;
              when 4 =>
                  i_move_3 <= conv_std_logic_vector(conv_integer(i_move_3) + 1, i_move_3'length);
                  state_counter_move_move_3 <= conv_std_logic_vector(2, 32);
              when others => state_counter_move_move_3 <= (others => '0');
            end case;
          when 7 =>
            this_move_method_busy <= '0';
            move_method_state <= (others => '0');
          when others => move_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --move
  process(clk) --setup
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_setup_setup_0 <= (others => '0');
        d_setup_0 <= (others => '0');
        v_setup_0 <= (others => '0');
        array_index_operation_state_counter_setup_1 <= (others => '0');
        state_counter_setup_setup_2 <= (others => '0');
        i_setup_2 <= (others => '0');
        state_counter_setup_setup_3 <= (others => '0');
        array_index_operation_state_counter_setup_4 <= (others => '0');
        this_decode_call_state_counter_setup_3 <= (others => '0');
        this_decode_call_state_counter_setup_3 <= (others => '0');
        array_index_operation_state_counter_setup_5 <= (others => '0');
        this_decode_call_state_counter_setup_3 <= (others => '0');
        this_decode_call_state_counter_setup_3 <= (others => '0');
        array_index_operation_state_counter_setup_6 <= (others => '0');
        this_setup_method_busy <= '0';
        setup_method_state <= (others => '0');
        this_decode_method_request_field_wdata_reset <= '0';
        check_x_wdata_field_wdata_reset <= (others => '0');
        this_decode_method_request_field_wdata_reset <= '0';
        check_y_wdata_field_wdata_reset <= (others => '0');
      else
        case conv_integer(setup_method_state) is
          when 0 =>
            if(this_setup_method_request_field_rdata = '1') then
              this_setup_method_busy <= '1';
              setup_method_state <= setup_method_state + 1;
            else
              this_setup_method_busy <= '0';
            end if;
          when 1 =>
            if(this_setup_method_request_field_rdata = '0') then
              setup_method_state <= setup_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(array_index_operation_state_counter_setup_1) is
              when 0 =>
                lenTable_data_raddr_field_wdata_writer_setup_method_state <= conv_std_logic_vector(conv_integer(this_input_port_setup_id_field_rdata), lenTable_data_raddr_field_wdata'length);
                array_index_operation_state_counter_setup_1 <= array_index_operation_state_counter_setup_1 + 1;
              when 1 =>
                array_index_operation_state_counter_setup_1 <= (others => '0');
                setup_method_state <= setup_method_state + 1;
              when others => array_index_operation_state_counter_setup_1 <= (others => '0');
            end case;
          when 3 => 
            check_len_field_wdata_writer_setup_method_state <= conv_std_logic_vector(conv_integer(lenTable_data_rdata_field_rdata), check_len_field_wdata'length);
            setup_method_state <= setup_method_state + 1;
          when 4 => 
            case conv_integer(state_counter_setup_setup_2) is
              when 0 => state_counter_setup_setup_2 <= state_counter_setup_setup_2 + 1;
              when 1 =>
                i_setup_2 <= conv_std_logic_vector(0, i_setup_2'length);
                state_counter_setup_setup_2 <= state_counter_setup_setup_2 + 1;
              when 2 =>
                if (conv_integer(i_setup_2) < conv_integer(check_len_field_rdata)) then
                  state_counter_setup_setup_2 <= state_counter_setup_setup_2 + 1;
                  state_counter_setup_setup_3 <= conv_std_logic_vector(1, state_counter_setup_setup_3'length);
                else
                  setup_method_state <= setup_method_state + 1;
                  state_counter_setup_setup_2 <= (others => '0');
                end if;
              when 3 =>
                case conv_integer(state_counter_setup_setup_3) is
                  when 0 => state_counter_setup_setup_3 <= state_counter_setup_setup_3 + 1;
                  when 1 =>
                    case conv_integer(array_index_operation_state_counter_setup_4) is
                      when 0 =>
                        table_data_raddr_field_wdata_writer_state_counter_setup_setup_3 <= conv_std_logic_vector((conv_integer(this_input_port_setup_id_field_rdata(31 - 5 downto 0) & conv_std_logic_vector(0, 5))) + (conv_integer(this_input_port_setup_id_field_rdata(31 - 3 downto 0) & conv_std_logic_vector(0, 3))) + (conv_integer(this_input_port_setup_rot_field_rdata(31 - 2 downto 0) & conv_std_logic_vector(0, 2))) + conv_integer(this_input_port_setup_rot_field_rdata) + conv_integer(i_setup_2), table_data_raddr_field_wdata'length);
                        array_index_operation_state_counter_setup_4 <= array_index_operation_state_counter_setup_4 + 1;
                      when 1 =>
                        array_index_operation_state_counter_setup_4 <= (others => '0');
                        state_counter_setup_setup_3 <= state_counter_setup_setup_3 + 1;
                      when others => array_index_operation_state_counter_setup_4 <= (others => '0');
                    end case;
                  when 2 =>
                    d_setup_0 <= conv_std_logic_vector(conv_integer(table_data_rdata_field_rdata), d_setup_0'length);
                    state_counter_setup_setup_3 <= state_counter_setup_setup_3 + 1;
                  when 3 =>
                    case conv_integer(this_decode_call_state_counter_setup_3) is
                      when 0 =>
                        if (this_decode_method_busy = '0') then
                          this_decode_method_request_field_wdata_writer_state_counter_setup_setup_3 <= '1';
                          this_decode_call_state_counter_setup_3 <= conv_std_logic_vector(1, this_decode_call_state_counter_setup_3'length);
                        end if;
                      when 1 =>
                        this_input_port_decode_code_field_wdata_writer_state_counter_setup_setup_3 <= conv_std_logic_vector(conv_integer(conv_std_logic_vector((conv_integer(conv_std_logic_vector(0, 3) & d_setup_0(31 downto 3))), 32) and conv_std_logic_vector(7, 32)), this_input_port_decode_code_field_wdata'length);
                        this_decode_method_request_field_wdata_writer_state_counter_setup_setup_3 <= '0';
                          this_decode_call_state_counter_setup_3 <= conv_std_logic_vector(2, this_decode_call_state_counter_setup_3'length);
                      when 2 =>
                        if (this_decode_method_request_field_wdata = '0' and this_decode_method_busy = '0') then
                          this_decode_call_state_counter_setup_3 <= (others => '0');
                          state_counter_setup_setup_3 <= state_counter_setup_setup_3 + 1;
                        end if;
                      when others => this_decode_call_state_counter_setup_3 <= (others => '0');
                    end case;
                  when 4 =>
                    v_setup_0 <= conv_std_logic_vector(conv_integer(this_output_port_decode), v_setup_0'length);
                    state_counter_setup_setup_3 <= state_counter_setup_setup_3 + 1;
                  when 5 =>
                    check_x_waddr_field_wdata_writer_state_counter_setup_setup_3 <= conv_std_logic_vector(conv_integer(i_setup_2), check_x_waddr_field_wdata'length);
                    check_x_we_field_wdata_writer_state_counter_setup_setup_3 <= conv_std_logic_vector(1, check_x_we_field_wdata'length);
                    check_x_wdata_field_wdata_writer_state_counter_setup_setup_3 <= conv_std_logic_vector(conv_integer(v_setup_0) + conv_integer(this_input_port_setup_x_field_rdata), check_x_wdata_field_wdata'length);
                    state_counter_setup_setup_3 <= state_counter_setup_setup_3 + 1;
                  when 6 =>
                    case conv_integer(this_decode_call_state_counter_setup_3) is
                      when 0 =>
                        if (this_decode_method_busy = '0') then
                          this_decode_method_request_field_wdata_writer_state_counter_setup_setup_3 <= '1';
                          this_decode_call_state_counter_setup_3 <= conv_std_logic_vector(1, this_decode_call_state_counter_setup_3'length);
                        end if;
                      when 1 =>
                        this_input_port_decode_code_field_wdata_writer_state_counter_setup_setup_3 <= conv_std_logic_vector(conv_integer(d_setup_0 and conv_std_logic_vector(7, 32)), this_input_port_decode_code_field_wdata'length);
                        this_decode_method_request_field_wdata_writer_state_counter_setup_setup_3 <= '0';
                          this_decode_call_state_counter_setup_3 <= conv_std_logic_vector(2, this_decode_call_state_counter_setup_3'length);
                      when 2 =>
                        if (this_decode_method_request_field_wdata = '0' and this_decode_method_busy = '0') then
                          this_decode_call_state_counter_setup_3 <= (others => '0');
                          state_counter_setup_setup_3 <= state_counter_setup_setup_3 + 1;
                        end if;
                      when others => this_decode_call_state_counter_setup_3 <= (others => '0');
                    end case;
                  when 7 =>
                    v_setup_0 <= conv_std_logic_vector(conv_integer(this_output_port_decode), v_setup_0'length);
                    state_counter_setup_setup_3 <= state_counter_setup_setup_3 + 1;
                  when 8 =>
                    check_y_waddr_field_wdata_writer_state_counter_setup_setup_3 <= conv_std_logic_vector(conv_integer(i_setup_2), check_y_waddr_field_wdata'length);
                    check_y_we_field_wdata_writer_state_counter_setup_setup_3 <= conv_std_logic_vector(1, check_y_we_field_wdata'length);
                    check_y_wdata_field_wdata_writer_state_counter_setup_setup_3 <= conv_std_logic_vector(conv_integer(v_setup_0) + conv_integer(this_input_port_setup_y_field_rdata), check_y_wdata_field_wdata'length);
                    state_counter_setup_setup_2 <= state_counter_setup_setup_2 + 1;
                    state_counter_setup_setup_3 <= (others => '0');
                  when others => state_counter_setup_setup_3 <= (others => '0');
                end case;
              when 4 =>
                  i_setup_2 <= conv_std_logic_vector(conv_integer(i_setup_2) + 1, i_setup_2'length);
                  state_counter_setup_setup_2 <= conv_std_logic_vector(2, 32);
              when others => state_counter_setup_setup_2 <= (others => '0');
            end case;
          when 5 =>
            this_setup_method_busy <= '0';
            setup_method_state <= (others => '0');
          when others => setup_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --setup
  process(clk) --wait
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        d_notify_flag <= '0';
        this_wait_method_busy <= '0';
        wait_method_state <= (others => '0');
        state_counter_wait_wait_0 <= (others => '0');
      else
        case conv_integer(wait_method_state) is
          when 0 =>
            if(this_wait_method_request_field_rdata = '1') then
              this_wait_method_busy <= '1';
              wait_method_state <= wait_method_state + 1;
            else
              this_wait_method_busy <= '0';
            end if;
          when 1 =>
            if(this_wait_method_request_field_rdata = '0') then
              wait_method_state <= wait_method_state + 1;
            end if;
          when 2 => 
            if (d_notify_flag = '0' and notify_flag = '1') then
              wait_method_state <= wait_method_state + 1;
            else
              d_notify_flag <= notify_flag;
            end if;
          when 3 =>
            this_wait_method_busy <= '0';
            wait_method_state <= (others => '0');
          when others => wait_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --wait
  process(clk) --isEdgeSharing
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_isEdgeSharing_isEdgeSharing_0 <= (others => '0');
        flag0_isEdgeSharing_0 <= '0';
        flag1_isEdgeSharing_0 <= '0';
        flag2_isEdgeSharing_0 <= '0';
        flag3_isEdgeSharing_0 <= '0';
        this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
        state_counter_isEdgeSharing_isEdgeSharing_1 <= (others => '0');
        isEdgeSharing_if_flag_isEdgeSharing_2_isEdgeSharing_0 <= '0';
        state_counter_isEdgeSharing_isEdgeSharing_3 <= (others => '0');
        state_counter_isEdgeSharing_isEdgeSharing_4 <= (others => '0');
        this_isEdgeSharing_method_busy <= '0';
        isEdgeSharing_method_state <= (others => '0');
        this_isDuplicated_method_request_field_wdata_reset <= '0';
        this_isDuplicated_method_request_field_wdata_reset <= '0';
        this_isDuplicated_method_request_field_wdata_reset <= '0';
        this_isDuplicated_method_request_field_wdata_reset <= '0';
        this_output_port_isEdgeSharing <= '0';
      else
        case conv_integer(isEdgeSharing_method_state) is
          when 0 =>
            if(this_isEdgeSharing_method_request_field_rdata = '1') then
              this_isEdgeSharing_method_busy <= '1';
              isEdgeSharing_method_state <= isEdgeSharing_method_state + 1;
            else
              this_isEdgeSharing_method_busy <= '0';
            end if;
          when 1 =>
            if(this_isEdgeSharing_method_request_field_rdata = '0') then
              isEdgeSharing_method_state <= isEdgeSharing_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(this_isDuplicated_call_state_counter_isEdgeSharing_0) is
              when 0 =>
                if (this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_method_request_field_wdata_writer_isEdgeSharing_method_state <= '1';
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= conv_std_logic_vector(1, this_isDuplicated_call_state_counter_isEdgeSharing_0'length);
                end if;
              when 1 =>
                this_input_port_isDuplicated_c_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(conv_integer(this_input_port_isEdgeSharing_c_field_rdata), this_input_port_isDuplicated_c_field_wdata'length);
                this_input_port_isDuplicated_dx_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(0, this_input_port_isDuplicated_dx_field_wdata'length);
                this_input_port_isDuplicated_dy_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(-1, this_input_port_isDuplicated_dy_field_wdata'length);
                this_isDuplicated_method_request_field_wdata_writer_isEdgeSharing_method_state <= '0';
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= conv_std_logic_vector(2, this_isDuplicated_call_state_counter_isEdgeSharing_0'length);
              when 2 =>
                if (this_isDuplicated_method_request_field_wdata = '0' and this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
                  isEdgeSharing_method_state <= isEdgeSharing_method_state + 1;
                end if;
              when others => this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
            end case;
          when 3 => 
            flag0_isEdgeSharing_0 <= this_output_port_isDuplicated;
            isEdgeSharing_method_state <= isEdgeSharing_method_state + 1;
          when 4 => 
            case conv_integer(this_isDuplicated_call_state_counter_isEdgeSharing_0) is
              when 0 =>
                if (this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_method_request_field_wdata_writer_isEdgeSharing_method_state <= '1';
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= conv_std_logic_vector(1, this_isDuplicated_call_state_counter_isEdgeSharing_0'length);
                end if;
              when 1 =>
                this_input_port_isDuplicated_c_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(conv_integer(this_input_port_isEdgeSharing_c_field_rdata), this_input_port_isDuplicated_c_field_wdata'length);
                this_input_port_isDuplicated_dx_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(-1, this_input_port_isDuplicated_dx_field_wdata'length);
                this_input_port_isDuplicated_dy_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(0, this_input_port_isDuplicated_dy_field_wdata'length);
                this_isDuplicated_method_request_field_wdata_writer_isEdgeSharing_method_state <= '0';
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= conv_std_logic_vector(2, this_isDuplicated_call_state_counter_isEdgeSharing_0'length);
              when 2 =>
                if (this_isDuplicated_method_request_field_wdata = '0' and this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
                  isEdgeSharing_method_state <= isEdgeSharing_method_state + 1;
                end if;
              when others => this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
            end case;
          when 5 => 
            flag1_isEdgeSharing_0 <= this_output_port_isDuplicated;
            isEdgeSharing_method_state <= isEdgeSharing_method_state + 1;
          when 6 => 
            case conv_integer(this_isDuplicated_call_state_counter_isEdgeSharing_0) is
              when 0 =>
                if (this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_method_request_field_wdata_writer_isEdgeSharing_method_state <= '1';
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= conv_std_logic_vector(1, this_isDuplicated_call_state_counter_isEdgeSharing_0'length);
                end if;
              when 1 =>
                this_input_port_isDuplicated_c_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(conv_integer(this_input_port_isEdgeSharing_c_field_rdata), this_input_port_isDuplicated_c_field_wdata'length);
                this_input_port_isDuplicated_dx_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(1, this_input_port_isDuplicated_dx_field_wdata'length);
                this_input_port_isDuplicated_dy_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(0, this_input_port_isDuplicated_dy_field_wdata'length);
                this_isDuplicated_method_request_field_wdata_writer_isEdgeSharing_method_state <= '0';
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= conv_std_logic_vector(2, this_isDuplicated_call_state_counter_isEdgeSharing_0'length);
              when 2 =>
                if (this_isDuplicated_method_request_field_wdata = '0' and this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
                  isEdgeSharing_method_state <= isEdgeSharing_method_state + 1;
                end if;
              when others => this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
            end case;
          when 7 => 
            flag2_isEdgeSharing_0 <= this_output_port_isDuplicated;
            isEdgeSharing_method_state <= isEdgeSharing_method_state + 1;
          when 8 => 
            case conv_integer(this_isDuplicated_call_state_counter_isEdgeSharing_0) is
              when 0 =>
                if (this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_method_request_field_wdata_writer_isEdgeSharing_method_state <= '1';
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= conv_std_logic_vector(1, this_isDuplicated_call_state_counter_isEdgeSharing_0'length);
                end if;
              when 1 =>
                this_input_port_isDuplicated_c_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(conv_integer(this_input_port_isEdgeSharing_c_field_rdata), this_input_port_isDuplicated_c_field_wdata'length);
                this_input_port_isDuplicated_dx_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(0, this_input_port_isDuplicated_dx_field_wdata'length);
                this_input_port_isDuplicated_dy_field_wdata_writer_isEdgeSharing_method_state <= conv_std_logic_vector(1, this_input_port_isDuplicated_dy_field_wdata'length);
                this_isDuplicated_method_request_field_wdata_writer_isEdgeSharing_method_state <= '0';
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= conv_std_logic_vector(2, this_isDuplicated_call_state_counter_isEdgeSharing_0'length);
              when 2 =>
                if (this_isDuplicated_method_request_field_wdata = '0' and this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
                  isEdgeSharing_method_state <= isEdgeSharing_method_state + 1;
                end if;
              when others => this_isDuplicated_call_state_counter_isEdgeSharing_0 <= (others => '0');
            end case;
          when 9 => 
            flag3_isEdgeSharing_0 <= this_output_port_isDuplicated;
            isEdgeSharing_method_state <= isEdgeSharing_method_state + 1;
          when 10 => 
            case conv_integer(state_counter_isEdgeSharing_isEdgeSharing_1) is
              when 0 => state_counter_isEdgeSharing_isEdgeSharing_1 <= state_counter_isEdgeSharing_isEdgeSharing_1 + 1;
              when 1 =>
                if (flag0_isEdgeSharing_0 = '1' or flag1_isEdgeSharing_0 = '1' or flag2_isEdgeSharing_0 = '1' or flag3_isEdgeSharing_0 = '1') then
                  isEdgeSharing_if_flag_isEdgeSharing_2_isEdgeSharing_0 <= '1';
                  state_counter_isEdgeSharing_isEdgeSharing_3 <= conv_std_logic_vector(1, state_counter_isEdgeSharing_isEdgeSharing_3'length);
                else
                  isEdgeSharing_if_flag_isEdgeSharing_2_isEdgeSharing_0 <= '0';
                  state_counter_isEdgeSharing_isEdgeSharing_4 <= conv_std_logic_vector(1, state_counter_isEdgeSharing_isEdgeSharing_4'length);
                end if;
                state_counter_isEdgeSharing_isEdgeSharing_1 <= state_counter_isEdgeSharing_isEdgeSharing_1 + 1;
              when 2 =>
                if (isEdgeSharing_if_flag_isEdgeSharing_2_isEdgeSharing_0 = '1') then
                  case conv_integer(state_counter_isEdgeSharing_isEdgeSharing_3) is
                    when 0 => state_counter_isEdgeSharing_isEdgeSharing_3 <= state_counter_isEdgeSharing_isEdgeSharing_3 + 1;
                    when 1 =>
                      this_output_port_isEdgeSharing <= '1';
                      state_counter_isEdgeSharing_isEdgeSharing_3 <= (others => '0');
                      state_counter_isEdgeSharing_isEdgeSharing_1 <= (others => '0');
                      isEdgeSharing_method_state <= (others => '0');
                    when 2 =>
                      state_counter_isEdgeSharing_isEdgeSharing_1 <= state_counter_isEdgeSharing_isEdgeSharing_1 + 1;
                      state_counter_isEdgeSharing_isEdgeSharing_3 <= (others => '0');
                    when others => state_counter_isEdgeSharing_isEdgeSharing_3 <= (others => '0');
                  end case;
                else
                  case conv_integer(state_counter_isEdgeSharing_isEdgeSharing_4) is
                    when 0 => state_counter_isEdgeSharing_isEdgeSharing_4 <= state_counter_isEdgeSharing_isEdgeSharing_4 + 1;
                    when 1 =>
                      this_output_port_isEdgeSharing <= '0';
                      state_counter_isEdgeSharing_isEdgeSharing_4 <= (others => '0');
                      state_counter_isEdgeSharing_isEdgeSharing_1 <= (others => '0');
                      isEdgeSharing_method_state <= (others => '0');
                    when 2 =>
                      state_counter_isEdgeSharing_isEdgeSharing_1 <= state_counter_isEdgeSharing_isEdgeSharing_1 + 1;
                      state_counter_isEdgeSharing_isEdgeSharing_4 <= (others => '0');
                    when others => state_counter_isEdgeSharing_isEdgeSharing_4 <= (others => '0');
                  end case;
                end if;
              when 3 =>
                state_counter_isEdgeSharing_isEdgeSharing_1 <= (others => '0');
                isEdgeSharing_method_state <= isEdgeSharing_method_state + 1;
              when others =>
                state_counter_isEdgeSharing_isEdgeSharing_1 <= (others => '0');
            end case;
          when 11 =>
            this_isEdgeSharing_method_busy <= '0';
            isEdgeSharing_method_state <= (others => '0');
          when others => isEdgeSharing_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --isEdgeSharing
  process(clk) --getPattern
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_getPattern_getPattern_0 <= (others => '0');
        array_index_operation_state_counter_getPattern_1 <= (others => '0');
        this_getPattern_method_busy <= '0';
        getPattern_method_state <= (others => '0');
        output_port_getPattern <= (others => '0');
      else
        case conv_integer(getPattern_method_state) is
          when 0 =>
            if(this_getPattern_method_request = '1') then
              this_getPattern_method_busy <= '1';
              getPattern_method_state <= getPattern_method_state + 1;
            else
              this_getPattern_method_busy <= '0';
            end if;
          when 1 =>
            if(this_getPattern_method_request = '0') then
              getPattern_method_state <= getPattern_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(array_index_operation_state_counter_getPattern_1) is
              when 0 =>
                table_data_raddr_field_wdata_writer_getPattern_method_state <= conv_std_logic_vector((conv_integer(input_port_getPattern_k(31 - 5 downto 0) & conv_std_logic_vector(0, 5))) + (conv_integer(input_port_getPattern_k(31 - 3 downto 0) & conv_std_logic_vector(0, 3))) + (conv_integer(input_port_getPattern_r(31 - 2 downto 0) & conv_std_logic_vector(0, 2))) + conv_integer(input_port_getPattern_r) + conv_integer(input_port_getPattern_i), table_data_raddr_field_wdata'length);
                array_index_operation_state_counter_getPattern_1 <= array_index_operation_state_counter_getPattern_1 + 1;
              when 1 =>
                array_index_operation_state_counter_getPattern_1 <= (others => '0');
                getPattern_method_state <= getPattern_method_state + 1;
              when others => array_index_operation_state_counter_getPattern_1 <= (others => '0');
            end case;
          when 3 => 
            output_port_getPattern <= conv_std_logic_vector(conv_integer(table_data_rdata_field_rdata), output_port_getPattern'length);
            getPattern_method_state <= (others => '0');
          when 4 =>
            this_getPattern_method_busy <= '0';
            getPattern_method_state <= (others => '0');
          when others => getPattern_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --getPattern
  process(clk) --put
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_put_put_0 <= (others => '0');
        array_index_operation_state_counter_put_1 <= (others => '0');
        array_index_operation_state_counter_put_2 <= (others => '0');
        this_put_method_busy <= '0';
        put_method_state <= (others => '0');
        map_wdata_field_wdata_reset <= (others => '0');
        sym_wdata_field_wdata_reset <= (others => '0');
      else
        case conv_integer(put_method_state) is
          when 0 =>
            if(this_put_method_request_field_rdata = '1') then
              this_put_method_busy <= '1';
              put_method_state <= put_method_state + 1;
            else
              this_put_method_busy <= '0';
            end if;
          when 1 =>
            if(this_put_method_request_field_rdata = '0') then
              put_method_state <= put_method_state + 1;
            end if;
          when 2 => 
            map_waddr_field_wdata_writer_put_method_state <= conv_std_logic_vector((conv_integer(this_input_port_put_y_field_rdata(31 - 4 downto 0) & conv_std_logic_vector(0, 4))) + conv_integer(this_input_port_put_x_field_rdata), map_waddr_field_wdata'length);
            map_we_field_wdata_writer_put_method_state <= conv_std_logic_vector(1, map_we_field_wdata'length);
            map_wdata_field_wdata_writer_put_method_state <= conv_std_logic_vector(conv_integer(this_input_port_put_c_field_rdata), map_wdata_field_wdata'length);
            put_method_state <= put_method_state + 1;
          when 3 => 
            sym_waddr_field_wdata_writer_put_method_state <= conv_std_logic_vector((conv_integer(this_input_port_put_y_field_rdata(31 - 4 downto 0) & conv_std_logic_vector(0, 4))) + conv_integer(this_input_port_put_x_field_rdata), sym_waddr_field_wdata'length);
            sym_we_field_wdata_writer_put_method_state <= conv_std_logic_vector(1, sym_we_field_wdata'length);
            sym_wdata_field_wdata_writer_put_method_state <= conv_std_logic_vector(conv_integer(this_input_port_put_s_field_rdata), sym_wdata_field_wdata'length);
            put_method_state <= put_method_state + 1;
          when 6 =>
            this_put_method_busy <= '0';
            put_method_state <= (others => '0');
          when others => put_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --put
  process(clk) --isInsideAndEmpty
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_isInsideAndEmpty_isInsideAndEmpty_0 <= (others => '0');
        x_isInsideAndEmpty_0 <= (others => '0');
        y_isInsideAndEmpty_0 <= (others => '0');
        state_counter_isInsideAndEmpty_isInsideAndEmpty_1 <= (others => '0');
        i_isInsideAndEmpty_1 <= (others => '0');
        state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= (others => '0');
        array_index_operation_state_counter_isInsideAndEmpty_3 <= (others => '0');
        array_index_operation_state_counter_isInsideAndEmpty_4 <= (others => '0');
        state_counter_isInsideAndEmpty_isInsideAndEmpty_5 <= (others => '0');
        isInsideAndEmpty_if_flag_isInsideAndEmpty_6_isInsideAndEmpty_2 <= '0';
        state_counter_isInsideAndEmpty_isInsideAndEmpty_7 <= (others => '0');
        state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= (others => '0');
        isInsideAndEmpty_if_flag_isInsideAndEmpty_9_isInsideAndEmpty_5 <= '0';
        array_index_operation_state_counter_isInsideAndEmpty_10 <= (others => '0');
        state_counter_isInsideAndEmpty_isInsideAndEmpty_11 <= (others => '0');
        this_isInsideAndEmpty_method_busy <= '0';
        isInsideAndEmpty_method_state <= (others => '0');
        this_output_port_isInsideAndEmpty <= '0';
      else
        case conv_integer(isInsideAndEmpty_method_state) is
          when 0 =>
            if(this_isInsideAndEmpty_method_request_field_rdata = '1') then
              this_isInsideAndEmpty_method_busy <= '1';
              isInsideAndEmpty_method_state <= isInsideAndEmpty_method_state + 1;
            else
              this_isInsideAndEmpty_method_busy <= '0';
            end if;
          when 1 =>
            if(this_isInsideAndEmpty_method_request_field_rdata = '0') then
              isInsideAndEmpty_method_state <= isInsideAndEmpty_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(state_counter_isInsideAndEmpty_isInsideAndEmpty_1) is
              when 0 => state_counter_isInsideAndEmpty_isInsideAndEmpty_1 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_1 + 1;
              when 1 =>
                i_isInsideAndEmpty_1 <= conv_std_logic_vector(0, i_isInsideAndEmpty_1'length);
                state_counter_isInsideAndEmpty_isInsideAndEmpty_1 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_1 + 1;
              when 2 =>
                if (conv_integer(i_isInsideAndEmpty_1) < conv_integer(check_len_field_rdata)) then
                  state_counter_isInsideAndEmpty_isInsideAndEmpty_1 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_1 + 1;
                  state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= conv_std_logic_vector(1, state_counter_isInsideAndEmpty_isInsideAndEmpty_2'length);
                else
                  isInsideAndEmpty_method_state <= isInsideAndEmpty_method_state + 1;
                  state_counter_isInsideAndEmpty_isInsideAndEmpty_1 <= (others => '0');
                end if;
              when 3 =>
                case conv_integer(state_counter_isInsideAndEmpty_isInsideAndEmpty_2) is
                  when 0 => state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_2 + 1;
                  when 1 =>
                    case conv_integer(array_index_operation_state_counter_isInsideAndEmpty_3) is
                      when 0 =>
                        check_x_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= conv_std_logic_vector(conv_integer(i_isInsideAndEmpty_1), check_x_raddr_field_wdata'length);
                        array_index_operation_state_counter_isInsideAndEmpty_3 <= array_index_operation_state_counter_isInsideAndEmpty_3 + 1;
                      when 1 =>
                        array_index_operation_state_counter_isInsideAndEmpty_3 <= (others => '0');
                        state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_2 + 1;
                      when others => array_index_operation_state_counter_isInsideAndEmpty_3 <= (others => '0');
                    end case;
                  when 2 =>
                    x_isInsideAndEmpty_0 <= conv_std_logic_vector(conv_integer(check_x_rdata_field_rdata), x_isInsideAndEmpty_0'length);
                    state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_2 + 1;
                  when 3 =>
                    case conv_integer(array_index_operation_state_counter_isInsideAndEmpty_4) is
                      when 0 =>
                        check_y_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= conv_std_logic_vector(conv_integer(i_isInsideAndEmpty_1), check_y_raddr_field_wdata'length);
                        array_index_operation_state_counter_isInsideAndEmpty_4 <= array_index_operation_state_counter_isInsideAndEmpty_4 + 1;
                      when 1 =>
                        array_index_operation_state_counter_isInsideAndEmpty_4 <= (others => '0');
                        state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_2 + 1;
                      when others => array_index_operation_state_counter_isInsideAndEmpty_4 <= (others => '0');
                    end case;
                  when 4 =>
                    y_isInsideAndEmpty_0 <= conv_std_logic_vector(conv_integer(check_y_rdata_field_rdata), y_isInsideAndEmpty_0'length);
                    state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_2 + 1;
                  when 5 =>
                    case conv_integer(state_counter_isInsideAndEmpty_isInsideAndEmpty_5) is
                      when 0 => state_counter_isInsideAndEmpty_isInsideAndEmpty_5 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_5 + 1;
                      when 1 =>
                        if (conv_integer(x_isInsideAndEmpty_0) < 0 or conv_integer(y_isInsideAndEmpty_0) < 0 or conv_integer(x_isInsideAndEmpty_0) >= COLS or conv_integer(y_isInsideAndEmpty_0) >= ROWS) then
                          isInsideAndEmpty_if_flag_isInsideAndEmpty_6_isInsideAndEmpty_2 <= '1';
                          state_counter_isInsideAndEmpty_isInsideAndEmpty_7 <= conv_std_logic_vector(1, state_counter_isInsideAndEmpty_isInsideAndEmpty_7'length);
                        else
                          isInsideAndEmpty_if_flag_isInsideAndEmpty_6_isInsideAndEmpty_2 <= '0';
                        end if;
                        state_counter_isInsideAndEmpty_isInsideAndEmpty_5 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_5 + 1;
                      when 2 =>
                        if (isInsideAndEmpty_if_flag_isInsideAndEmpty_6_isInsideAndEmpty_2 = '1') then
                          case conv_integer(state_counter_isInsideAndEmpty_isInsideAndEmpty_7) is
                            when 0 => state_counter_isInsideAndEmpty_isInsideAndEmpty_7 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_7 + 1;
                            when 1 =>
                              this_output_port_isInsideAndEmpty <= '0';
                              state_counter_isInsideAndEmpty_isInsideAndEmpty_7 <= (others => '0');
                              state_counter_isInsideAndEmpty_isInsideAndEmpty_5 <= (others => '0');
                              state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= (others => '0');
                              state_counter_isInsideAndEmpty_isInsideAndEmpty_1 <= (others => '0');
                              isInsideAndEmpty_method_state <= (others => '0');
                            when 2 =>
                              state_counter_isInsideAndEmpty_isInsideAndEmpty_5 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_5 + 1;
                              state_counter_isInsideAndEmpty_isInsideAndEmpty_7 <= (others => '0');
                            when others => state_counter_isInsideAndEmpty_isInsideAndEmpty_7 <= (others => '0');
                          end case;
                        else
                          case conv_integer(state_counter_isInsideAndEmpty_isInsideAndEmpty_8) is
                            when 0 => state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_8 + 1;
                            when 1 =>
                              case conv_integer(array_index_operation_state_counter_isInsideAndEmpty_10) is
                                when 0 =>
                                  map_raddr_field_wdata_writer_state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= conv_std_logic_vector((conv_integer(y_isInsideAndEmpty_0(31 - 4 downto 0) & conv_std_logic_vector(0, 4))) + conv_integer(x_isInsideAndEmpty_0), map_raddr_field_wdata'length);
                                  array_index_operation_state_counter_isInsideAndEmpty_10 <= array_index_operation_state_counter_isInsideAndEmpty_10 + 1;
                                when 1 =>
                                  array_index_operation_state_counter_isInsideAndEmpty_10 <= (others => '0');
                                  state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_8 + 1;
                                when others => array_index_operation_state_counter_isInsideAndEmpty_10 <= (others => '0');
                              end case;
                            when 2 =>
                              if (conv_integer(map_rdata_field_rdata) /= NONE) then
                                isInsideAndEmpty_if_flag_isInsideAndEmpty_9_isInsideAndEmpty_5 <= '1';
                                state_counter_isInsideAndEmpty_isInsideAndEmpty_11 <= conv_std_logic_vector(1, state_counter_isInsideAndEmpty_isInsideAndEmpty_11'length);
                              else
                                isInsideAndEmpty_if_flag_isInsideAndEmpty_9_isInsideAndEmpty_5 <= '0';
                              end if;
                              state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_8 + 1;
                            when 3 =>
                              if (isInsideAndEmpty_if_flag_isInsideAndEmpty_9_isInsideAndEmpty_5 = '1') then
                                case conv_integer(state_counter_isInsideAndEmpty_isInsideAndEmpty_11) is
                                  when 0 => state_counter_isInsideAndEmpty_isInsideAndEmpty_11 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_11 + 1;
                                  when 1 =>
                                    this_output_port_isInsideAndEmpty <= '0';
                                    state_counter_isInsideAndEmpty_isInsideAndEmpty_11 <= (others => '0');
                                    state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= (others => '0');
                                    state_counter_isInsideAndEmpty_isInsideAndEmpty_5 <= (others => '0');
                                    state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= (others => '0');
                                    state_counter_isInsideAndEmpty_isInsideAndEmpty_1 <= (others => '0');
                                    isInsideAndEmpty_method_state <= (others => '0');
                                  when 2 =>
                                    state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_8 + 1;
                                    state_counter_isInsideAndEmpty_isInsideAndEmpty_11 <= (others => '0');
                                  when others => state_counter_isInsideAndEmpty_isInsideAndEmpty_11 <= (others => '0');
                                end case;
                              else
                                state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_8 + 1;
                              end if;
                            when 4 =>
                              state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= (others => '0');
                              state_counter_isInsideAndEmpty_isInsideAndEmpty_5 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_5 + 1;
                            when others =>
                              state_counter_isInsideAndEmpty_isInsideAndEmpty_8 <= (others => '0');
                          end case;
                        end if;
                      when 3 =>
                        state_counter_isInsideAndEmpty_isInsideAndEmpty_5 <= (others => '0');
                        state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_2 + 1;
                      when others =>
                        state_counter_isInsideAndEmpty_isInsideAndEmpty_5 <= (others => '0');
                    end case;
                  when 6 =>
                    state_counter_isInsideAndEmpty_isInsideAndEmpty_1 <= state_counter_isInsideAndEmpty_isInsideAndEmpty_1 + 1;
                    state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= (others => '0');
                  when others => state_counter_isInsideAndEmpty_isInsideAndEmpty_2 <= (others => '0');
                end case;
              when 4 =>
                  i_isInsideAndEmpty_1 <= conv_std_logic_vector(conv_integer(i_isInsideAndEmpty_1) + 1, i_isInsideAndEmpty_1'length);
                  state_counter_isInsideAndEmpty_isInsideAndEmpty_1 <= conv_std_logic_vector(2, 32);
              when others => state_counter_isInsideAndEmpty_isInsideAndEmpty_1 <= (others => '0');
            end case;
          when 3 => 
            this_output_port_isInsideAndEmpty <= '1';
            isInsideAndEmpty_method_state <= (others => '0');
          when 4 =>
            this_isInsideAndEmpty_method_busy <= '0';
            isInsideAndEmpty_method_state <= (others => '0');
          when others => isInsideAndEmpty_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --isInsideAndEmpty
  process(clk) --getSym
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_getSym_getSym_0 <= (others => '0');
        array_index_operation_state_counter_getSym_1 <= (others => '0');
        this_getSym_method_busy <= '0';
        getSym_method_state <= (others => '0');
        output_port_getSym <= (others => '0');
      else
        case conv_integer(getSym_method_state) is
          when 0 =>
            if(this_getSym_method_request = '1') then
              this_getSym_method_busy <= '1';
              getSym_method_state <= getSym_method_state + 1;
            else
              this_getSym_method_busy <= '0';
            end if;
          when 1 =>
            if(this_getSym_method_request = '0') then
              getSym_method_state <= getSym_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(array_index_operation_state_counter_getSym_1) is
              when 0 =>
                sym_raddr_field_wdata_writer_getSym_method_state <= conv_std_logic_vector((conv_integer(input_port_getSym_y(31 - 4 downto 0) & conv_std_logic_vector(0, 4))) + conv_integer(input_port_getSym_x), sym_raddr_field_wdata'length);
                array_index_operation_state_counter_getSym_1 <= array_index_operation_state_counter_getSym_1 + 1;
              when 1 =>
                array_index_operation_state_counter_getSym_1 <= (others => '0');
                getSym_method_state <= getSym_method_state + 1;
              when others => array_index_operation_state_counter_getSym_1 <= (others => '0');
            end case;
          when 3 => 
            output_port_getSym <= conv_std_logic_vector(conv_integer(sym_rdata_field_rdata), output_port_getSym'length);
            getSym_method_state <= (others => '0');
          when 4 =>
            this_getSym_method_busy <= '0';
            getSym_method_state <= (others => '0');
          when others => getSym_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --getSym
  process(clk) --isVertexSharing
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_isVertexSharing_isVertexSharing_0 <= (others => '0');
        flag0_isVertexSharing_0 <= '0';
        flag1_isVertexSharing_0 <= '0';
        flag2_isVertexSharing_0 <= '0';
        flag3_isVertexSharing_0 <= '0';
        this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
        this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
        state_counter_isVertexSharing_isVertexSharing_1 <= (others => '0');
        isVertexSharing_if_flag_isVertexSharing_2_isVertexSharing_0 <= '0';
        state_counter_isVertexSharing_isVertexSharing_3 <= (others => '0');
        state_counter_isVertexSharing_isVertexSharing_4 <= (others => '0');
        this_isVertexSharing_method_busy <= '0';
        isVertexSharing_method_state <= (others => '0');
        this_isDuplicated_method_request_field_wdata_reset <= '0';
        this_isDuplicated_method_request_field_wdata_reset <= '0';
        this_isDuplicated_method_request_field_wdata_reset <= '0';
        this_isDuplicated_method_request_field_wdata_reset <= '0';
        this_output_port_isVertexSharing <= '0';
      else
        case conv_integer(isVertexSharing_method_state) is
          when 0 =>
            if(this_isVertexSharing_method_request_field_rdata = '1') then
              this_isVertexSharing_method_busy <= '1';
              isVertexSharing_method_state <= isVertexSharing_method_state + 1;
            else
              this_isVertexSharing_method_busy <= '0';
            end if;
          when 1 =>
            if(this_isVertexSharing_method_request_field_rdata = '0') then
              isVertexSharing_method_state <= isVertexSharing_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(this_isDuplicated_call_state_counter_isVertexSharing_0) is
              when 0 =>
                if (this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_method_request_field_wdata_writer_isVertexSharing_method_state <= '1';
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= conv_std_logic_vector(1, this_isDuplicated_call_state_counter_isVertexSharing_0'length);
                end if;
              when 1 =>
                this_input_port_isDuplicated_c_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(conv_integer(this_input_port_isVertexSharing_c_field_rdata), this_input_port_isDuplicated_c_field_wdata'length);
                this_input_port_isDuplicated_dx_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(-1, this_input_port_isDuplicated_dx_field_wdata'length);
                this_input_port_isDuplicated_dy_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(-1, this_input_port_isDuplicated_dy_field_wdata'length);
                this_isDuplicated_method_request_field_wdata_writer_isVertexSharing_method_state <= '0';
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= conv_std_logic_vector(2, this_isDuplicated_call_state_counter_isVertexSharing_0'length);
              when 2 =>
                if (this_isDuplicated_method_request_field_wdata = '0' and this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
                  isVertexSharing_method_state <= isVertexSharing_method_state + 1;
                end if;
              when others => this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
            end case;
          when 3 => 
            flag0_isVertexSharing_0 <= this_output_port_isDuplicated;
            isVertexSharing_method_state <= isVertexSharing_method_state + 1;
          when 4 => 
            case conv_integer(this_isDuplicated_call_state_counter_isVertexSharing_0) is
              when 0 =>
                if (this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_method_request_field_wdata_writer_isVertexSharing_method_state <= '1';
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= conv_std_logic_vector(1, this_isDuplicated_call_state_counter_isVertexSharing_0'length);
                end if;
              when 1 =>
                this_input_port_isDuplicated_c_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(conv_integer(this_input_port_isVertexSharing_c_field_rdata), this_input_port_isDuplicated_c_field_wdata'length);
                this_input_port_isDuplicated_dx_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(1, this_input_port_isDuplicated_dx_field_wdata'length);
                this_input_port_isDuplicated_dy_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(-1, this_input_port_isDuplicated_dy_field_wdata'length);
                this_isDuplicated_method_request_field_wdata_writer_isVertexSharing_method_state <= '0';
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= conv_std_logic_vector(2, this_isDuplicated_call_state_counter_isVertexSharing_0'length);
              when 2 =>
                if (this_isDuplicated_method_request_field_wdata = '0' and this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
                  isVertexSharing_method_state <= isVertexSharing_method_state + 1;
                end if;
              when others => this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
            end case;
          when 5 => 
            flag1_isVertexSharing_0 <= this_output_port_isDuplicated;
            isVertexSharing_method_state <= isVertexSharing_method_state + 1;
          when 6 => 
            case conv_integer(this_isDuplicated_call_state_counter_isVertexSharing_0) is
              when 0 =>
                if (this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_method_request_field_wdata_writer_isVertexSharing_method_state <= '1';
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= conv_std_logic_vector(1, this_isDuplicated_call_state_counter_isVertexSharing_0'length);
                end if;
              when 1 =>
                this_input_port_isDuplicated_c_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(conv_integer(this_input_port_isVertexSharing_c_field_rdata), this_input_port_isDuplicated_c_field_wdata'length);
                this_input_port_isDuplicated_dx_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(-1, this_input_port_isDuplicated_dx_field_wdata'length);
                this_input_port_isDuplicated_dy_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(1, this_input_port_isDuplicated_dy_field_wdata'length);
                this_isDuplicated_method_request_field_wdata_writer_isVertexSharing_method_state <= '0';
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= conv_std_logic_vector(2, this_isDuplicated_call_state_counter_isVertexSharing_0'length);
              when 2 =>
                if (this_isDuplicated_method_request_field_wdata = '0' and this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
                  isVertexSharing_method_state <= isVertexSharing_method_state + 1;
                end if;
              when others => this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
            end case;
          when 7 => 
            flag2_isVertexSharing_0 <= this_output_port_isDuplicated;
            isVertexSharing_method_state <= isVertexSharing_method_state + 1;
          when 8 => 
            case conv_integer(this_isDuplicated_call_state_counter_isVertexSharing_0) is
              when 0 =>
                if (this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_method_request_field_wdata_writer_isVertexSharing_method_state <= '1';
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= conv_std_logic_vector(1, this_isDuplicated_call_state_counter_isVertexSharing_0'length);
                end if;
              when 1 =>
                this_input_port_isDuplicated_c_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(conv_integer(this_input_port_isVertexSharing_c_field_rdata), this_input_port_isDuplicated_c_field_wdata'length);
                this_input_port_isDuplicated_dx_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(1, this_input_port_isDuplicated_dx_field_wdata'length);
                this_input_port_isDuplicated_dy_field_wdata_writer_isVertexSharing_method_state <= conv_std_logic_vector(1, this_input_port_isDuplicated_dy_field_wdata'length);
                this_isDuplicated_method_request_field_wdata_writer_isVertexSharing_method_state <= '0';
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= conv_std_logic_vector(2, this_isDuplicated_call_state_counter_isVertexSharing_0'length);
              when 2 =>
                if (this_isDuplicated_method_request_field_wdata = '0' and this_isDuplicated_method_busy = '0') then
                  this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
                  isVertexSharing_method_state <= isVertexSharing_method_state + 1;
                end if;
              when others => this_isDuplicated_call_state_counter_isVertexSharing_0 <= (others => '0');
            end case;
          when 9 => 
            flag3_isVertexSharing_0 <= this_output_port_isDuplicated;
            isVertexSharing_method_state <= isVertexSharing_method_state + 1;
          when 10 => 
            case conv_integer(state_counter_isVertexSharing_isVertexSharing_1) is
              when 0 => state_counter_isVertexSharing_isVertexSharing_1 <= state_counter_isVertexSharing_isVertexSharing_1 + 1;
              when 1 =>
                if (flag0_isVertexSharing_0 = '1' or flag1_isVertexSharing_0 = '1' or flag2_isVertexSharing_0 = '1' or flag3_isVertexSharing_0 = '1') then
                  isVertexSharing_if_flag_isVertexSharing_2_isVertexSharing_0 <= '1';
                  state_counter_isVertexSharing_isVertexSharing_3 <= conv_std_logic_vector(1, state_counter_isVertexSharing_isVertexSharing_3'length);
                else
                  isVertexSharing_if_flag_isVertexSharing_2_isVertexSharing_0 <= '0';
                  state_counter_isVertexSharing_isVertexSharing_4 <= conv_std_logic_vector(1, state_counter_isVertexSharing_isVertexSharing_4'length);
                end if;
                state_counter_isVertexSharing_isVertexSharing_1 <= state_counter_isVertexSharing_isVertexSharing_1 + 1;
              when 2 =>
                if (isVertexSharing_if_flag_isVertexSharing_2_isVertexSharing_0 = '1') then
                  case conv_integer(state_counter_isVertexSharing_isVertexSharing_3) is
                    when 0 => state_counter_isVertexSharing_isVertexSharing_3 <= state_counter_isVertexSharing_isVertexSharing_3 + 1;
                    when 1 =>
                      this_output_port_isVertexSharing <= '1';
                      state_counter_isVertexSharing_isVertexSharing_3 <= (others => '0');
                      state_counter_isVertexSharing_isVertexSharing_1 <= (others => '0');
                      isVertexSharing_method_state <= (others => '0');
                    when 2 =>
                      state_counter_isVertexSharing_isVertexSharing_1 <= state_counter_isVertexSharing_isVertexSharing_1 + 1;
                      state_counter_isVertexSharing_isVertexSharing_3 <= (others => '0');
                    when others => state_counter_isVertexSharing_isVertexSharing_3 <= (others => '0');
                  end case;
                else
                  case conv_integer(state_counter_isVertexSharing_isVertexSharing_4) is
                    when 0 => state_counter_isVertexSharing_isVertexSharing_4 <= state_counter_isVertexSharing_isVertexSharing_4 + 1;
                    when 1 =>
                      this_output_port_isVertexSharing <= '0';
                      state_counter_isVertexSharing_isVertexSharing_4 <= (others => '0');
                      state_counter_isVertexSharing_isVertexSharing_1 <= (others => '0');
                      isVertexSharing_method_state <= (others => '0');
                    when 2 =>
                      state_counter_isVertexSharing_isVertexSharing_1 <= state_counter_isVertexSharing_isVertexSharing_1 + 1;
                      state_counter_isVertexSharing_isVertexSharing_4 <= (others => '0');
                    when others => state_counter_isVertexSharing_isVertexSharing_4 <= (others => '0');
                  end case;
                end if;
              when 3 =>
                state_counter_isVertexSharing_isVertexSharing_1 <= (others => '0');
                isVertexSharing_method_state <= isVertexSharing_method_state + 1;
              when others =>
                state_counter_isVertexSharing_isVertexSharing_1 <= (others => '0');
            end case;
          when 11 =>
            this_isVertexSharing_method_busy <= '0';
            isVertexSharing_method_state <= (others => '0');
          when others => isVertexSharing_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --isVertexSharing
  process(clk) --notify
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        notify_flag <= '0';
        this_notify_method_busy <= '0';
        notify_method_state <= (others => '0');
        state_counter_notify_notify_0 <= (others => '0');
      else
        case conv_integer(notify_method_state) is
          when 0 =>
            if(this_notify_method_request = '1') then
              this_notify_method_busy <= '1';
              notify_method_state <= notify_method_state + 1;
            else
              this_notify_method_busy <= '0';
            end if;
          when 1 =>
            if(this_notify_method_request = '0') then
              notify_method_state <= notify_method_state + 1;
            end if;
          when 2 => 
            notify_flag <= '1';
            notify_method_state <= notify_method_state + 1;
          when 3 => 
            notify_flag <= '0';
            notify_method_state <= notify_method_state + 1;
          when 4 =>
            this_notify_method_busy <= '0';
            notify_method_state <= (others => '0');
          when others => notify_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --notify
  process(clk) --isValid
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_isValid_isValid_0 <= (others => '0');
        this_setup_call_state_counter_isValid_0 <= (others => '0');
        this_setup_call_state_counter_isValid_0 <= (others => '0');
        state_counter_isValid_isValid_1 <= (others => '0');
        isValid_if_flag_isValid_2_isValid_0 <= '0';
        this_isInsideAndEmpty_call_state_counter_isValid_1 <= (others => '0');
        this_isInsideAndEmpty_call_state_counter_isValid_1 <= (others => '0');
        state_counter_isValid_isValid_3 <= (others => '0');
        state_counter_isValid_isValid_4 <= (others => '0');
        isValid_if_flag_isValid_5_isValid_0 <= '0';
        this_isEdgeSharing_call_state_counter_isValid_4 <= (others => '0');
        this_isEdgeSharing_call_state_counter_isValid_4 <= (others => '0');
        state_counter_isValid_isValid_6 <= (others => '0');
        state_counter_isValid_isValid_7 <= (others => '0');
        isValid_if_flag_isValid_8_isValid_0 <= '0';
        this_isVertexSharing_call_state_counter_isValid_7 <= (others => '0');
        this_isVertexSharing_call_state_counter_isValid_7 <= (others => '0');
        state_counter_isValid_isValid_9 <= (others => '0');
        this_isValid_method_busy <= '0';
        isValid_method_state <= (others => '0');
        this_setup_method_request_field_wdata_reset <= '0';
        output_port_isValid <= '0';
        this_isInsideAndEmpty_method_request_field_wdata_reset <= '0';
        this_isEdgeSharing_method_request_field_wdata_reset <= '0';
        this_isVertexSharing_method_request_field_wdata_reset <= '0';
      else
        case conv_integer(isValid_method_state) is
          when 0 =>
            if(this_isValid_method_request = '1') then
              this_isValid_method_busy <= '1';
              isValid_method_state <= isValid_method_state + 1;
            else
              this_isValid_method_busy <= '0';
            end if;
          when 1 =>
            if(this_isValid_method_request = '0') then
              isValid_method_state <= isValid_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(this_setup_call_state_counter_isValid_0) is
              when 0 =>
                if (this_setup_method_busy = '0') then
                  this_setup_method_request_field_wdata_writer_isValid_method_state <= '1';
                  this_setup_call_state_counter_isValid_0 <= conv_std_logic_vector(1, this_setup_call_state_counter_isValid_0'length);
                end if;
              when 1 =>
                this_input_port_setup_x_field_wdata_writer_isValid_method_state <= conv_std_logic_vector(conv_integer(input_port_isValid_x), this_input_port_setup_x_field_wdata'length);
                this_input_port_setup_y_field_wdata_writer_isValid_method_state <= conv_std_logic_vector(conv_integer(input_port_isValid_y), this_input_port_setup_y_field_wdata'length);
                this_input_port_setup_id_field_wdata_writer_isValid_method_state <= conv_std_logic_vector(conv_integer(input_port_isValid_id), this_input_port_setup_id_field_wdata'length);
                this_input_port_setup_rot_field_wdata_writer_isValid_method_state <= conv_std_logic_vector(conv_integer(input_port_isValid_rot), this_input_port_setup_rot_field_wdata'length);
                this_setup_method_request_field_wdata_writer_isValid_method_state <= '0';
                  this_setup_call_state_counter_isValid_0 <= conv_std_logic_vector(2, this_setup_call_state_counter_isValid_0'length);
              when 2 =>
                if (this_setup_method_request_field_wdata = '0' and this_setup_method_busy = '0') then
                  this_setup_call_state_counter_isValid_0 <= (others => '0');
                  isValid_method_state <= isValid_method_state + 1;
                end if;
              when others => this_setup_call_state_counter_isValid_0 <= (others => '0');
            end case;
          when 3 => 
            case conv_integer(state_counter_isValid_isValid_1) is
              when 0 => state_counter_isValid_isValid_1 <= state_counter_isValid_isValid_1 + 1;
              when 1 =>
                case conv_integer(this_isInsideAndEmpty_call_state_counter_isValid_1) is
                  when 0 =>
                    if (this_isInsideAndEmpty_method_busy = '0') then
                      this_isInsideAndEmpty_method_request_field_wdata_writer_state_counter_isValid_isValid_1 <= '1';
                      this_isInsideAndEmpty_call_state_counter_isValid_1 <= conv_std_logic_vector(1, this_isInsideAndEmpty_call_state_counter_isValid_1'length);
                    end if;
                  when 1 =>
                    this_isInsideAndEmpty_method_request_field_wdata_writer_state_counter_isValid_isValid_1 <= '0';
                      this_isInsideAndEmpty_call_state_counter_isValid_1 <= conv_std_logic_vector(2, this_isInsideAndEmpty_call_state_counter_isValid_1'length);
                  when 2 =>
                    if (this_isInsideAndEmpty_method_request_field_wdata = '0' and this_isInsideAndEmpty_method_busy = '0') then
                      this_isInsideAndEmpty_call_state_counter_isValid_1 <= (others => '0');
                      state_counter_isValid_isValid_1 <= state_counter_isValid_isValid_1 + 1;
                    end if;
                  when others => this_isInsideAndEmpty_call_state_counter_isValid_1 <= (others => '0');
                end case;
              when 2 =>
                if (this_output_port_isInsideAndEmpty = '0') then
                  isValid_if_flag_isValid_2_isValid_0 <= '1';
                  state_counter_isValid_isValid_3 <= conv_std_logic_vector(1, state_counter_isValid_isValid_3'length);
                else
                  isValid_if_flag_isValid_2_isValid_0 <= '0';
                end if;
                state_counter_isValid_isValid_1 <= state_counter_isValid_isValid_1 + 1;
              when 3 =>
                if (isValid_if_flag_isValid_2_isValid_0 = '1') then
                  case conv_integer(state_counter_isValid_isValid_3) is
                    when 0 => state_counter_isValid_isValid_3 <= state_counter_isValid_isValid_3 + 1;
                    when 1 =>
                      output_port_isValid <= '0';
                      state_counter_isValid_isValid_3 <= (others => '0');
                      state_counter_isValid_isValid_1 <= (others => '0');
                      isValid_method_state <= (others => '0');
                    when 2 =>
                      state_counter_isValid_isValid_1 <= state_counter_isValid_isValid_1 + 1;
                      state_counter_isValid_isValid_3 <= (others => '0');
                    when others => state_counter_isValid_isValid_3 <= (others => '0');
                  end case;
                else
                  state_counter_isValid_isValid_1 <= state_counter_isValid_isValid_1 + 1;
                end if;
              when 4 =>
                state_counter_isValid_isValid_1 <= (others => '0');
                isValid_method_state <= isValid_method_state + 1;
              when others =>
                state_counter_isValid_isValid_1 <= (others => '0');
            end case;
          when 4 => 
            case conv_integer(state_counter_isValid_isValid_4) is
              when 0 => state_counter_isValid_isValid_4 <= state_counter_isValid_isValid_4 + 1;
              when 1 =>
                case conv_integer(this_isEdgeSharing_call_state_counter_isValid_4) is
                  when 0 =>
                    if (this_isEdgeSharing_method_busy = '0') then
                      this_isEdgeSharing_method_request_field_wdata_writer_state_counter_isValid_isValid_4 <= '1';
                      this_isEdgeSharing_call_state_counter_isValid_4 <= conv_std_logic_vector(1, this_isEdgeSharing_call_state_counter_isValid_4'length);
                    end if;
                  when 1 =>
                    this_input_port_isEdgeSharing_c_field_wdata_writer_state_counter_isValid_isValid_4 <= conv_std_logic_vector(conv_integer(input_port_isValid_c), this_input_port_isEdgeSharing_c_field_wdata'length);
                    this_isEdgeSharing_method_request_field_wdata_writer_state_counter_isValid_isValid_4 <= '0';
                      this_isEdgeSharing_call_state_counter_isValid_4 <= conv_std_logic_vector(2, this_isEdgeSharing_call_state_counter_isValid_4'length);
                  when 2 =>
                    if (this_isEdgeSharing_method_request_field_wdata = '0' and this_isEdgeSharing_method_busy = '0') then
                      this_isEdgeSharing_call_state_counter_isValid_4 <= (others => '0');
                      state_counter_isValid_isValid_4 <= state_counter_isValid_isValid_4 + 1;
                    end if;
                  when others => this_isEdgeSharing_call_state_counter_isValid_4 <= (others => '0');
                end case;
              when 2 =>
                if (this_output_port_isEdgeSharing = '1') then
                  isValid_if_flag_isValid_5_isValid_0 <= '1';
                  state_counter_isValid_isValid_6 <= conv_std_logic_vector(1, state_counter_isValid_isValid_6'length);
                else
                  isValid_if_flag_isValid_5_isValid_0 <= '0';
                end if;
                state_counter_isValid_isValid_4 <= state_counter_isValid_isValid_4 + 1;
              when 3 =>
                if (isValid_if_flag_isValid_5_isValid_0 = '1') then
                  case conv_integer(state_counter_isValid_isValid_6) is
                    when 0 => state_counter_isValid_isValid_6 <= state_counter_isValid_isValid_6 + 1;
                    when 1 =>
                      output_port_isValid <= '0';
                      state_counter_isValid_isValid_6 <= (others => '0');
                      state_counter_isValid_isValid_4 <= (others => '0');
                      isValid_method_state <= (others => '0');
                    when 2 =>
                      state_counter_isValid_isValid_4 <= state_counter_isValid_isValid_4 + 1;
                      state_counter_isValid_isValid_6 <= (others => '0');
                    when others => state_counter_isValid_isValid_6 <= (others => '0');
                  end case;
                else
                  state_counter_isValid_isValid_4 <= state_counter_isValid_isValid_4 + 1;
                end if;
              when 4 =>
                state_counter_isValid_isValid_4 <= (others => '0');
                isValid_method_state <= isValid_method_state + 1;
              when others =>
                state_counter_isValid_isValid_4 <= (others => '0');
            end case;
          when 5 => 
            case conv_integer(state_counter_isValid_isValid_7) is
              when 0 => state_counter_isValid_isValid_7 <= state_counter_isValid_isValid_7 + 1;
              when 1 =>
                case conv_integer(this_isVertexSharing_call_state_counter_isValid_7) is
                  when 0 =>
                    if (this_isVertexSharing_method_busy = '0') then
                      this_isVertexSharing_method_request_field_wdata_writer_state_counter_isValid_isValid_7 <= '1';
                      this_isVertexSharing_call_state_counter_isValid_7 <= conv_std_logic_vector(1, this_isVertexSharing_call_state_counter_isValid_7'length);
                    end if;
                  when 1 =>
                    this_input_port_isVertexSharing_c_field_wdata_writer_state_counter_isValid_isValid_7 <= conv_std_logic_vector(conv_integer(input_port_isValid_c), this_input_port_isVertexSharing_c_field_wdata'length);
                    this_isVertexSharing_method_request_field_wdata_writer_state_counter_isValid_isValid_7 <= '0';
                      this_isVertexSharing_call_state_counter_isValid_7 <= conv_std_logic_vector(2, this_isVertexSharing_call_state_counter_isValid_7'length);
                  when 2 =>
                    if (this_isVertexSharing_method_request_field_wdata = '0' and this_isVertexSharing_method_busy = '0') then
                      this_isVertexSharing_call_state_counter_isValid_7 <= (others => '0');
                      state_counter_isValid_isValid_7 <= state_counter_isValid_isValid_7 + 1;
                    end if;
                  when others => this_isVertexSharing_call_state_counter_isValid_7 <= (others => '0');
                end case;
              when 2 =>
                if (this_output_port_isVertexSharing = '0') then
                  isValid_if_flag_isValid_8_isValid_0 <= '1';
                  state_counter_isValid_isValid_9 <= conv_std_logic_vector(1, state_counter_isValid_isValid_9'length);
                else
                  isValid_if_flag_isValid_8_isValid_0 <= '0';
                end if;
                state_counter_isValid_isValid_7 <= state_counter_isValid_isValid_7 + 1;
              when 3 =>
                if (isValid_if_flag_isValid_8_isValid_0 = '1') then
                  case conv_integer(state_counter_isValid_isValid_9) is
                    when 0 => state_counter_isValid_isValid_9 <= state_counter_isValid_isValid_9 + 1;
                    when 1 =>
                      output_port_isValid <= '0';
                      state_counter_isValid_isValid_9 <= (others => '0');
                      state_counter_isValid_isValid_7 <= (others => '0');
                      isValid_method_state <= (others => '0');
                    when 2 =>
                      state_counter_isValid_isValid_7 <= state_counter_isValid_isValid_7 + 1;
                      state_counter_isValid_isValid_9 <= (others => '0');
                    when others => state_counter_isValid_isValid_9 <= (others => '0');
                  end case;
                else
                  state_counter_isValid_isValid_7 <= state_counter_isValid_isValid_7 + 1;
                end if;
              when 4 =>
                state_counter_isValid_isValid_7 <= (others => '0');
                isValid_method_state <= isValid_method_state + 1;
              when others =>
                state_counter_isValid_isValid_7 <= (others => '0');
            end case;
          when 6 => 
            output_port_isValid <= '1';
            isValid_method_state <= (others => '0');
          when 7 =>
            this_isValid_method_busy <= '0';
            isValid_method_state <= (others => '0');
          when others => isValid_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --isValid
  process(clk) --init
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_init_init_0 <= (others => '0');
        state_counter_init_init_1 <= (others => '0');
        i_init_1 <= (others => '0');
        state_counter_init_init_2 <= (others => '0');
        array_index_operation_state_counter_init_3 <= (others => '0');
        array_index_operation_state_counter_init_4 <= (others => '0');
        this_init_method_busy <= '0';
        init_method_state <= (others => '0');
      else
        case conv_integer(init_method_state) is
          when 0 =>
            if(this_init_method_request = '1') then
              this_init_method_busy <= '1';
              init_method_state <= init_method_state + 1;
            else
              this_init_method_busy <= '0';
            end if;
          when 1 =>
            if(this_init_method_request = '0') then
              init_method_state <= init_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(state_counter_init_init_1) is
              when 0 => state_counter_init_init_1 <= state_counter_init_init_1 + 1;
              when 1 =>
                i_init_1 <= conv_std_logic_vector(0, i_init_1'length);
                state_counter_init_init_1 <= state_counter_init_init_1 + 1;
              when 2 =>
                if (conv_integer(i_init_1) < map_length) then
                  state_counter_init_init_1 <= state_counter_init_init_1 + 1;
                  state_counter_init_init_2 <= conv_std_logic_vector(1, state_counter_init_init_2'length);
                else
                  init_method_state <= init_method_state + 1;
                  state_counter_init_init_1 <= (others => '0');
                end if;
              when 3 =>
                case conv_integer(state_counter_init_init_2) is
                  when 0 => state_counter_init_init_2 <= state_counter_init_init_2 + 1;
                  when 1 =>
                    map_waddr_field_wdata_writer_state_counter_init_init_2 <= conv_std_logic_vector(conv_integer(i_init_1), map_waddr_field_wdata'length);
                    map_we_field_wdata_writer_state_counter_init_init_2 <= conv_std_logic_vector(1, map_we_field_wdata'length);
                    map_wdata_field_wdata_writer_state_counter_init_init_2 <= conv_std_logic_vector(NONE, map_wdata_field_wdata'length);
                    state_counter_init_init_2 <= state_counter_init_init_2 + 1;
                  when 2 =>
                    sym_waddr_field_wdata_writer_state_counter_init_init_2 <= conv_std_logic_vector(conv_integer(i_init_1), sym_waddr_field_wdata'length);
                    sym_we_field_wdata_writer_state_counter_init_init_2 <= conv_std_logic_vector(1, sym_we_field_wdata'length);
                    sym_wdata_field_wdata_writer_state_counter_init_init_2 <= conv_std_logic_vector(NONE, sym_wdata_field_wdata'length);
                    state_counter_init_init_1 <= state_counter_init_init_1 + 1;
                    state_counter_init_init_2 <= (others => '0');
                  when others => state_counter_init_init_2 <= (others => '0');
                end case;
              when 4 =>
                  i_init_1 <= conv_std_logic_vector(conv_integer(i_init_1) + 1, i_init_1'length);
                  state_counter_init_init_1 <= conv_std_logic_vector(2, 32);
              when others => state_counter_init_init_1 <= (others => '0');
            end case;
          when 3 =>
            this_init_method_busy <= '0';
            init_method_state <= (others => '0');
          when others => init_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --init
  process(clk) --isDuplicated
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_isDuplicated_isDuplicated_0 <= (others => '0');
        x_isDuplicated_0 <= (others => '0');
        y_isDuplicated_0 <= (others => '0');
        state_counter_isDuplicated_isDuplicated_1 <= (others => '0');
        i_isDuplicated_1 <= (others => '0');
        state_counter_isDuplicated_isDuplicated_2 <= (others => '0');
        array_index_operation_state_counter_isDuplicated_3 <= (others => '0');
        array_index_operation_state_counter_isDuplicated_4 <= (others => '0');
        state_counter_isDuplicated_isDuplicated_5 <= (others => '0');
        isDuplicated_if_flag_isDuplicated_6_isDuplicated_2 <= '0';
        state_counter_isDuplicated_isDuplicated_7 <= (others => '0');
        state_counter_isDuplicated_isDuplicated_8 <= (others => '0');
        isDuplicated_if_flag_isDuplicated_9_isDuplicated_7 <= '0';
        array_index_operation_state_counter_isDuplicated_10 <= (others => '0');
        state_counter_isDuplicated_isDuplicated_11 <= (others => '0');
        this_isDuplicated_method_busy <= '0';
        isDuplicated_method_state <= (others => '0');
        this_output_port_isDuplicated <= '0';
      else
        case conv_integer(isDuplicated_method_state) is
          when 0 =>
            if(this_isDuplicated_method_request_field_rdata = '1') then
              this_isDuplicated_method_busy <= '1';
              isDuplicated_method_state <= isDuplicated_method_state + 1;
            else
              this_isDuplicated_method_busy <= '0';
            end if;
          when 1 =>
            if(this_isDuplicated_method_request_field_rdata = '0') then
              isDuplicated_method_state <= isDuplicated_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(state_counter_isDuplicated_isDuplicated_1) is
              when 0 => state_counter_isDuplicated_isDuplicated_1 <= state_counter_isDuplicated_isDuplicated_1 + 1;
              when 1 =>
                i_isDuplicated_1 <= conv_std_logic_vector(0, i_isDuplicated_1'length);
                state_counter_isDuplicated_isDuplicated_1 <= state_counter_isDuplicated_isDuplicated_1 + 1;
              when 2 =>
                if (conv_integer(i_isDuplicated_1) < conv_integer(check_len_field_rdata)) then
                  state_counter_isDuplicated_isDuplicated_1 <= state_counter_isDuplicated_isDuplicated_1 + 1;
                  state_counter_isDuplicated_isDuplicated_2 <= conv_std_logic_vector(1, state_counter_isDuplicated_isDuplicated_2'length);
                else
                  isDuplicated_method_state <= isDuplicated_method_state + 1;
                  state_counter_isDuplicated_isDuplicated_1 <= (others => '0');
                end if;
              when 3 =>
                case conv_integer(state_counter_isDuplicated_isDuplicated_2) is
                  when 0 => state_counter_isDuplicated_isDuplicated_2 <= state_counter_isDuplicated_isDuplicated_2 + 1;
                  when 1 =>
                    case conv_integer(array_index_operation_state_counter_isDuplicated_3) is
                      when 0 =>
                        check_x_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_2 <= conv_std_logic_vector(conv_integer(i_isDuplicated_1), check_x_raddr_field_wdata'length);
                        array_index_operation_state_counter_isDuplicated_3 <= array_index_operation_state_counter_isDuplicated_3 + 1;
                      when 1 =>
                        array_index_operation_state_counter_isDuplicated_3 <= (others => '0');
                        state_counter_isDuplicated_isDuplicated_2 <= state_counter_isDuplicated_isDuplicated_2 + 1;
                      when others => array_index_operation_state_counter_isDuplicated_3 <= (others => '0');
                    end case;
                  when 2 =>
                    x_isDuplicated_0 <= conv_std_logic_vector(conv_integer(check_x_rdata_field_rdata) + conv_integer(this_input_port_isDuplicated_dx_field_rdata), x_isDuplicated_0'length);
                    state_counter_isDuplicated_isDuplicated_2 <= state_counter_isDuplicated_isDuplicated_2 + 1;
                  when 3 =>
                    case conv_integer(array_index_operation_state_counter_isDuplicated_4) is
                      when 0 =>
                        check_y_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_2 <= conv_std_logic_vector(conv_integer(i_isDuplicated_1), check_y_raddr_field_wdata'length);
                        array_index_operation_state_counter_isDuplicated_4 <= array_index_operation_state_counter_isDuplicated_4 + 1;
                      when 1 =>
                        array_index_operation_state_counter_isDuplicated_4 <= (others => '0');
                        state_counter_isDuplicated_isDuplicated_2 <= state_counter_isDuplicated_isDuplicated_2 + 1;
                      when others => array_index_operation_state_counter_isDuplicated_4 <= (others => '0');
                    end case;
                  when 4 =>
                    y_isDuplicated_0 <= conv_std_logic_vector(conv_integer(check_y_rdata_field_rdata) + conv_integer(this_input_port_isDuplicated_dy_field_rdata), y_isDuplicated_0'length);
                    state_counter_isDuplicated_isDuplicated_2 <= state_counter_isDuplicated_isDuplicated_2 + 1;
                  when 5 =>
                    case conv_integer(state_counter_isDuplicated_isDuplicated_5) is
                      when 0 => state_counter_isDuplicated_isDuplicated_5 <= state_counter_isDuplicated_isDuplicated_5 + 1;
                      when 1 =>
                        if (conv_integer(x_isDuplicated_0) >= 0 and conv_integer(y_isDuplicated_0) >= 0 and conv_integer(x_isDuplicated_0) < COLS and conv_integer(y_isDuplicated_0) < ROWS) then
                          isDuplicated_if_flag_isDuplicated_6_isDuplicated_2 <= '1';
                          state_counter_isDuplicated_isDuplicated_7 <= conv_std_logic_vector(1, state_counter_isDuplicated_isDuplicated_7'length);
                        else
                          isDuplicated_if_flag_isDuplicated_6_isDuplicated_2 <= '0';
                        end if;
                        state_counter_isDuplicated_isDuplicated_5 <= state_counter_isDuplicated_isDuplicated_5 + 1;
                      when 2 =>
                        if (isDuplicated_if_flag_isDuplicated_6_isDuplicated_2 = '1') then
                          case conv_integer(state_counter_isDuplicated_isDuplicated_7) is
                            when 0 => state_counter_isDuplicated_isDuplicated_7 <= state_counter_isDuplicated_isDuplicated_7 + 1;
                            when 1 =>
                              case conv_integer(state_counter_isDuplicated_isDuplicated_8) is
                                when 0 => state_counter_isDuplicated_isDuplicated_8 <= state_counter_isDuplicated_isDuplicated_8 + 1;
                                when 1 =>
                                  case conv_integer(array_index_operation_state_counter_isDuplicated_10) is
                                    when 0 =>
                                      map_raddr_field_wdata_writer_state_counter_isDuplicated_isDuplicated_8 <= conv_std_logic_vector((conv_integer(y_isDuplicated_0(31 - 4 downto 0) & conv_std_logic_vector(0, 4))) + conv_integer(x_isDuplicated_0), map_raddr_field_wdata'length);
                                      array_index_operation_state_counter_isDuplicated_10 <= array_index_operation_state_counter_isDuplicated_10 + 1;
                                    when 1 =>
                                      array_index_operation_state_counter_isDuplicated_10 <= (others => '0');
                                      state_counter_isDuplicated_isDuplicated_8 <= state_counter_isDuplicated_isDuplicated_8 + 1;
                                    when others => array_index_operation_state_counter_isDuplicated_10 <= (others => '0');
                                  end case;
                                when 2 =>
                                  if (conv_integer(map_rdata_field_rdata) = conv_integer(this_input_port_isDuplicated_c_field_rdata)) then
                                    isDuplicated_if_flag_isDuplicated_9_isDuplicated_7 <= '1';
                                    state_counter_isDuplicated_isDuplicated_11 <= conv_std_logic_vector(1, state_counter_isDuplicated_isDuplicated_11'length);
                                  else
                                    isDuplicated_if_flag_isDuplicated_9_isDuplicated_7 <= '0';
                                  end if;
                                  state_counter_isDuplicated_isDuplicated_8 <= state_counter_isDuplicated_isDuplicated_8 + 1;
                                when 3 =>
                                  if (isDuplicated_if_flag_isDuplicated_9_isDuplicated_7 = '1') then
                                    case conv_integer(state_counter_isDuplicated_isDuplicated_11) is
                                      when 0 => state_counter_isDuplicated_isDuplicated_11 <= state_counter_isDuplicated_isDuplicated_11 + 1;
                                      when 1 =>
                                        this_output_port_isDuplicated <= '1';
                                        state_counter_isDuplicated_isDuplicated_11 <= (others => '0');
                                        state_counter_isDuplicated_isDuplicated_8 <= (others => '0');
                                        state_counter_isDuplicated_isDuplicated_7 <= (others => '0');
                                        state_counter_isDuplicated_isDuplicated_5 <= (others => '0');
                                        state_counter_isDuplicated_isDuplicated_2 <= (others => '0');
                                        state_counter_isDuplicated_isDuplicated_1 <= (others => '0');
                                        isDuplicated_method_state <= (others => '0');
                                      when 2 =>
                                        state_counter_isDuplicated_isDuplicated_8 <= state_counter_isDuplicated_isDuplicated_8 + 1;
                                        state_counter_isDuplicated_isDuplicated_11 <= (others => '0');
                                      when others => state_counter_isDuplicated_isDuplicated_11 <= (others => '0');
                                    end case;
                                  else
                                    state_counter_isDuplicated_isDuplicated_8 <= state_counter_isDuplicated_isDuplicated_8 + 1;
                                  end if;
                                when 4 =>
                                  state_counter_isDuplicated_isDuplicated_8 <= (others => '0');
                                  state_counter_isDuplicated_isDuplicated_7 <= state_counter_isDuplicated_isDuplicated_7 + 1;
                                when others =>
                                  state_counter_isDuplicated_isDuplicated_8 <= (others => '0');
                              end case;
                            when 2 =>
                              state_counter_isDuplicated_isDuplicated_5 <= state_counter_isDuplicated_isDuplicated_5 + 1;
                              state_counter_isDuplicated_isDuplicated_7 <= (others => '0');
                            when others => state_counter_isDuplicated_isDuplicated_7 <= (others => '0');
                          end case;
                        else
                          state_counter_isDuplicated_isDuplicated_5 <= state_counter_isDuplicated_isDuplicated_5 + 1;
                        end if;
                      when 3 =>
                        state_counter_isDuplicated_isDuplicated_5 <= (others => '0');
                        state_counter_isDuplicated_isDuplicated_2 <= state_counter_isDuplicated_isDuplicated_2 + 1;
                      when others =>
                        state_counter_isDuplicated_isDuplicated_5 <= (others => '0');
                    end case;
                  when 6 =>
                    state_counter_isDuplicated_isDuplicated_1 <= state_counter_isDuplicated_isDuplicated_1 + 1;
                    state_counter_isDuplicated_isDuplicated_2 <= (others => '0');
                  when others => state_counter_isDuplicated_isDuplicated_2 <= (others => '0');
                end case;
              when 4 =>
                  i_isDuplicated_1 <= conv_std_logic_vector(conv_integer(i_isDuplicated_1) + 1, i_isDuplicated_1'length);
                  state_counter_isDuplicated_isDuplicated_1 <= conv_std_logic_vector(2, 32);
              when others => state_counter_isDuplicated_isDuplicated_1 <= (others => '0');
            end case;
          when 3 => 
            this_output_port_isDuplicated <= '0';
            isDuplicated_method_state <= (others => '0');
          when 4 =>
            this_isDuplicated_method_busy <= '0';
            isDuplicated_method_state <= (others => '0');
          when others => isDuplicated_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --isDuplicated
end RTL;
