library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_signed.all;
entity net_wasamon_blokus_javarock_simpleplayer is
  port (
    notify_method_busy : OUT std_logic;
    getNextMove_method_busy : OUT std_logic;
    setOpponentMove_method_busy : OUT std_logic;
    init_method_busy : OUT std_logic;
    output_port_getNextMove : OUT std_logic_vector(31 downto 0);
    setTurnCode_method_busy : OUT std_logic;
    getFirstMoveCode_method_busy : OUT std_logic;
    output_port_getFirstMoveCode : OUT std_logic_vector(31 downto 0);
    setTurnCode_method_request : IN std_logic;
    clk : IN std_logic;
    notify_method_request : IN std_logic;
    input_port_setOpponentMove_rot : IN std_logic_vector(31 downto 0);
    input_port_setOpponentMove_y : IN std_logic_vector(31 downto 0);
    getFirstMoveCode_method_request : IN std_logic;
    input_port_setOpponentMove_x : IN std_logic_vector(31 downto 0);
    getNextMove_method_request : IN std_logic;
    reset : IN std_logic;
    input_port_setTurnCode_v : IN std_logic_vector(31 downto 0);
    input_port_getFirstMoveCode_y : IN std_logic_vector(31 downto 0);
    input_port_setOpponentMove_id : IN std_logic_vector(31 downto 0);
    input_port_getFirstMoveCode_x : IN std_logic_vector(31 downto 0);
    setOpponentMove_method_request : IN std_logic;
    init_method_request : IN std_logic
  );
end net_wasamon_blokus_javarock_simpleplayer;

architecture RTL of net_wasamon_blokus_javarock_simpleplayer is
  component net_wasamon_blokus_javarock_blokusboard
    port (
      output_port_getSym : OUT std_logic_vector(7 downto 0);
      notify_method_busy : OUT std_logic;
      output_port_get : OUT std_logic_vector(31 downto 0);
      init_method_busy : OUT std_logic;
      getSym_method_busy : OUT std_logic;
      output_port_getPattern : OUT std_logic_vector(7 downto 0);
      output_port_isValid : OUT std_logic;
      move_method_busy : OUT std_logic;
      get_method_busy : OUT std_logic;
      isValid_method_busy : OUT std_logic;
      getPattern_method_busy : OUT std_logic;
      notify_method_request : IN std_logic;
      getSym_method_request : IN std_logic;
      input_port_move_c : IN std_logic_vector(31 downto 0);
      isValid_method_request : IN std_logic;
      input_port_isValid_c : IN std_logic_vector(31 downto 0);
      clk : IN std_logic;
      input_port_move_rot : IN std_logic_vector(31 downto 0);
      init_method_request : IN std_logic;
      input_port_move_id : IN std_logic_vector(31 downto 0);
      input_port_get_y : IN std_logic_vector(31 downto 0);
      input_port_get_x : IN std_logic_vector(31 downto 0);
      input_port_isValid_rot : IN std_logic_vector(31 downto 0);
      input_port_isValid_id : IN std_logic_vector(31 downto 0);
      input_port_getPattern_r : IN std_logic_vector(31 downto 0);
      input_port_getSym_y : IN std_logic_vector(31 downto 0);
      input_port_getSym_x : IN std_logic_vector(31 downto 0);
      input_port_move_y : IN std_logic_vector(31 downto 0);
      input_port_move_x : IN std_logic_vector(31 downto 0);
      getPattern_method_request : IN std_logic;
      move_method_request : IN std_logic;
      input_port_getPattern_k : IN std_logic_vector(31 downto 0);
      input_port_isValid_y : IN std_logic_vector(31 downto 0);
      input_port_getPattern_i : IN std_logic_vector(31 downto 0);
      input_port_isValid_x : IN std_logic_vector(31 downto 0);
      reset : IN std_logic;
      get_method_request : IN std_logic
    );
  end component;
  constant ROWS : integer := 14;
  constant ORANGE : integer := 2;
  constant COLS : integer := 14;
  constant BLUE : integer := 1;
  constant NONE : integer := 0;
  signal myColor_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal myColor_field_wdata_reset_strobe : std_logic := '0';
  signal myColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal myColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_3 : std_logic := '0';
  signal myColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal myColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_4 : std_logic := '0';
  signal myColor_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal myColor_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal turnCode_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal turnCode_field_wdata_reset_strobe : std_logic := '0';
  signal turnCode_field_wdata_writer_setTurnCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal turnCode_field_wdata_writer_strobe_setTurnCode_method_state : std_logic := '0';
  signal turnCode_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal turnCode_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_id_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_id_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_move_id_field_wdata_writer_setOpponentMove_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_id_field_wdata_writer_strobe_setOpponentMove_method_state : std_logic := '0';
  signal board_input_port_move_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal board_input_port_move_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal board_input_port_move_id_field_wdata_writer_getFirstMoveCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_id_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal board_input_port_move_id_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_id_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal nextId_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal nextId_field_wdata_reset_strobe : std_logic := '0';
  signal nextId_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal nextId_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal nextId_field_wdata_writer_state_counter_getNextMove2_getNextMove2_2 : std_logic_vector(31 downto 0) := (others => '0');
  signal nextId_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_2 : std_logic := '0';
  signal nextId_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal nextId_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal nextId_field_wdata_writer_state_counter_getNextMove1_getNextMove1_2 : std_logic_vector(31 downto 0) := (others => '0');
  signal nextId_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_2 : std_logic := '0';
  signal nextId_field_wdata_writer_getFirstMoveCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal nextId_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal nextId_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal nextId_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_getPattern_method_request_field_wdata_reset : std_logic := '0';
  signal board_getPattern_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal board_getPattern_method_request_field_rdata : std_logic := '0';
  signal board_getPattern_method_request_field_wdata : std_logic := '0';
  signal board_input_port_getPattern_r_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getPattern_r_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_getPattern_r_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getPattern_r_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_output_port_get_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_output_port_get_field_wdata_reset_strobe : std_logic := '0';
  signal board_output_port_get_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_output_port_get_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_wait_method_request_field_wdata_reset : std_logic := '0';
  signal this_wait_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_wait_method_request_field_rdata : std_logic := '0';
  signal this_wait_method_request_field_wdata : std_logic := '0';
  signal board_input_port_move_c_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_c_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_move_c_field_wdata_writer_setOpponentMove_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_c_field_wdata_writer_strobe_setOpponentMove_method_state : std_logic := '0';
  signal board_input_port_move_c_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_c_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal board_input_port_move_c_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_c_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal board_input_port_move_c_field_wdata_writer_getFirstMoveCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_c_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal board_input_port_move_c_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_c_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_notify_method_request_field_wdata_reset : std_logic := '0';
  signal board_notify_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal board_notify_method_request_field_rdata : std_logic := '0';
  signal board_notify_method_request_field_wdata : std_logic := '0';
  signal board_input_port_getPattern_k_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getPattern_k_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_getPattern_k_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getPattern_k_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getPattern_i_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getPattern_i_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_getPattern_i_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getPattern_i_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_getSym_method_request_field_wdata_reset : std_logic := '0';
  signal board_getSym_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal board_getSym_method_request_field_rdata : std_logic := '0';
  signal board_getSym_method_request_field_wdata : std_logic := '0';
  signal this_encode_method_request_field_wdata_reset : std_logic := '0';
  signal this_encode_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_encode_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal this_encode_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal this_encode_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal this_encode_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal this_encode_method_request_field_wdata_writer_getFirstMoveCode_method_state : std_logic := '0';
  signal this_encode_method_request_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal this_encode_method_request_field_rdata : std_logic := '0';
  signal this_encode_method_request_field_wdata : std_logic := '0';
  signal board_init_method_busy_field_wdata_reset : std_logic := '0';
  signal board_init_method_busy_field_wdata_reset_strobe : std_logic := '0';
  signal board_init_method_busy_field_rdata : std_logic := '0';
  signal board_init_method_busy_field_wdata : std_logic := '0';
  signal board_input_port_isValid_rot_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_rot_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_isValid_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 : std_logic := '0';
  signal board_input_port_isValid_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 : std_logic := '0';
  signal board_input_port_isValid_rot_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_rot_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal opponentColor_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal opponentColor_field_wdata_reset_strobe : std_logic := '0';
  signal opponentColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal opponentColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_3 : std_logic := '0';
  signal opponentColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal opponentColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_4 : std_logic := '0';
  signal opponentColor_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal opponentColor_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_get_y_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_get_y_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_get_y_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_get_y_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_get_x_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_get_x_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_get_x_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_get_x_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_getNextMove2_method_request_field_wdata_reset : std_logic := '0';
  signal this_getNextMove2_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_getNextMove2_method_request_field_wdata_writer_state_counter_getNextMove_getNextMove_7 : std_logic := '0';
  signal this_getNextMove2_method_request_field_wdata_writer_strobe_state_counter_getNextMove_getNextMove_7 : std_logic := '0';
  signal this_getNextMove2_method_request_field_rdata : std_logic := '0';
  signal this_getNextMove2_method_request_field_wdata : std_logic := '0';
  signal board_init_method_request_field_wdata_reset : std_logic := '0';
  signal board_init_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal board_init_method_request_field_wdata_writer_init_method_state : std_logic := '0';
  signal board_init_method_request_field_wdata_writer_strobe_init_method_state : std_logic := '0';
  signal board_init_method_request_field_rdata : std_logic := '0';
  signal board_init_method_request_field_wdata : std_logic := '0';
  signal board_output_port_isValid_field_wdata_reset : std_logic := '0';
  signal board_output_port_isValid_field_wdata_reset_strobe : std_logic := '0';
  signal board_output_port_isValid_field_rdata : std_logic := '0';
  signal board_output_port_isValid_field_wdata : std_logic := '0';
  signal this_getNextMove1_method_request_field_wdata_reset : std_logic := '0';
  signal this_getNextMove1_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal this_getNextMove1_method_request_field_wdata_writer_state_counter_getNextMove_getNextMove_6 : std_logic := '0';
  signal this_getNextMove1_method_request_field_wdata_writer_strobe_state_counter_getNextMove_getNextMove_6 : std_logic := '0';
  signal this_getNextMove1_method_request_field_rdata : std_logic := '0';
  signal this_getNextMove1_method_request_field_wdata : std_logic := '0';
  signal board_input_port_getSym_y_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getSym_y_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_getSym_y_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getSym_y_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getSym_x_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getSym_x_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_getSym_x_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_getSym_x_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_rot_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_rot_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_encode_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal this_input_port_encode_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal this_input_port_encode_rot_field_wdata_writer_getFirstMoveCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_rot_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal this_input_port_encode_rot_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_rot_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_y_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_y_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_isValid_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 : std_logic := '0';
  signal board_input_port_isValid_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 : std_logic := '0';
  signal board_input_port_isValid_y_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_y_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_x_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_x_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_isValid_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 : std_logic := '0';
  signal board_input_port_isValid_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 : std_logic := '0';
  signal board_input_port_isValid_x_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_x_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_output_port_getSym_field_wdata_reset : std_logic_vector(7 downto 0) := (others => '0');
  signal board_output_port_getSym_field_wdata_reset_strobe : std_logic := '0';
  signal board_output_port_getSym_field_rdata : std_logic_vector(7 downto 0) := (others => '0');
  signal board_output_port_getSym_field_wdata : std_logic_vector(7 downto 0) := (others => '0');
  signal this_input_port_encode_id_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_id_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_encode_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal this_input_port_encode_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal this_input_port_encode_id_field_wdata_writer_getFirstMoveCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_id_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal this_input_port_encode_id_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_id_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_getPattern_method_busy_field_wdata_reset : std_logic := '0';
  signal board_getPattern_method_busy_field_wdata_reset_strobe : std_logic := '0';
  signal board_getPattern_method_busy_field_rdata : std_logic := '0';
  signal board_getPattern_method_busy_field_wdata : std_logic := '0';
  signal this_input_port_encode_y_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_y_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_encode_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal this_input_port_encode_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal this_input_port_encode_y_field_wdata_writer_getFirstMoveCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_y_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal this_input_port_encode_y_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_y_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_x_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_x_field_wdata_reset_strobe : std_logic := '0';
  signal this_input_port_encode_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal this_input_port_encode_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal this_input_port_encode_x_field_wdata_writer_getFirstMoveCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_x_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal this_input_port_encode_x_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_encode_x_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_get_method_busy_field_wdata_reset : std_logic := '0';
  signal board_get_method_busy_field_wdata_reset_strobe : std_logic := '0';
  signal board_get_method_busy_field_rdata : std_logic := '0';
  signal board_get_method_busy_field_wdata : std_logic := '0';
  signal board_isValid_method_busy_field_wdata_reset : std_logic := '0';
  signal board_isValid_method_busy_field_wdata_reset_strobe : std_logic := '0';
  signal board_isValid_method_busy_field_rdata : std_logic := '0';
  signal board_isValid_method_busy_field_wdata : std_logic := '0';
  signal board_move_method_busy_field_wdata_reset : std_logic := '0';
  signal board_move_method_busy_field_wdata_reset_strobe : std_logic := '0';
  signal board_move_method_busy_field_rdata : std_logic := '0';
  signal board_move_method_busy_field_wdata : std_logic := '0';
  signal board_input_port_move_rot_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_rot_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_move_rot_field_wdata_writer_setOpponentMove_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_rot_field_wdata_writer_strobe_setOpponentMove_method_state : std_logic := '0';
  signal board_input_port_move_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal board_input_port_move_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal board_input_port_move_rot_field_wdata_writer_getFirstMoveCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_rot_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal board_input_port_move_rot_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_rot_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_isValid_method_request_field_wdata_reset : std_logic := '0';
  signal board_isValid_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal board_isValid_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 : std_logic := '0';
  signal board_isValid_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 : std_logic := '0';
  signal board_isValid_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 : std_logic := '0';
  signal board_isValid_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 : std_logic := '0';
  signal board_isValid_method_request_field_rdata : std_logic := '0';
  signal board_isValid_method_request_field_wdata : std_logic := '0';
  signal board_input_port_isValid_c_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_c_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_isValid_c_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_c_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 : std_logic := '0';
  signal board_input_port_isValid_c_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_c_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 : std_logic := '0';
  signal board_input_port_isValid_c_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_c_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_output_port_getPattern_field_wdata_reset : std_logic_vector(7 downto 0) := (others => '0');
  signal board_output_port_getPattern_field_wdata_reset_strobe : std_logic := '0';
  signal board_output_port_getPattern_field_rdata : std_logic_vector(7 downto 0) := (others => '0');
  signal board_output_port_getPattern_field_wdata : std_logic_vector(7 downto 0) := (others => '0');
  signal board_notify_method_busy_field_wdata_reset : std_logic := '0';
  signal board_notify_method_busy_field_wdata_reset_strobe : std_logic := '0';
  signal board_notify_method_busy_field_rdata : std_logic := '0';
  signal board_notify_method_busy_field_wdata : std_logic := '0';
  signal board_get_method_request_field_wdata_reset : std_logic := '0';
  signal board_get_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal board_get_method_request_field_rdata : std_logic := '0';
  signal board_get_method_request_field_wdata : std_logic := '0';
  signal board_getSym_method_busy_field_wdata_reset : std_logic := '0';
  signal board_getSym_method_busy_field_wdata_reset_strobe : std_logic := '0';
  signal board_getSym_method_busy_field_rdata : std_logic := '0';
  signal board_getSym_method_busy_field_wdata : std_logic := '0';
  signal board_input_port_isValid_id_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_id_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_isValid_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 : std_logic := '0';
  signal board_input_port_isValid_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 : std_logic := '0';
  signal board_input_port_isValid_id_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_isValid_id_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_move_method_request_field_wdata_reset : std_logic := '0';
  signal board_move_method_request_field_wdata_reset_strobe : std_logic := '0';
  signal board_move_method_request_field_wdata_writer_setOpponentMove_method_state : std_logic := '0';
  signal board_move_method_request_field_wdata_writer_strobe_setOpponentMove_method_state : std_logic := '0';
  signal board_move_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal board_move_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal board_move_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal board_move_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal board_move_method_request_field_wdata_writer_getFirstMoveCode_method_state : std_logic := '0';
  signal board_move_method_request_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal board_move_method_request_field_rdata : std_logic := '0';
  signal board_move_method_request_field_wdata : std_logic := '0';
  signal board_input_port_move_y_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_y_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_move_y_field_wdata_writer_setOpponentMove_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_y_field_wdata_writer_strobe_setOpponentMove_method_state : std_logic := '0';
  signal board_input_port_move_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal board_input_port_move_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal board_input_port_move_y_field_wdata_writer_getFirstMoveCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_y_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal board_input_port_move_y_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_y_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_x_field_wdata_reset : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_x_field_wdata_reset_strobe : std_logic := '0';
  signal board_input_port_move_x_field_wdata_writer_setOpponentMove_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_x_field_wdata_writer_strobe_setOpponentMove_method_state : std_logic := '0';
  signal board_input_port_move_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 : std_logic := '0';
  signal board_input_port_move_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 : std_logic := '0';
  signal board_input_port_move_x_field_wdata_writer_getFirstMoveCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_x_field_wdata_writer_strobe_getFirstMoveCode_method_state : std_logic := '0';
  signal board_input_port_move_x_field_rdata : std_logic_vector(31 downto 0) := (others => '0');
  signal board_input_port_move_x_field_wdata : std_logic_vector(31 downto 0) := (others => '0');
  signal getNextMove_if_flag_getNextMove_2_getNextMove_0 : std_logic := '0';
  signal encode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_init_call_state_counter_init_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal code_getNextMove2_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_encode_method_busy : std_logic := '0';
  signal id_getFirstMoveCode_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal k_getNextMove1_10 : std_logic_vector(31 downto 0) := (others => '0');
  signal code_getNextMove1_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_getFirstMoveCode_y : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_getFirstMoveCode_x : std_logic_vector(31 downto 0) := (others => '0');
  signal k_getNextMove2_10 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_getNextMove1_method_busy : std_logic := '0';
  signal state_counter_getNextMove2_getNextMove2_9 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_8 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_7 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getFirstMoveCode_getFirstMoveCode_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_6 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_5 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_2 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_wait_method_busy : std_logic := '0';
  signal this_init_method_busy : std_logic := '0';
  signal getNextMove2_if_flag_getNextMove2_13_getNextMove2_11 : std_logic := '0';
  signal state_counter_encode_encode_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal notify_flag : std_logic := '0';
  signal getNextMove1_if_flag_getNextMove1_4_getNextMove1_2 : std_logic := '0';
  signal this_getNextMove_method_request : std_logic := '0';
  signal this_notify_method_busy : std_logic := '0';
  signal this_setTurnCode_method_busy : std_logic := '0';
  signal state_counter_init_init_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_move_call_state_counter_setOpponentMove_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal d_notify_flag : std_logic := '0';
  signal state_counter_getNextMove1_getNextMove1_9 : std_logic_vector(31 downto 0) := (others => '0');
  signal setOpponentMove_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_8 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_encode_call_state_counter_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_7 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_6 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_5 : std_logic_vector(31 downto 0) := (others => '0');
  signal setTurnCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_encode_call_state_counter_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_move_call_state_counter_getFirstMoveCode_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_2 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_init_method_request : std_logic := '0';
  signal init_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_encode_call_state_counter_getFirstMoveCode_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_output_port_encode : std_logic_vector(31 downto 0) := (others => '0');
  signal j_getNextMove2_8 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_setOpponentMove_setOpponentMove_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal wait_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal j_getNextMove1_8 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_getNextMove2_method_busy : std_logic := '0';
  signal getNextMove2_if_flag_getNextMove2_4_getNextMove2_2 : std_logic := '0';
  signal this_input_port_setOpponentMove_y : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setOpponentMove_x : std_logic_vector(31 downto 0) := (others => '0');
  signal this_output_port_getNextMove2 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_output_port_getNextMove1 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_notify_method_request : std_logic := '0';
  signal this_setOpponentMove_method_busy : std_logic := '0';
  signal state_counter_wait_wait_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal getNextMove_if_flag_getNextMove_5_getNextMove_0 : std_logic := '0';
  signal getFirstMoveCode_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_input_port_setTurnCode_v : std_logic_vector(31 downto 0) := (others => '0');
  signal this_getFirstMoveCode_method_request : std_logic := '0';
  signal this_setTurnCode_method_request : std_logic := '0';
  signal this_input_port_setOpponentMove_rot : std_logic_vector(31 downto 0) := (others => '0');
  signal this_setOpponentMove_method_request : std_logic := '0';
  signal i_getNextMove2_6 : std_logic_vector(31 downto 0) := (others => '0');
  signal notify_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal board_move_call_state_counter_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal i_getNextMove1_6 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_getNextMove_method_busy : std_logic := '0';
  signal board_move_call_state_counter_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_11 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove2_getNextMove2_10 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_14 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_isValid_call_state_counter_getNextMove1_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_11 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove1_getNextMove1_10 : std_logic_vector(31 downto 0) := (others => '0');
  signal board_isValid_call_state_counter_getNextMove2_12 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_notify_notify_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_getNextMove2_call_state_counter_getNextMove_7 : std_logic_vector(31 downto 0) := (others => '0');
  signal getNextMove_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal setTurnCode_if_flag_setTurnCode_2_setTurnCode_0 : std_logic := '0';
  signal rot_getFirstMoveCode_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal getNextMove2_method_state : std_logic_vector(31 downto 0) := (others => '0');
  signal this_getNextMove1_call_state_counter_getNextMove_6 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove_getNextMove_7 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove_getNextMove_6 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_setTurnCode_setTurnCode_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal this_getFirstMoveCode_method_busy : std_logic := '0';
  signal this_input_port_setOpponentMove_id : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_setTurnCode_setTurnCode_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove_getNextMove_4 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove_getNextMove_3 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_setTurnCode_setTurnCode_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_setTurnCode_setTurnCode_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal state_counter_getNextMove_getNextMove_1 : std_logic_vector(31 downto 0) := (others => '0');
  signal getNextMove1_if_flag_getNextMove1_13_getNextMove1_11 : std_logic := '0';
  signal state_counter_getNextMove_getNextMove_0 : std_logic_vector(31 downto 0) := (others => '0');
  signal getNextMove1_method_state : std_logic_vector(31 downto 0) := (others => '0');
begin
  U_board : net_wasamon_blokus_javarock_blokusboard
  port map(
    output_port_getSym => board_output_port_getSym_field_wdata,
    notify_method_busy => board_notify_method_busy_field_wdata,
    output_port_get => board_output_port_get_field_wdata,
    init_method_busy => board_init_method_busy_field_wdata,
    getSym_method_busy => board_getSym_method_busy_field_wdata,
    output_port_getPattern => board_output_port_getPattern_field_wdata,
    output_port_isValid => board_output_port_isValid_field_wdata,
    move_method_busy => board_move_method_busy_field_wdata,
    get_method_busy => board_get_method_busy_field_wdata,
    isValid_method_busy => board_isValid_method_busy_field_wdata,
    getPattern_method_busy => board_getPattern_method_busy_field_wdata,
    notify_method_request => board_notify_method_request_field_rdata,
    getSym_method_request => board_getSym_method_request_field_rdata,
    input_port_move_c => board_input_port_move_c_field_rdata,
    isValid_method_request => board_isValid_method_request_field_rdata,
    input_port_isValid_c => board_input_port_isValid_c_field_rdata,
    clk => clk,
    input_port_move_rot => board_input_port_move_rot_field_rdata,
    init_method_request => board_init_method_request_field_rdata,
    input_port_move_id => board_input_port_move_id_field_rdata,
    input_port_get_y => board_input_port_get_y_field_rdata,
    input_port_get_x => board_input_port_get_x_field_rdata,
    input_port_isValid_rot => board_input_port_isValid_rot_field_rdata,
    input_port_isValid_id => board_input_port_isValid_id_field_rdata,
    input_port_getPattern_r => board_input_port_getPattern_r_field_rdata,
    input_port_getSym_y => board_input_port_getSym_y_field_rdata,
    input_port_getSym_x => board_input_port_getSym_x_field_rdata,
    input_port_move_y => board_input_port_move_y_field_rdata,
    input_port_move_x => board_input_port_move_x_field_rdata,
    getPattern_method_request => board_getPattern_method_request_field_rdata,
    move_method_request => board_move_method_request_field_rdata,
    input_port_getPattern_k => board_input_port_getPattern_k_field_rdata,
    input_port_isValid_y => board_input_port_isValid_y_field_rdata,
    input_port_getPattern_i => board_input_port_getPattern_i_field_rdata,
    input_port_isValid_x => board_input_port_isValid_x_field_rdata,
    reset => reset,
    get_method_request => board_get_method_request_field_rdata
  );
  this_notify_method_request <= notify_method_request;
  notify_method_busy <= this_notify_method_busy;
  this_init_method_request <= init_method_request;
  init_method_busy <= this_init_method_busy;
  this_input_port_setTurnCode_v <= conv_std_logic_vector(conv_integer(input_port_setTurnCode_v), this_input_port_setTurnCode_v'length);
  this_setTurnCode_method_request <= setTurnCode_method_request;
  setTurnCode_method_busy <= this_setTurnCode_method_busy;
  this_input_port_setOpponentMove_x <= conv_std_logic_vector(conv_integer(input_port_setOpponentMove_x), this_input_port_setOpponentMove_x'length);
  this_input_port_setOpponentMove_y <= conv_std_logic_vector(conv_integer(input_port_setOpponentMove_y), this_input_port_setOpponentMove_y'length);
  this_input_port_setOpponentMove_id <= conv_std_logic_vector(conv_integer(input_port_setOpponentMove_id), this_input_port_setOpponentMove_id'length);
  this_input_port_setOpponentMove_rot <= conv_std_logic_vector(conv_integer(input_port_setOpponentMove_rot), this_input_port_setOpponentMove_rot'length);
  this_setOpponentMove_method_request <= setOpponentMove_method_request;
  setOpponentMove_method_busy <= this_setOpponentMove_method_busy;
  this_input_port_getFirstMoveCode_x <= conv_std_logic_vector(conv_integer(input_port_getFirstMoveCode_x), this_input_port_getFirstMoveCode_x'length);
  this_input_port_getFirstMoveCode_y <= conv_std_logic_vector(conv_integer(input_port_getFirstMoveCode_y), this_input_port_getFirstMoveCode_y'length);
  this_getFirstMoveCode_method_request <= getFirstMoveCode_method_request;
  getFirstMoveCode_method_busy <= this_getFirstMoveCode_method_busy;
  this_getNextMove_method_request <= getNextMove_method_request;
  getNextMove_method_busy <= this_getNextMove_method_busy;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        myColor_field_wdata <= myColor_field_wdata_reset;
      elsif (myColor_field_wdata_reset_strobe = '1') then
        myColor_field_wdata <= myColor_field_wdata_reset;
      elsif (myColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_3 = '1') then
        myColor_field_wdata <= myColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_3;
      elsif (myColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_4 = '1') then
        myColor_field_wdata <= myColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_4;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        myColor_field_wdata_reset_strobe <= '1';
      else
        myColor_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_setTurnCode_setTurnCode_3) = 1) then
        myColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_3 <= '1';
      else
        myColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_3 <= '0';
      end if;
      if (conv_integer(state_counter_setTurnCode_setTurnCode_4) = 1) then
        myColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_4 <= '1';
      else
        myColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_4 <= '0';
      end if;
    end if;
  end process;
  myColor_field_rdata <= myColor_field_wdata_reset when (reset = '1') else
        myColor_field_wdata_reset when (myColor_field_wdata_reset_strobe = '1') else
        myColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_3 when (myColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_3 = '1') else
        myColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_4 when (myColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_4 = '1') else
        myColor_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        turnCode_field_wdata <= turnCode_field_wdata_reset;
      elsif (turnCode_field_wdata_reset_strobe = '1') then
        turnCode_field_wdata <= turnCode_field_wdata_reset;
      elsif (turnCode_field_wdata_writer_strobe_setTurnCode_method_state = '1') then
        turnCode_field_wdata <= turnCode_field_wdata_writer_setTurnCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        turnCode_field_wdata_reset_strobe <= '1';
      else
        turnCode_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(setTurnCode_method_state) = 2) then
        turnCode_field_wdata_writer_strobe_setTurnCode_method_state <= '1';
      else
        turnCode_field_wdata_writer_strobe_setTurnCode_method_state <= '0';
      end if;
    end if;
  end process;
  turnCode_field_rdata <= turnCode_field_wdata_reset when (reset = '1') else
        turnCode_field_wdata_reset when (turnCode_field_wdata_reset_strobe = '1') else
        turnCode_field_wdata_writer_setTurnCode_method_state when (turnCode_field_wdata_writer_strobe_setTurnCode_method_state = '1') else
        turnCode_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_move_id_field_wdata <= board_input_port_move_id_field_wdata_reset;
      elsif (board_input_port_move_id_field_wdata_reset_strobe = '1') then
        board_input_port_move_id_field_wdata <= board_input_port_move_id_field_wdata_reset;
      elsif (board_input_port_move_id_field_wdata_writer_strobe_setOpponentMove_method_state = '1') then
        board_input_port_move_id_field_wdata <= board_input_port_move_id_field_wdata_writer_setOpponentMove_method_state;
      elsif (board_input_port_move_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        board_input_port_move_id_field_wdata <= board_input_port_move_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (board_input_port_move_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        board_input_port_move_id_field_wdata <= board_input_port_move_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (board_input_port_move_id_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        board_input_port_move_id_field_wdata <= board_input_port_move_id_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_move_id_field_wdata_reset_strobe <= '1';
      else
        board_input_port_move_id_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(setOpponentMove_method_state) = 2) then
        board_input_port_move_id_field_wdata_writer_strobe_setOpponentMove_method_state <= '1';
      else
        board_input_port_move_id_field_wdata_writer_strobe_setOpponentMove_method_state <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 1) then
        board_input_port_move_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        board_input_port_move_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 1) then
        board_input_port_move_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        board_input_port_move_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 3) then
        board_input_port_move_id_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        board_input_port_move_id_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  board_input_port_move_id_field_rdata <= board_input_port_move_id_field_wdata_reset when (reset = '1') else
        board_input_port_move_id_field_wdata_reset when (board_input_port_move_id_field_wdata_reset_strobe = '1') else
        board_input_port_move_id_field_wdata_writer_setOpponentMove_method_state when (board_input_port_move_id_field_wdata_writer_strobe_setOpponentMove_method_state = '1') else
        board_input_port_move_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (board_input_port_move_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        board_input_port_move_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (board_input_port_move_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        board_input_port_move_id_field_wdata_writer_getFirstMoveCode_method_state when (board_input_port_move_id_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        board_input_port_move_id_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        nextId_field_wdata <= nextId_field_wdata_reset;
      elsif (nextId_field_wdata_reset_strobe = '1') then
        nextId_field_wdata <= nextId_field_wdata_reset;
      elsif (nextId_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        nextId_field_wdata <= nextId_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (nextId_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_2 = '1') then
        nextId_field_wdata <= nextId_field_wdata_writer_state_counter_getNextMove2_getNextMove2_2;
      elsif (nextId_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        nextId_field_wdata <= nextId_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (nextId_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_2 = '1') then
        nextId_field_wdata <= nextId_field_wdata_writer_state_counter_getNextMove1_getNextMove1_2;
      elsif (nextId_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        nextId_field_wdata <= nextId_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        nextId_field_wdata_reset_strobe <= '1';
      else
        nextId_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 3) then
        nextId_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        nextId_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_2) = 3) then
        nextId_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_2 <= '1';
      else
        nextId_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_2 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 3) then
        nextId_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        nextId_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_2) = 3) then
        nextId_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_2 <= '1';
      else
        nextId_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_2 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 4) then
        nextId_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        nextId_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  nextId_field_rdata <= nextId_field_wdata_reset when (reset = '1') else
        nextId_field_wdata_reset when (nextId_field_wdata_reset_strobe = '1') else
        nextId_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (nextId_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        nextId_field_wdata_writer_state_counter_getNextMove2_getNextMove2_2 when (nextId_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_2 = '1') else
        nextId_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (nextId_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        nextId_field_wdata_writer_state_counter_getNextMove1_getNextMove1_2 when (nextId_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_2 = '1') else
        nextId_field_wdata_writer_getFirstMoveCode_method_state when (nextId_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        nextId_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_getPattern_method_request_field_wdata <= board_getPattern_method_request_field_wdata_reset;
      elsif (board_getPattern_method_request_field_wdata_reset_strobe = '1') then
        board_getPattern_method_request_field_wdata <= board_getPattern_method_request_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_getPattern_method_request_field_wdata_reset_strobe <= '1';
      else
        board_getPattern_method_request_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  board_getPattern_method_request_field_rdata <= board_getPattern_method_request_field_wdata_reset when (reset = '1') else
        board_getPattern_method_request_field_wdata_reset when (board_getPattern_method_request_field_wdata_reset_strobe = '1') else
        board_getPattern_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_getPattern_r_field_wdata <= board_input_port_getPattern_r_field_wdata_reset;
      elsif (board_input_port_getPattern_r_field_wdata_reset_strobe = '1') then
        board_input_port_getPattern_r_field_wdata <= board_input_port_getPattern_r_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_getPattern_r_field_wdata_reset_strobe <= '1';
      else
        board_input_port_getPattern_r_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  board_input_port_getPattern_r_field_rdata <= board_input_port_getPattern_r_field_wdata_reset when (reset = '1') else
        board_input_port_getPattern_r_field_wdata_reset when (board_input_port_getPattern_r_field_wdata_reset_strobe = '1') else
        board_input_port_getPattern_r_field_wdata;
  
  board_output_port_get_field_rdata <= board_output_port_get_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_wait_method_request_field_wdata <= this_wait_method_request_field_wdata_reset;
      elsif (this_wait_method_request_field_wdata_reset_strobe = '1') then
        this_wait_method_request_field_wdata <= this_wait_method_request_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_wait_method_request_field_wdata_reset_strobe <= '1';
      else
        this_wait_method_request_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  this_wait_method_request_field_rdata <= this_wait_method_request_field_wdata_reset when (reset = '1') else
        this_wait_method_request_field_wdata_reset when (this_wait_method_request_field_wdata_reset_strobe = '1') else
        this_wait_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_move_c_field_wdata <= board_input_port_move_c_field_wdata_reset;
      elsif (board_input_port_move_c_field_wdata_reset_strobe = '1') then
        board_input_port_move_c_field_wdata <= board_input_port_move_c_field_wdata_reset;
      elsif (board_input_port_move_c_field_wdata_writer_strobe_setOpponentMove_method_state = '1') then
        board_input_port_move_c_field_wdata <= board_input_port_move_c_field_wdata_writer_setOpponentMove_method_state;
      elsif (board_input_port_move_c_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        board_input_port_move_c_field_wdata <= board_input_port_move_c_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (board_input_port_move_c_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        board_input_port_move_c_field_wdata <= board_input_port_move_c_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (board_input_port_move_c_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        board_input_port_move_c_field_wdata <= board_input_port_move_c_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_move_c_field_wdata_reset_strobe <= '1';
      else
        board_input_port_move_c_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(setOpponentMove_method_state) = 2) then
        board_input_port_move_c_field_wdata_writer_strobe_setOpponentMove_method_state <= '1';
      else
        board_input_port_move_c_field_wdata_writer_strobe_setOpponentMove_method_state <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 1) then
        board_input_port_move_c_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        board_input_port_move_c_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 1) then
        board_input_port_move_c_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        board_input_port_move_c_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 3) then
        board_input_port_move_c_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        board_input_port_move_c_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  board_input_port_move_c_field_rdata <= board_input_port_move_c_field_wdata_reset when (reset = '1') else
        board_input_port_move_c_field_wdata_reset when (board_input_port_move_c_field_wdata_reset_strobe = '1') else
        board_input_port_move_c_field_wdata_writer_setOpponentMove_method_state when (board_input_port_move_c_field_wdata_writer_strobe_setOpponentMove_method_state = '1') else
        board_input_port_move_c_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (board_input_port_move_c_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        board_input_port_move_c_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (board_input_port_move_c_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        board_input_port_move_c_field_wdata_writer_getFirstMoveCode_method_state when (board_input_port_move_c_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        board_input_port_move_c_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_notify_method_request_field_wdata <= board_notify_method_request_field_wdata_reset;
      elsif (board_notify_method_request_field_wdata_reset_strobe = '1') then
        board_notify_method_request_field_wdata <= board_notify_method_request_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_notify_method_request_field_wdata_reset_strobe <= '1';
      else
        board_notify_method_request_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  board_notify_method_request_field_rdata <= board_notify_method_request_field_wdata_reset when (reset = '1') else
        board_notify_method_request_field_wdata_reset when (board_notify_method_request_field_wdata_reset_strobe = '1') else
        board_notify_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_getPattern_k_field_wdata <= board_input_port_getPattern_k_field_wdata_reset;
      elsif (board_input_port_getPattern_k_field_wdata_reset_strobe = '1') then
        board_input_port_getPattern_k_field_wdata <= board_input_port_getPattern_k_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_getPattern_k_field_wdata_reset_strobe <= '1';
      else
        board_input_port_getPattern_k_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  board_input_port_getPattern_k_field_rdata <= board_input_port_getPattern_k_field_wdata_reset when (reset = '1') else
        board_input_port_getPattern_k_field_wdata_reset when (board_input_port_getPattern_k_field_wdata_reset_strobe = '1') else
        board_input_port_getPattern_k_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_getPattern_i_field_wdata <= board_input_port_getPattern_i_field_wdata_reset;
      elsif (board_input_port_getPattern_i_field_wdata_reset_strobe = '1') then
        board_input_port_getPattern_i_field_wdata <= board_input_port_getPattern_i_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_getPattern_i_field_wdata_reset_strobe <= '1';
      else
        board_input_port_getPattern_i_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  board_input_port_getPattern_i_field_rdata <= board_input_port_getPattern_i_field_wdata_reset when (reset = '1') else
        board_input_port_getPattern_i_field_wdata_reset when (board_input_port_getPattern_i_field_wdata_reset_strobe = '1') else
        board_input_port_getPattern_i_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_getSym_method_request_field_wdata <= board_getSym_method_request_field_wdata_reset;
      elsif (board_getSym_method_request_field_wdata_reset_strobe = '1') then
        board_getSym_method_request_field_wdata <= board_getSym_method_request_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_getSym_method_request_field_wdata_reset_strobe <= '1';
      else
        board_getSym_method_request_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  board_getSym_method_request_field_rdata <= board_getSym_method_request_field_wdata_reset when (reset = '1') else
        board_getSym_method_request_field_wdata_reset when (board_getSym_method_request_field_wdata_reset_strobe = '1') else
        board_getSym_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_encode_method_request_field_wdata <= this_encode_method_request_field_wdata_reset;
      elsif (this_encode_method_request_field_wdata_reset_strobe = '1') then
        this_encode_method_request_field_wdata <= this_encode_method_request_field_wdata_reset;
      elsif (this_encode_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        this_encode_method_request_field_wdata <= this_encode_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (this_encode_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        this_encode_method_request_field_wdata <= this_encode_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (this_encode_method_request_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        this_encode_method_request_field_wdata <= this_encode_method_request_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_encode_method_request_field_wdata_reset_strobe <= '1';
      else
        this_encode_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 2 or conv_integer(state_counter_getNextMove2_getNextMove2_14) = 2) then
        this_encode_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        this_encode_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 2 or conv_integer(state_counter_getNextMove1_getNextMove1_14) = 2) then
        this_encode_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        this_encode_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 5 or conv_integer(getFirstMoveCode_method_state) = 5) then
        this_encode_method_request_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        this_encode_method_request_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  this_encode_method_request_field_rdata <= this_encode_method_request_field_wdata_reset when (reset = '1') else
        this_encode_method_request_field_wdata_reset when (this_encode_method_request_field_wdata_reset_strobe = '1') else
        this_encode_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (this_encode_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        this_encode_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (this_encode_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        this_encode_method_request_field_wdata_writer_getFirstMoveCode_method_state when (this_encode_method_request_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        this_encode_method_request_field_wdata;
  
  board_init_method_busy_field_rdata <= board_init_method_busy_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_isValid_rot_field_wdata <= board_input_port_isValid_rot_field_wdata_reset;
      elsif (board_input_port_isValid_rot_field_wdata_reset_strobe = '1') then
        board_input_port_isValid_rot_field_wdata <= board_input_port_isValid_rot_field_wdata_reset;
      elsif (board_input_port_isValid_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') then
        board_input_port_isValid_rot_field_wdata <= board_input_port_isValid_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12;
      elsif (board_input_port_isValid_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') then
        board_input_port_isValid_rot_field_wdata <= board_input_port_isValid_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_isValid_rot_field_wdata_reset_strobe <= '1';
      else
        board_input_port_isValid_rot_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_12) = 1) then
        board_input_port_isValid_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '1';
      else
        board_input_port_isValid_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_12) = 1) then
        board_input_port_isValid_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '1';
      else
        board_input_port_isValid_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '0';
      end if;
    end if;
  end process;
  board_input_port_isValid_rot_field_rdata <= board_input_port_isValid_rot_field_wdata_reset when (reset = '1') else
        board_input_port_isValid_rot_field_wdata_reset when (board_input_port_isValid_rot_field_wdata_reset_strobe = '1') else
        board_input_port_isValid_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 when (board_input_port_isValid_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') else
        board_input_port_isValid_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 when (board_input_port_isValid_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') else
        board_input_port_isValid_rot_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        opponentColor_field_wdata <= opponentColor_field_wdata_reset;
      elsif (opponentColor_field_wdata_reset_strobe = '1') then
        opponentColor_field_wdata <= opponentColor_field_wdata_reset;
      elsif (opponentColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_3 = '1') then
        opponentColor_field_wdata <= opponentColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_3;
      elsif (opponentColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_4 = '1') then
        opponentColor_field_wdata <= opponentColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_4;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        opponentColor_field_wdata_reset_strobe <= '1';
      else
        opponentColor_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_setTurnCode_setTurnCode_3) = 1) then
        opponentColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_3 <= '1';
      else
        opponentColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_3 <= '0';
      end if;
      if (conv_integer(state_counter_setTurnCode_setTurnCode_4) = 1) then
        opponentColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_4 <= '1';
      else
        opponentColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_4 <= '0';
      end if;
    end if;
  end process;
  opponentColor_field_rdata <= opponentColor_field_wdata_reset when (reset = '1') else
        opponentColor_field_wdata_reset when (opponentColor_field_wdata_reset_strobe = '1') else
        opponentColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_3 when (opponentColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_3 = '1') else
        opponentColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_4 when (opponentColor_field_wdata_writer_strobe_state_counter_setTurnCode_setTurnCode_4 = '1') else
        opponentColor_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_get_y_field_wdata <= board_input_port_get_y_field_wdata_reset;
      elsif (board_input_port_get_y_field_wdata_reset_strobe = '1') then
        board_input_port_get_y_field_wdata <= board_input_port_get_y_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_get_y_field_wdata_reset_strobe <= '1';
      else
        board_input_port_get_y_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  board_input_port_get_y_field_rdata <= board_input_port_get_y_field_wdata_reset when (reset = '1') else
        board_input_port_get_y_field_wdata_reset when (board_input_port_get_y_field_wdata_reset_strobe = '1') else
        board_input_port_get_y_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_get_x_field_wdata <= board_input_port_get_x_field_wdata_reset;
      elsif (board_input_port_get_x_field_wdata_reset_strobe = '1') then
        board_input_port_get_x_field_wdata <= board_input_port_get_x_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_get_x_field_wdata_reset_strobe <= '1';
      else
        board_input_port_get_x_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  board_input_port_get_x_field_rdata <= board_input_port_get_x_field_wdata_reset when (reset = '1') else
        board_input_port_get_x_field_wdata_reset when (board_input_port_get_x_field_wdata_reset_strobe = '1') else
        board_input_port_get_x_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_getNextMove2_method_request_field_wdata <= this_getNextMove2_method_request_field_wdata_reset;
      elsif (this_getNextMove2_method_request_field_wdata_reset_strobe = '1') then
        this_getNextMove2_method_request_field_wdata <= this_getNextMove2_method_request_field_wdata_reset;
      elsif (this_getNextMove2_method_request_field_wdata_writer_strobe_state_counter_getNextMove_getNextMove_7 = '1') then
        this_getNextMove2_method_request_field_wdata <= this_getNextMove2_method_request_field_wdata_writer_state_counter_getNextMove_getNextMove_7;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_getNextMove2_method_request_field_wdata_reset_strobe <= '1';
      else
        this_getNextMove2_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove_getNextMove_7) = 1 or conv_integer(state_counter_getNextMove_getNextMove_7) = 1) then
        this_getNextMove2_method_request_field_wdata_writer_strobe_state_counter_getNextMove_getNextMove_7 <= '1';
      else
        this_getNextMove2_method_request_field_wdata_writer_strobe_state_counter_getNextMove_getNextMove_7 <= '0';
      end if;
    end if;
  end process;
  this_getNextMove2_method_request_field_rdata <= this_getNextMove2_method_request_field_wdata_reset when (reset = '1') else
        this_getNextMove2_method_request_field_wdata_reset when (this_getNextMove2_method_request_field_wdata_reset_strobe = '1') else
        this_getNextMove2_method_request_field_wdata_writer_state_counter_getNextMove_getNextMove_7 when (this_getNextMove2_method_request_field_wdata_writer_strobe_state_counter_getNextMove_getNextMove_7 = '1') else
        this_getNextMove2_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_init_method_request_field_wdata <= board_init_method_request_field_wdata_reset;
      elsif (board_init_method_request_field_wdata_reset_strobe = '1') then
        board_init_method_request_field_wdata <= board_init_method_request_field_wdata_reset;
      elsif (board_init_method_request_field_wdata_writer_strobe_init_method_state = '1') then
        board_init_method_request_field_wdata <= board_init_method_request_field_wdata_writer_init_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_init_method_request_field_wdata_reset_strobe <= '1';
      else
        board_init_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(init_method_state) = 2 or conv_integer(init_method_state) = 2) then
        board_init_method_request_field_wdata_writer_strobe_init_method_state <= '1';
      else
        board_init_method_request_field_wdata_writer_strobe_init_method_state <= '0';
      end if;
    end if;
  end process;
  board_init_method_request_field_rdata <= board_init_method_request_field_wdata_reset when (reset = '1') else
        board_init_method_request_field_wdata_reset when (board_init_method_request_field_wdata_reset_strobe = '1') else
        board_init_method_request_field_wdata_writer_init_method_state when (board_init_method_request_field_wdata_writer_strobe_init_method_state = '1') else
        board_init_method_request_field_wdata;
  
  board_output_port_isValid_field_rdata <= board_output_port_isValid_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_getNextMove1_method_request_field_wdata <= this_getNextMove1_method_request_field_wdata_reset;
      elsif (this_getNextMove1_method_request_field_wdata_reset_strobe = '1') then
        this_getNextMove1_method_request_field_wdata <= this_getNextMove1_method_request_field_wdata_reset;
      elsif (this_getNextMove1_method_request_field_wdata_writer_strobe_state_counter_getNextMove_getNextMove_6 = '1') then
        this_getNextMove1_method_request_field_wdata <= this_getNextMove1_method_request_field_wdata_writer_state_counter_getNextMove_getNextMove_6;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_getNextMove1_method_request_field_wdata_reset_strobe <= '1';
      else
        this_getNextMove1_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove_getNextMove_6) = 1 or conv_integer(state_counter_getNextMove_getNextMove_6) = 1) then
        this_getNextMove1_method_request_field_wdata_writer_strobe_state_counter_getNextMove_getNextMove_6 <= '1';
      else
        this_getNextMove1_method_request_field_wdata_writer_strobe_state_counter_getNextMove_getNextMove_6 <= '0';
      end if;
    end if;
  end process;
  this_getNextMove1_method_request_field_rdata <= this_getNextMove1_method_request_field_wdata_reset when (reset = '1') else
        this_getNextMove1_method_request_field_wdata_reset when (this_getNextMove1_method_request_field_wdata_reset_strobe = '1') else
        this_getNextMove1_method_request_field_wdata_writer_state_counter_getNextMove_getNextMove_6 when (this_getNextMove1_method_request_field_wdata_writer_strobe_state_counter_getNextMove_getNextMove_6 = '1') else
        this_getNextMove1_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_getSym_y_field_wdata <= board_input_port_getSym_y_field_wdata_reset;
      elsif (board_input_port_getSym_y_field_wdata_reset_strobe = '1') then
        board_input_port_getSym_y_field_wdata <= board_input_port_getSym_y_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_getSym_y_field_wdata_reset_strobe <= '1';
      else
        board_input_port_getSym_y_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  board_input_port_getSym_y_field_rdata <= board_input_port_getSym_y_field_wdata_reset when (reset = '1') else
        board_input_port_getSym_y_field_wdata_reset when (board_input_port_getSym_y_field_wdata_reset_strobe = '1') else
        board_input_port_getSym_y_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_getSym_x_field_wdata <= board_input_port_getSym_x_field_wdata_reset;
      elsif (board_input_port_getSym_x_field_wdata_reset_strobe = '1') then
        board_input_port_getSym_x_field_wdata <= board_input_port_getSym_x_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_getSym_x_field_wdata_reset_strobe <= '1';
      else
        board_input_port_getSym_x_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  board_input_port_getSym_x_field_rdata <= board_input_port_getSym_x_field_wdata_reset when (reset = '1') else
        board_input_port_getSym_x_field_wdata_reset when (board_input_port_getSym_x_field_wdata_reset_strobe = '1') else
        board_input_port_getSym_x_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_encode_rot_field_wdata <= this_input_port_encode_rot_field_wdata_reset;
      elsif (this_input_port_encode_rot_field_wdata_reset_strobe = '1') then
        this_input_port_encode_rot_field_wdata <= this_input_port_encode_rot_field_wdata_reset;
      elsif (this_input_port_encode_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        this_input_port_encode_rot_field_wdata <= this_input_port_encode_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (this_input_port_encode_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        this_input_port_encode_rot_field_wdata <= this_input_port_encode_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (this_input_port_encode_rot_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        this_input_port_encode_rot_field_wdata <= this_input_port_encode_rot_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_encode_rot_field_wdata_reset_strobe <= '1';
      else
        this_input_port_encode_rot_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 2) then
        this_input_port_encode_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        this_input_port_encode_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 2) then
        this_input_port_encode_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        this_input_port_encode_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 5) then
        this_input_port_encode_rot_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        this_input_port_encode_rot_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  this_input_port_encode_rot_field_rdata <= this_input_port_encode_rot_field_wdata_reset when (reset = '1') else
        this_input_port_encode_rot_field_wdata_reset when (this_input_port_encode_rot_field_wdata_reset_strobe = '1') else
        this_input_port_encode_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (this_input_port_encode_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        this_input_port_encode_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (this_input_port_encode_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        this_input_port_encode_rot_field_wdata_writer_getFirstMoveCode_method_state when (this_input_port_encode_rot_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        this_input_port_encode_rot_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_isValid_y_field_wdata <= board_input_port_isValid_y_field_wdata_reset;
      elsif (board_input_port_isValid_y_field_wdata_reset_strobe = '1') then
        board_input_port_isValid_y_field_wdata <= board_input_port_isValid_y_field_wdata_reset;
      elsif (board_input_port_isValid_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') then
        board_input_port_isValid_y_field_wdata <= board_input_port_isValid_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12;
      elsif (board_input_port_isValid_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') then
        board_input_port_isValid_y_field_wdata <= board_input_port_isValid_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_isValid_y_field_wdata_reset_strobe <= '1';
      else
        board_input_port_isValid_y_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_12) = 1) then
        board_input_port_isValid_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '1';
      else
        board_input_port_isValid_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_12) = 1) then
        board_input_port_isValid_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '1';
      else
        board_input_port_isValid_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '0';
      end if;
    end if;
  end process;
  board_input_port_isValid_y_field_rdata <= board_input_port_isValid_y_field_wdata_reset when (reset = '1') else
        board_input_port_isValid_y_field_wdata_reset when (board_input_port_isValid_y_field_wdata_reset_strobe = '1') else
        board_input_port_isValid_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 when (board_input_port_isValid_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') else
        board_input_port_isValid_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 when (board_input_port_isValid_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') else
        board_input_port_isValid_y_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_isValid_x_field_wdata <= board_input_port_isValid_x_field_wdata_reset;
      elsif (board_input_port_isValid_x_field_wdata_reset_strobe = '1') then
        board_input_port_isValid_x_field_wdata <= board_input_port_isValid_x_field_wdata_reset;
      elsif (board_input_port_isValid_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') then
        board_input_port_isValid_x_field_wdata <= board_input_port_isValid_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12;
      elsif (board_input_port_isValid_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') then
        board_input_port_isValid_x_field_wdata <= board_input_port_isValid_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_isValid_x_field_wdata_reset_strobe <= '1';
      else
        board_input_port_isValid_x_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_12) = 1) then
        board_input_port_isValid_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '1';
      else
        board_input_port_isValid_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_12) = 1) then
        board_input_port_isValid_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '1';
      else
        board_input_port_isValid_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '0';
      end if;
    end if;
  end process;
  board_input_port_isValid_x_field_rdata <= board_input_port_isValid_x_field_wdata_reset when (reset = '1') else
        board_input_port_isValid_x_field_wdata_reset when (board_input_port_isValid_x_field_wdata_reset_strobe = '1') else
        board_input_port_isValid_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 when (board_input_port_isValid_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') else
        board_input_port_isValid_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 when (board_input_port_isValid_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') else
        board_input_port_isValid_x_field_wdata;
  
  board_output_port_getSym_field_rdata <= board_output_port_getSym_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_encode_id_field_wdata <= this_input_port_encode_id_field_wdata_reset;
      elsif (this_input_port_encode_id_field_wdata_reset_strobe = '1') then
        this_input_port_encode_id_field_wdata <= this_input_port_encode_id_field_wdata_reset;
      elsif (this_input_port_encode_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        this_input_port_encode_id_field_wdata <= this_input_port_encode_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (this_input_port_encode_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        this_input_port_encode_id_field_wdata <= this_input_port_encode_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (this_input_port_encode_id_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        this_input_port_encode_id_field_wdata <= this_input_port_encode_id_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_encode_id_field_wdata_reset_strobe <= '1';
      else
        this_input_port_encode_id_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 2) then
        this_input_port_encode_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        this_input_port_encode_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 2) then
        this_input_port_encode_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        this_input_port_encode_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 5) then
        this_input_port_encode_id_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        this_input_port_encode_id_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  this_input_port_encode_id_field_rdata <= this_input_port_encode_id_field_wdata_reset when (reset = '1') else
        this_input_port_encode_id_field_wdata_reset when (this_input_port_encode_id_field_wdata_reset_strobe = '1') else
        this_input_port_encode_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (this_input_port_encode_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        this_input_port_encode_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (this_input_port_encode_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        this_input_port_encode_id_field_wdata_writer_getFirstMoveCode_method_state when (this_input_port_encode_id_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        this_input_port_encode_id_field_wdata;
  
  board_getPattern_method_busy_field_rdata <= board_getPattern_method_busy_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_encode_y_field_wdata <= this_input_port_encode_y_field_wdata_reset;
      elsif (this_input_port_encode_y_field_wdata_reset_strobe = '1') then
        this_input_port_encode_y_field_wdata <= this_input_port_encode_y_field_wdata_reset;
      elsif (this_input_port_encode_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        this_input_port_encode_y_field_wdata <= this_input_port_encode_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (this_input_port_encode_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        this_input_port_encode_y_field_wdata <= this_input_port_encode_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (this_input_port_encode_y_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        this_input_port_encode_y_field_wdata <= this_input_port_encode_y_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_encode_y_field_wdata_reset_strobe <= '1';
      else
        this_input_port_encode_y_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 2) then
        this_input_port_encode_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        this_input_port_encode_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 2) then
        this_input_port_encode_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        this_input_port_encode_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 5) then
        this_input_port_encode_y_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        this_input_port_encode_y_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  this_input_port_encode_y_field_rdata <= this_input_port_encode_y_field_wdata_reset when (reset = '1') else
        this_input_port_encode_y_field_wdata_reset when (this_input_port_encode_y_field_wdata_reset_strobe = '1') else
        this_input_port_encode_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (this_input_port_encode_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        this_input_port_encode_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (this_input_port_encode_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        this_input_port_encode_y_field_wdata_writer_getFirstMoveCode_method_state when (this_input_port_encode_y_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        this_input_port_encode_y_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_encode_x_field_wdata <= this_input_port_encode_x_field_wdata_reset;
      elsif (this_input_port_encode_x_field_wdata_reset_strobe = '1') then
        this_input_port_encode_x_field_wdata <= this_input_port_encode_x_field_wdata_reset;
      elsif (this_input_port_encode_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        this_input_port_encode_x_field_wdata <= this_input_port_encode_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (this_input_port_encode_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        this_input_port_encode_x_field_wdata <= this_input_port_encode_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (this_input_port_encode_x_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        this_input_port_encode_x_field_wdata <= this_input_port_encode_x_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        this_input_port_encode_x_field_wdata_reset_strobe <= '1';
      else
        this_input_port_encode_x_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 2) then
        this_input_port_encode_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        this_input_port_encode_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 2) then
        this_input_port_encode_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        this_input_port_encode_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 5) then
        this_input_port_encode_x_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        this_input_port_encode_x_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  this_input_port_encode_x_field_rdata <= this_input_port_encode_x_field_wdata_reset when (reset = '1') else
        this_input_port_encode_x_field_wdata_reset when (this_input_port_encode_x_field_wdata_reset_strobe = '1') else
        this_input_port_encode_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (this_input_port_encode_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        this_input_port_encode_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (this_input_port_encode_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        this_input_port_encode_x_field_wdata_writer_getFirstMoveCode_method_state when (this_input_port_encode_x_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        this_input_port_encode_x_field_wdata;
  
  board_get_method_busy_field_rdata <= board_get_method_busy_field_wdata;
  
  board_isValid_method_busy_field_rdata <= board_isValid_method_busy_field_wdata;
  
  board_move_method_busy_field_rdata <= board_move_method_busy_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_move_rot_field_wdata <= board_input_port_move_rot_field_wdata_reset;
      elsif (board_input_port_move_rot_field_wdata_reset_strobe = '1') then
        board_input_port_move_rot_field_wdata <= board_input_port_move_rot_field_wdata_reset;
      elsif (board_input_port_move_rot_field_wdata_writer_strobe_setOpponentMove_method_state = '1') then
        board_input_port_move_rot_field_wdata <= board_input_port_move_rot_field_wdata_writer_setOpponentMove_method_state;
      elsif (board_input_port_move_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        board_input_port_move_rot_field_wdata <= board_input_port_move_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (board_input_port_move_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        board_input_port_move_rot_field_wdata <= board_input_port_move_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (board_input_port_move_rot_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        board_input_port_move_rot_field_wdata <= board_input_port_move_rot_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_move_rot_field_wdata_reset_strobe <= '1';
      else
        board_input_port_move_rot_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(setOpponentMove_method_state) = 2) then
        board_input_port_move_rot_field_wdata_writer_strobe_setOpponentMove_method_state <= '1';
      else
        board_input_port_move_rot_field_wdata_writer_strobe_setOpponentMove_method_state <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 1) then
        board_input_port_move_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        board_input_port_move_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 1) then
        board_input_port_move_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        board_input_port_move_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 3) then
        board_input_port_move_rot_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        board_input_port_move_rot_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  board_input_port_move_rot_field_rdata <= board_input_port_move_rot_field_wdata_reset when (reset = '1') else
        board_input_port_move_rot_field_wdata_reset when (board_input_port_move_rot_field_wdata_reset_strobe = '1') else
        board_input_port_move_rot_field_wdata_writer_setOpponentMove_method_state when (board_input_port_move_rot_field_wdata_writer_strobe_setOpponentMove_method_state = '1') else
        board_input_port_move_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (board_input_port_move_rot_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        board_input_port_move_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (board_input_port_move_rot_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        board_input_port_move_rot_field_wdata_writer_getFirstMoveCode_method_state when (board_input_port_move_rot_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        board_input_port_move_rot_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_isValid_method_request_field_wdata <= board_isValid_method_request_field_wdata_reset;
      elsif (board_isValid_method_request_field_wdata_reset_strobe = '1') then
        board_isValid_method_request_field_wdata <= board_isValid_method_request_field_wdata_reset;
      elsif (board_isValid_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') then
        board_isValid_method_request_field_wdata <= board_isValid_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12;
      elsif (board_isValid_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') then
        board_isValid_method_request_field_wdata <= board_isValid_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_isValid_method_request_field_wdata_reset_strobe <= '1';
      else
        board_isValid_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_12) = 1 or conv_integer(state_counter_getNextMove2_getNextMove2_12) = 1) then
        board_isValid_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '1';
      else
        board_isValid_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_12) = 1 or conv_integer(state_counter_getNextMove1_getNextMove1_12) = 1) then
        board_isValid_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '1';
      else
        board_isValid_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '0';
      end if;
    end if;
  end process;
  board_isValid_method_request_field_rdata <= board_isValid_method_request_field_wdata_reset when (reset = '1') else
        board_isValid_method_request_field_wdata_reset when (board_isValid_method_request_field_wdata_reset_strobe = '1') else
        board_isValid_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 when (board_isValid_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') else
        board_isValid_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 when (board_isValid_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') else
        board_isValid_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_isValid_c_field_wdata <= board_input_port_isValid_c_field_wdata_reset;
      elsif (board_input_port_isValid_c_field_wdata_reset_strobe = '1') then
        board_input_port_isValid_c_field_wdata <= board_input_port_isValid_c_field_wdata_reset;
      elsif (board_input_port_isValid_c_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') then
        board_input_port_isValid_c_field_wdata <= board_input_port_isValid_c_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12;
      elsif (board_input_port_isValid_c_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') then
        board_input_port_isValid_c_field_wdata <= board_input_port_isValid_c_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_isValid_c_field_wdata_reset_strobe <= '1';
      else
        board_input_port_isValid_c_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_12) = 1) then
        board_input_port_isValid_c_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '1';
      else
        board_input_port_isValid_c_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_12) = 1) then
        board_input_port_isValid_c_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '1';
      else
        board_input_port_isValid_c_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '0';
      end if;
    end if;
  end process;
  board_input_port_isValid_c_field_rdata <= board_input_port_isValid_c_field_wdata_reset when (reset = '1') else
        board_input_port_isValid_c_field_wdata_reset when (board_input_port_isValid_c_field_wdata_reset_strobe = '1') else
        board_input_port_isValid_c_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 when (board_input_port_isValid_c_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') else
        board_input_port_isValid_c_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 when (board_input_port_isValid_c_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') else
        board_input_port_isValid_c_field_wdata;
  
  board_output_port_getPattern_field_rdata <= board_output_port_getPattern_field_wdata;
  
  board_notify_method_busy_field_rdata <= board_notify_method_busy_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_get_method_request_field_wdata <= board_get_method_request_field_wdata_reset;
      elsif (board_get_method_request_field_wdata_reset_strobe = '1') then
        board_get_method_request_field_wdata <= board_get_method_request_field_wdata_reset;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_get_method_request_field_wdata_reset_strobe <= '1';
      else
        board_get_method_request_field_wdata_reset_strobe <= '0';
      end if;
    end if;
  end process;
  board_get_method_request_field_rdata <= board_get_method_request_field_wdata_reset when (reset = '1') else
        board_get_method_request_field_wdata_reset when (board_get_method_request_field_wdata_reset_strobe = '1') else
        board_get_method_request_field_wdata;
  
  board_getSym_method_busy_field_rdata <= board_getSym_method_busy_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_isValid_id_field_wdata <= board_input_port_isValid_id_field_wdata_reset;
      elsif (board_input_port_isValid_id_field_wdata_reset_strobe = '1') then
        board_input_port_isValid_id_field_wdata <= board_input_port_isValid_id_field_wdata_reset;
      elsif (board_input_port_isValid_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') then
        board_input_port_isValid_id_field_wdata <= board_input_port_isValid_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12;
      elsif (board_input_port_isValid_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') then
        board_input_port_isValid_id_field_wdata <= board_input_port_isValid_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_isValid_id_field_wdata_reset_strobe <= '1';
      else
        board_input_port_isValid_id_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_12) = 1) then
        board_input_port_isValid_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '1';
      else
        board_input_port_isValid_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_12) = 1) then
        board_input_port_isValid_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '1';
      else
        board_input_port_isValid_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 <= '0';
      end if;
    end if;
  end process;
  board_input_port_isValid_id_field_rdata <= board_input_port_isValid_id_field_wdata_reset when (reset = '1') else
        board_input_port_isValid_id_field_wdata_reset when (board_input_port_isValid_id_field_wdata_reset_strobe = '1') else
        board_input_port_isValid_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 when (board_input_port_isValid_id_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_12 = '1') else
        board_input_port_isValid_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 when (board_input_port_isValid_id_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_12 = '1') else
        board_input_port_isValid_id_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_move_method_request_field_wdata <= board_move_method_request_field_wdata_reset;
      elsif (board_move_method_request_field_wdata_reset_strobe = '1') then
        board_move_method_request_field_wdata <= board_move_method_request_field_wdata_reset;
      elsif (board_move_method_request_field_wdata_writer_strobe_setOpponentMove_method_state = '1') then
        board_move_method_request_field_wdata <= board_move_method_request_field_wdata_writer_setOpponentMove_method_state;
      elsif (board_move_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        board_move_method_request_field_wdata <= board_move_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (board_move_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        board_move_method_request_field_wdata <= board_move_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (board_move_method_request_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        board_move_method_request_field_wdata <= board_move_method_request_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_move_method_request_field_wdata_reset_strobe <= '1';
      else
        board_move_method_request_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(setOpponentMove_method_state) = 2 or conv_integer(setOpponentMove_method_state) = 2) then
        board_move_method_request_field_wdata_writer_strobe_setOpponentMove_method_state <= '1';
      else
        board_move_method_request_field_wdata_writer_strobe_setOpponentMove_method_state <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 1 or conv_integer(state_counter_getNextMove2_getNextMove2_14) = 1) then
        board_move_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        board_move_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 1 or conv_integer(state_counter_getNextMove1_getNextMove1_14) = 1) then
        board_move_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        board_move_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 3 or conv_integer(getFirstMoveCode_method_state) = 3) then
        board_move_method_request_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        board_move_method_request_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  board_move_method_request_field_rdata <= board_move_method_request_field_wdata_reset when (reset = '1') else
        board_move_method_request_field_wdata_reset when (board_move_method_request_field_wdata_reset_strobe = '1') else
        board_move_method_request_field_wdata_writer_setOpponentMove_method_state when (board_move_method_request_field_wdata_writer_strobe_setOpponentMove_method_state = '1') else
        board_move_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (board_move_method_request_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        board_move_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (board_move_method_request_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        board_move_method_request_field_wdata_writer_getFirstMoveCode_method_state when (board_move_method_request_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        board_move_method_request_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_move_y_field_wdata <= board_input_port_move_y_field_wdata_reset;
      elsif (board_input_port_move_y_field_wdata_reset_strobe = '1') then
        board_input_port_move_y_field_wdata <= board_input_port_move_y_field_wdata_reset;
      elsif (board_input_port_move_y_field_wdata_writer_strobe_setOpponentMove_method_state = '1') then
        board_input_port_move_y_field_wdata <= board_input_port_move_y_field_wdata_writer_setOpponentMove_method_state;
      elsif (board_input_port_move_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        board_input_port_move_y_field_wdata <= board_input_port_move_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (board_input_port_move_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        board_input_port_move_y_field_wdata <= board_input_port_move_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (board_input_port_move_y_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        board_input_port_move_y_field_wdata <= board_input_port_move_y_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_move_y_field_wdata_reset_strobe <= '1';
      else
        board_input_port_move_y_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(setOpponentMove_method_state) = 2) then
        board_input_port_move_y_field_wdata_writer_strobe_setOpponentMove_method_state <= '1';
      else
        board_input_port_move_y_field_wdata_writer_strobe_setOpponentMove_method_state <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 1) then
        board_input_port_move_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        board_input_port_move_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 1) then
        board_input_port_move_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        board_input_port_move_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 3) then
        board_input_port_move_y_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        board_input_port_move_y_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  board_input_port_move_y_field_rdata <= board_input_port_move_y_field_wdata_reset when (reset = '1') else
        board_input_port_move_y_field_wdata_reset when (board_input_port_move_y_field_wdata_reset_strobe = '1') else
        board_input_port_move_y_field_wdata_writer_setOpponentMove_method_state when (board_input_port_move_y_field_wdata_writer_strobe_setOpponentMove_method_state = '1') else
        board_input_port_move_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (board_input_port_move_y_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        board_input_port_move_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (board_input_port_move_y_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        board_input_port_move_y_field_wdata_writer_getFirstMoveCode_method_state when (board_input_port_move_y_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        board_input_port_move_y_field_wdata;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_move_x_field_wdata <= board_input_port_move_x_field_wdata_reset;
      elsif (board_input_port_move_x_field_wdata_reset_strobe = '1') then
        board_input_port_move_x_field_wdata <= board_input_port_move_x_field_wdata_reset;
      elsif (board_input_port_move_x_field_wdata_writer_strobe_setOpponentMove_method_state = '1') then
        board_input_port_move_x_field_wdata <= board_input_port_move_x_field_wdata_writer_setOpponentMove_method_state;
      elsif (board_input_port_move_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') then
        board_input_port_move_x_field_wdata <= board_input_port_move_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14;
      elsif (board_input_port_move_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') then
        board_input_port_move_x_field_wdata <= board_input_port_move_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14;
      elsif (board_input_port_move_x_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') then
        board_input_port_move_x_field_wdata <= board_input_port_move_x_field_wdata_writer_getFirstMoveCode_method_state;
      end if;
    end if;
  end process;
  process(clk)
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        board_input_port_move_x_field_wdata_reset_strobe <= '1';
      else
        board_input_port_move_x_field_wdata_reset_strobe <= '0';
      end if;
      if (conv_integer(setOpponentMove_method_state) = 2) then
        board_input_port_move_x_field_wdata_writer_strobe_setOpponentMove_method_state <= '1';
      else
        board_input_port_move_x_field_wdata_writer_strobe_setOpponentMove_method_state <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove2_getNextMove2_14) = 1) then
        board_input_port_move_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '1';
      else
        board_input_port_move_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 <= '0';
      end if;
      if (conv_integer(state_counter_getNextMove1_getNextMove1_14) = 1) then
        board_input_port_move_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '1';
      else
        board_input_port_move_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 <= '0';
      end if;
      if (conv_integer(getFirstMoveCode_method_state) = 3) then
        board_input_port_move_x_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '1';
      else
        board_input_port_move_x_field_wdata_writer_strobe_getFirstMoveCode_method_state <= '0';
      end if;
    end if;
  end process;
  board_input_port_move_x_field_rdata <= board_input_port_move_x_field_wdata_reset when (reset = '1') else
        board_input_port_move_x_field_wdata_reset when (board_input_port_move_x_field_wdata_reset_strobe = '1') else
        board_input_port_move_x_field_wdata_writer_setOpponentMove_method_state when (board_input_port_move_x_field_wdata_writer_strobe_setOpponentMove_method_state = '1') else
        board_input_port_move_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 when (board_input_port_move_x_field_wdata_writer_strobe_state_counter_getNextMove2_getNextMove2_14 = '1') else
        board_input_port_move_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 when (board_input_port_move_x_field_wdata_writer_strobe_state_counter_getNextMove1_getNextMove1_14 = '1') else
        board_input_port_move_x_field_wdata_writer_getFirstMoveCode_method_state when (board_input_port_move_x_field_wdata_writer_strobe_getFirstMoveCode_method_state = '1') else
        board_input_port_move_x_field_wdata;
  process(clk) --setOpponentMove
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_setOpponentMove_setOpponentMove_0 <= (others => '0');
        board_move_call_state_counter_setOpponentMove_0 <= (others => '0');
        board_move_call_state_counter_setOpponentMove_0 <= (others => '0');
        this_setOpponentMove_method_busy <= '0';
        setOpponentMove_method_state <= (others => '0');
        board_move_method_request_field_wdata_reset <= '0';
      else
        case conv_integer(setOpponentMove_method_state) is
          when 0 =>
            if(this_setOpponentMove_method_request = '1') then
              this_setOpponentMove_method_busy <= '1';
              setOpponentMove_method_state <= setOpponentMove_method_state + 1;
            else
              this_setOpponentMove_method_busy <= '0';
            end if;
          when 1 =>
            if(this_setOpponentMove_method_request = '0') then
              setOpponentMove_method_state <= setOpponentMove_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(board_move_call_state_counter_setOpponentMove_0) is
              when 0 =>
                if (board_move_method_busy_field_wdata = '0') then
                  board_move_method_request_field_wdata_writer_setOpponentMove_method_state <= '1';
                  board_move_call_state_counter_setOpponentMove_0 <= conv_std_logic_vector(1, board_move_call_state_counter_setOpponentMove_0'length);
                end if;
              when 1 =>
                board_input_port_move_x_field_wdata_writer_setOpponentMove_method_state <= conv_std_logic_vector(conv_integer(input_port_setOpponentMove_x), board_input_port_move_x_field_wdata'length);
                board_input_port_move_y_field_wdata_writer_setOpponentMove_method_state <= conv_std_logic_vector(conv_integer(input_port_setOpponentMove_y), board_input_port_move_y_field_wdata'length);
                board_input_port_move_c_field_wdata_writer_setOpponentMove_method_state <= conv_std_logic_vector(conv_integer(opponentColor_field_rdata), board_input_port_move_c_field_wdata'length);
                board_input_port_move_id_field_wdata_writer_setOpponentMove_method_state <= conv_std_logic_vector(conv_integer(input_port_setOpponentMove_id), board_input_port_move_id_field_wdata'length);
                board_input_port_move_rot_field_wdata_writer_setOpponentMove_method_state <= conv_std_logic_vector(conv_integer(input_port_setOpponentMove_rot), board_input_port_move_rot_field_wdata'length);
                board_move_method_request_field_wdata_writer_setOpponentMove_method_state <= '0';
                  board_move_call_state_counter_setOpponentMove_0 <= conv_std_logic_vector(2, board_move_call_state_counter_setOpponentMove_0'length);
              when 2 =>
                if (board_move_method_request_field_wdata = '0' and board_move_method_busy_field_wdata = '0') then
                  board_move_call_state_counter_setOpponentMove_0 <= (others => '0');
                  setOpponentMove_method_state <= setOpponentMove_method_state + 1;
                end if;
              when others => board_move_call_state_counter_setOpponentMove_0 <= (others => '0');
            end case;
          when 3 =>
            this_setOpponentMove_method_busy <= '0';
            setOpponentMove_method_state <= (others => '0');
          when others => setOpponentMove_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --setOpponentMove
  process(clk) --getNextMove2
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_getNextMove2_getNextMove2_0 <= (others => '0');
        code_getNextMove2_0 <= (others => '0');
        state_counter_getNextMove2_getNextMove2_1 <= (others => '0');
        state_counter_getNextMove2_getNextMove2_2 <= (others => '0');
        state_counter_getNextMove2_getNextMove2_3 <= (others => '0');
        getNextMove2_if_flag_getNextMove2_4_getNextMove2_2 <= '0';
        state_counter_getNextMove2_getNextMove2_5 <= (others => '0');
        state_counter_getNextMove2_getNextMove2_6 <= (others => '0');
        i_getNextMove2_6 <= (others => '0');
        state_counter_getNextMove2_getNextMove2_7 <= (others => '0');
        state_counter_getNextMove2_getNextMove2_8 <= (others => '0');
        j_getNextMove2_8 <= (others => '0');
        state_counter_getNextMove2_getNextMove2_9 <= (others => '0');
        state_counter_getNextMove2_getNextMove2_10 <= (others => '0');
        k_getNextMove2_10 <= (others => '0');
        state_counter_getNextMove2_getNextMove2_11 <= (others => '0');
        state_counter_getNextMove2_getNextMove2_12 <= (others => '0');
        getNextMove2_if_flag_getNextMove2_13_getNextMove2_11 <= '0';
        board_isValid_call_state_counter_getNextMove2_12 <= (others => '0');
        board_isValid_call_state_counter_getNextMove2_12 <= (others => '0');
        state_counter_getNextMove2_getNextMove2_14 <= (others => '0');
        board_move_call_state_counter_getNextMove2_14 <= (others => '0');
        board_move_call_state_counter_getNextMove2_14 <= (others => '0');
        this_encode_call_state_counter_getNextMove2_14 <= (others => '0');
        this_encode_call_state_counter_getNextMove2_14 <= (others => '0');
        this_getNextMove2_method_busy <= '0';
        getNextMove2_method_state <= (others => '0');
        board_move_method_request_field_wdata_reset <= '0';
        this_encode_method_request_field_wdata_reset <= '0';
        nextId_field_wdata_reset <= (others => '0');
        this_output_port_getNextMove2 <= (others => '0');
        board_isValid_method_request_field_wdata_reset <= '0';
      else
        case conv_integer(getNextMove2_method_state) is
          when 0 =>
            if(this_getNextMove2_method_request_field_rdata = '1') then
              this_getNextMove2_method_busy <= '1';
              getNextMove2_method_state <= getNextMove2_method_state + 1;
            else
              this_getNextMove2_method_busy <= '0';
            end if;
          when 1 =>
            if(this_getNextMove2_method_request_field_rdata = '0') then
              getNextMove2_method_state <= getNextMove2_method_state + 1;
            end if;
          when 2 => 
            code_getNextMove2_0 <= conv_std_logic_vector(0, code_getNextMove2_0'length);
            getNextMove2_method_state <= getNextMove2_method_state + 1;
          when 3 => 
            case conv_integer(state_counter_getNextMove2_getNextMove2_1) is
              when 0 => state_counter_getNextMove2_getNextMove2_1 <= state_counter_getNextMove2_getNextMove2_1 + 1;
              when 1 =>
                if (true) then
                  state_counter_getNextMove2_getNextMove2_1 <= state_counter_getNextMove2_getNextMove2_1 + 1;
                  state_counter_getNextMove2_getNextMove2_2 <= conv_std_logic_vector(1, state_counter_getNextMove2_getNextMove2_2'length);
                else
                  getNextMove2_method_state <= getNextMove2_method_state + 1;
                  state_counter_getNextMove2_getNextMove2_1 <= (others => '0');
                end if;
              when 2 =>
                case conv_integer(state_counter_getNextMove2_getNextMove2_2) is
                  when 0 => state_counter_getNextMove2_getNextMove2_2 <= state_counter_getNextMove2_getNextMove2_2 + 1;
                  when 1 =>
                    case conv_integer(state_counter_getNextMove2_getNextMove2_3) is
                      when 0 => state_counter_getNextMove2_getNextMove2_3 <= state_counter_getNextMove2_getNextMove2_3 + 1;
                      when 1 =>
                        if (conv_integer(nextId_field_rdata) < 0) then
                          getNextMove2_if_flag_getNextMove2_4_getNextMove2_2 <= '1';
                          state_counter_getNextMove2_getNextMove2_5 <= conv_std_logic_vector(1, state_counter_getNextMove2_getNextMove2_5'length);
                        else
                          getNextMove2_if_flag_getNextMove2_4_getNextMove2_2 <= '0';
                        end if;
                        state_counter_getNextMove2_getNextMove2_3 <= state_counter_getNextMove2_getNextMove2_3 + 1;
                      when 2 =>
                        if (getNextMove2_if_flag_getNextMove2_4_getNextMove2_2 = '1') then
                          case conv_integer(state_counter_getNextMove2_getNextMove2_5) is
                            when 0 => state_counter_getNextMove2_getNextMove2_5 <= state_counter_getNextMove2_getNextMove2_5 + 1;
                            when 1 =>
                              state_counter_getNextMove2_getNextMove2_5 <= (others => '0');
                              state_counter_getNextMove2_getNextMove2_3 <= (others => '0');
                              state_counter_getNextMove2_getNextMove2_2 <= (others => '0');
                              state_counter_getNextMove2_getNextMove2_1 <= (others => '0');
                              getNextMove2_method_state <= getNextMove2_method_state + 1;
                            when 2 =>
                              state_counter_getNextMove2_getNextMove2_3 <= state_counter_getNextMove2_getNextMove2_3 + 1;
                              state_counter_getNextMove2_getNextMove2_5 <= (others => '0');
                            when others => state_counter_getNextMove2_getNextMove2_5 <= (others => '0');
                          end case;
                        else
                          state_counter_getNextMove2_getNextMove2_3 <= state_counter_getNextMove2_getNextMove2_3 + 1;
                        end if;
                      when 3 =>
                        state_counter_getNextMove2_getNextMove2_3 <= (others => '0');
                        state_counter_getNextMove2_getNextMove2_2 <= state_counter_getNextMove2_getNextMove2_2 + 1;
                      when others =>
                        state_counter_getNextMove2_getNextMove2_3 <= (others => '0');
                    end case;
                  when 2 =>
                    case conv_integer(state_counter_getNextMove2_getNextMove2_6) is
                      when 0 => state_counter_getNextMove2_getNextMove2_6 <= state_counter_getNextMove2_getNextMove2_6 + 1;
                      when 1 =>
                        i_getNextMove2_6 <= conv_std_logic_vector(0, i_getNextMove2_6'length);
                        state_counter_getNextMove2_getNextMove2_6 <= state_counter_getNextMove2_getNextMove2_6 + 1;
                      when 2 =>
                        if (conv_integer(i_getNextMove2_6) < COLS) then
                          state_counter_getNextMove2_getNextMove2_6 <= state_counter_getNextMove2_getNextMove2_6 + 1;
                          state_counter_getNextMove2_getNextMove2_7 <= conv_std_logic_vector(1, state_counter_getNextMove2_getNextMove2_7'length);
                        else
                          state_counter_getNextMove2_getNextMove2_2 <= state_counter_getNextMove2_getNextMove2_2 + 1;
                          state_counter_getNextMove2_getNextMove2_6 <= (others => '0');
                        end if;
                      when 3 =>
                        case conv_integer(state_counter_getNextMove2_getNextMove2_7) is
                          when 0 => state_counter_getNextMove2_getNextMove2_7 <= state_counter_getNextMove2_getNextMove2_7 + 1;
                          when 1 =>
                            case conv_integer(state_counter_getNextMove2_getNextMove2_8) is
                              when 0 => state_counter_getNextMove2_getNextMove2_8 <= state_counter_getNextMove2_getNextMove2_8 + 1;
                              when 1 =>
                                j_getNextMove2_8 <= conv_std_logic_vector(0, j_getNextMove2_8'length);
                                state_counter_getNextMove2_getNextMove2_8 <= state_counter_getNextMove2_getNextMove2_8 + 1;
                              when 2 =>
                                if (conv_integer(j_getNextMove2_8) < ROWS) then
                                  state_counter_getNextMove2_getNextMove2_8 <= state_counter_getNextMove2_getNextMove2_8 + 1;
                                  state_counter_getNextMove2_getNextMove2_9 <= conv_std_logic_vector(1, state_counter_getNextMove2_getNextMove2_9'length);
                                else
                                  state_counter_getNextMove2_getNextMove2_7 <= state_counter_getNextMove2_getNextMove2_7 + 1;
                                  state_counter_getNextMove2_getNextMove2_8 <= (others => '0');
                                end if;
                              when 3 =>
                                case conv_integer(state_counter_getNextMove2_getNextMove2_9) is
                                  when 0 => state_counter_getNextMove2_getNextMove2_9 <= state_counter_getNextMove2_getNextMove2_9 + 1;
                                  when 1 =>
                                    case conv_integer(state_counter_getNextMove2_getNextMove2_10) is
                                      when 0 => state_counter_getNextMove2_getNextMove2_10 <= state_counter_getNextMove2_getNextMove2_10 + 1;
                                      when 1 =>
                                        k_getNextMove2_10 <= conv_std_logic_vector(0, k_getNextMove2_10'length);
                                        state_counter_getNextMove2_getNextMove2_10 <= state_counter_getNextMove2_getNextMove2_10 + 1;
                                      when 2 =>
                                        if (conv_integer(k_getNextMove2_10) < 8) then
                                          state_counter_getNextMove2_getNextMove2_10 <= state_counter_getNextMove2_getNextMove2_10 + 1;
                                          state_counter_getNextMove2_getNextMove2_11 <= conv_std_logic_vector(1, state_counter_getNextMove2_getNextMove2_11'length);
                                        else
                                          state_counter_getNextMove2_getNextMove2_9 <= state_counter_getNextMove2_getNextMove2_9 + 1;
                                          state_counter_getNextMove2_getNextMove2_10 <= (others => '0');
                                        end if;
                                      when 3 =>
                                        case conv_integer(state_counter_getNextMove2_getNextMove2_11) is
                                          when 0 => state_counter_getNextMove2_getNextMove2_11 <= state_counter_getNextMove2_getNextMove2_11 + 1;
                                          when 1 =>
                                            case conv_integer(state_counter_getNextMove2_getNextMove2_12) is
                                              when 0 => state_counter_getNextMove2_getNextMove2_12 <= state_counter_getNextMove2_getNextMove2_12 + 1;
                                              when 1 =>
                                                case conv_integer(board_isValid_call_state_counter_getNextMove2_12) is
                                                  when 0 =>
                                                    if (board_isValid_method_busy_field_wdata = '0') then
                                                      board_isValid_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 <= '1';
                                                      board_isValid_call_state_counter_getNextMove2_12 <= conv_std_logic_vector(1, board_isValid_call_state_counter_getNextMove2_12'length);
                                                    end if;
                                                  when 1 =>
                                                    board_input_port_isValid_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 <= conv_std_logic_vector(conv_integer(i_getNextMove2_6), board_input_port_isValid_x_field_wdata'length);
                                                    board_input_port_isValid_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 <= conv_std_logic_vector(conv_integer(j_getNextMove2_8), board_input_port_isValid_y_field_wdata'length);
                                                    board_input_port_isValid_c_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 <= conv_std_logic_vector(conv_integer(myColor_field_rdata), board_input_port_isValid_c_field_wdata'length);
                                                    board_input_port_isValid_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 <= conv_std_logic_vector(conv_integer(nextId_field_rdata), board_input_port_isValid_id_field_wdata'length);
                                                    board_input_port_isValid_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 <= conv_std_logic_vector(conv_integer(k_getNextMove2_10), board_input_port_isValid_rot_field_wdata'length);
                                                    board_isValid_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_12 <= '0';
                                                      board_isValid_call_state_counter_getNextMove2_12 <= conv_std_logic_vector(2, board_isValid_call_state_counter_getNextMove2_12'length);
                                                  when 2 =>
                                                    if (board_isValid_method_request_field_wdata = '0' and board_isValid_method_busy_field_wdata = '0') then
                                                      board_isValid_call_state_counter_getNextMove2_12 <= (others => '0');
                                                      state_counter_getNextMove2_getNextMove2_12 <= state_counter_getNextMove2_getNextMove2_12 + 1;
                                                    end if;
                                                  when others => board_isValid_call_state_counter_getNextMove2_12 <= (others => '0');
                                                end case;
                                              when 2 =>
                                                if (board_output_port_isValid_field_rdata = '1') then
                                                  getNextMove2_if_flag_getNextMove2_13_getNextMove2_11 <= '1';
                                                  state_counter_getNextMove2_getNextMove2_14 <= conv_std_logic_vector(1, state_counter_getNextMove2_getNextMove2_14'length);
                                                else
                                                  getNextMove2_if_flag_getNextMove2_13_getNextMove2_11 <= '0';
                                                end if;
                                                state_counter_getNextMove2_getNextMove2_12 <= state_counter_getNextMove2_getNextMove2_12 + 1;
                                              when 3 =>
                                                if (getNextMove2_if_flag_getNextMove2_13_getNextMove2_11 = '1') then
                                                  case conv_integer(state_counter_getNextMove2_getNextMove2_14) is
                                                    when 0 => state_counter_getNextMove2_getNextMove2_14 <= state_counter_getNextMove2_getNextMove2_14 + 1;
                                                    when 1 =>
                                                      case conv_integer(board_move_call_state_counter_getNextMove2_14) is
                                                        when 0 =>
                                                          if (board_move_method_busy_field_wdata = '0') then
                                                            board_move_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= '1';
                                                            board_move_call_state_counter_getNextMove2_14 <= conv_std_logic_vector(1, board_move_call_state_counter_getNextMove2_14'length);
                                                          end if;
                                                        when 1 =>
                                                          board_input_port_move_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= conv_std_logic_vector(conv_integer(i_getNextMove2_6), board_input_port_move_x_field_wdata'length);
                                                          board_input_port_move_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= conv_std_logic_vector(conv_integer(j_getNextMove2_8), board_input_port_move_y_field_wdata'length);
                                                          board_input_port_move_c_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= conv_std_logic_vector(conv_integer(myColor_field_rdata), board_input_port_move_c_field_wdata'length);
                                                          board_input_port_move_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= conv_std_logic_vector(conv_integer(nextId_field_rdata), board_input_port_move_id_field_wdata'length);
                                                          board_input_port_move_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= conv_std_logic_vector(conv_integer(k_getNextMove2_10), board_input_port_move_rot_field_wdata'length);
                                                          board_move_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= '0';
                                                            board_move_call_state_counter_getNextMove2_14 <= conv_std_logic_vector(2, board_move_call_state_counter_getNextMove2_14'length);
                                                        when 2 =>
                                                          if (board_move_method_request_field_wdata = '0' and board_move_method_busy_field_wdata = '0') then
                                                            board_move_call_state_counter_getNextMove2_14 <= (others => '0');
                                                            state_counter_getNextMove2_getNextMove2_14 <= state_counter_getNextMove2_getNextMove2_14 + 1;
                                                          end if;
                                                        when others => board_move_call_state_counter_getNextMove2_14 <= (others => '0');
                                                      end case;
                                                    when 2 =>
                                                      case conv_integer(this_encode_call_state_counter_getNextMove2_14) is
                                                        when 0 =>
                                                          if (this_encode_method_busy = '0') then
                                                            this_encode_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= '1';
                                                            this_encode_call_state_counter_getNextMove2_14 <= conv_std_logic_vector(1, this_encode_call_state_counter_getNextMove2_14'length);
                                                          end if;
                                                        when 1 =>
                                                          this_input_port_encode_x_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= conv_std_logic_vector(conv_integer(i_getNextMove2_6), this_input_port_encode_x_field_wdata'length);
                                                          this_input_port_encode_y_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= conv_std_logic_vector(conv_integer(j_getNextMove2_8), this_input_port_encode_y_field_wdata'length);
                                                          this_input_port_encode_id_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= conv_std_logic_vector(conv_integer(nextId_field_rdata), this_input_port_encode_id_field_wdata'length);
                                                          this_input_port_encode_rot_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= conv_std_logic_vector(conv_integer(k_getNextMove2_10), this_input_port_encode_rot_field_wdata'length);
                                                          this_encode_method_request_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= '0';
                                                            this_encode_call_state_counter_getNextMove2_14 <= conv_std_logic_vector(2, this_encode_call_state_counter_getNextMove2_14'length);
                                                        when 2 =>
                                                          if (this_encode_method_request_field_wdata = '0' and this_encode_method_busy = '0') then
                                                            this_encode_call_state_counter_getNextMove2_14 <= (others => '0');
                                                            state_counter_getNextMove2_getNextMove2_14 <= state_counter_getNextMove2_getNextMove2_14 + 1;
                                                          end if;
                                                        when others => this_encode_call_state_counter_getNextMove2_14 <= (others => '0');
                                                      end case;
                                                    when 3 =>
                                                      code_getNextMove2_0 <= conv_std_logic_vector(conv_integer(this_output_port_encode), code_getNextMove2_0'length);
                                                      nextId_field_wdata_writer_state_counter_getNextMove2_getNextMove2_14 <= conv_std_logic_vector(conv_integer(nextId_field_rdata) - 1, nextId_field_wdata'length);
                                                      state_counter_getNextMove2_getNextMove2_14 <= state_counter_getNextMove2_getNextMove2_14 + 1;
                                                    when 4 =>
                                                      this_output_port_getNextMove2 <= conv_std_logic_vector(conv_integer(code_getNextMove2_0), this_output_port_getNextMove2'length);
                                                      state_counter_getNextMove2_getNextMove2_14 <= (others => '0');
                                                      state_counter_getNextMove2_getNextMove2_12 <= (others => '0');
                                                      state_counter_getNextMove2_getNextMove2_11 <= (others => '0');
                                                      state_counter_getNextMove2_getNextMove2_10 <= (others => '0');
                                                      state_counter_getNextMove2_getNextMove2_9 <= (others => '0');
                                                      state_counter_getNextMove2_getNextMove2_8 <= (others => '0');
                                                      state_counter_getNextMove2_getNextMove2_7 <= (others => '0');
                                                      state_counter_getNextMove2_getNextMove2_6 <= (others => '0');
                                                      state_counter_getNextMove2_getNextMove2_2 <= (others => '0');
                                                      state_counter_getNextMove2_getNextMove2_1 <= (others => '0');
                                                      getNextMove2_method_state <= (others => '0');
                                                    when 5 =>
                                                      state_counter_getNextMove2_getNextMove2_12 <= state_counter_getNextMove2_getNextMove2_12 + 1;
                                                      state_counter_getNextMove2_getNextMove2_14 <= (others => '0');
                                                    when others => state_counter_getNextMove2_getNextMove2_14 <= (others => '0');
                                                  end case;
                                                else
                                                  state_counter_getNextMove2_getNextMove2_12 <= state_counter_getNextMove2_getNextMove2_12 + 1;
                                                end if;
                                              when 4 =>
                                                state_counter_getNextMove2_getNextMove2_12 <= (others => '0');
                                                state_counter_getNextMove2_getNextMove2_11 <= state_counter_getNextMove2_getNextMove2_11 + 1;
                                              when others =>
                                                state_counter_getNextMove2_getNextMove2_12 <= (others => '0');
                                            end case;
                                          when 2 =>
                                            state_counter_getNextMove2_getNextMove2_10 <= state_counter_getNextMove2_getNextMove2_10 + 1;
                                            state_counter_getNextMove2_getNextMove2_11 <= (others => '0');
                                          when others => state_counter_getNextMove2_getNextMove2_11 <= (others => '0');
                                        end case;
                                      when 4 =>
                                          k_getNextMove2_10 <= conv_std_logic_vector(conv_integer(k_getNextMove2_10) + 1, k_getNextMove2_10'length);
                                          state_counter_getNextMove2_getNextMove2_10 <= conv_std_logic_vector(2, 32);
                                      when others => state_counter_getNextMove2_getNextMove2_10 <= (others => '0');
                                    end case;
                                  when 2 =>
                                    state_counter_getNextMove2_getNextMove2_8 <= state_counter_getNextMove2_getNextMove2_8 + 1;
                                    state_counter_getNextMove2_getNextMove2_9 <= (others => '0');
                                  when others => state_counter_getNextMove2_getNextMove2_9 <= (others => '0');
                                end case;
                              when 4 =>
                                  j_getNextMove2_8 <= conv_std_logic_vector(conv_integer(j_getNextMove2_8) + 1, j_getNextMove2_8'length);
                                  state_counter_getNextMove2_getNextMove2_8 <= conv_std_logic_vector(2, 32);
                              when others => state_counter_getNextMove2_getNextMove2_8 <= (others => '0');
                            end case;
                          when 2 =>
                            state_counter_getNextMove2_getNextMove2_6 <= state_counter_getNextMove2_getNextMove2_6 + 1;
                            state_counter_getNextMove2_getNextMove2_7 <= (others => '0');
                          when others => state_counter_getNextMove2_getNextMove2_7 <= (others => '0');
                        end case;
                      when 4 =>
                          i_getNextMove2_6 <= conv_std_logic_vector(conv_integer(i_getNextMove2_6) + 1, i_getNextMove2_6'length);
                          state_counter_getNextMove2_getNextMove2_6 <= conv_std_logic_vector(2, 32);
                      when others => state_counter_getNextMove2_getNextMove2_6 <= (others => '0');
                    end case;
                  when 3 =>
                    nextId_field_wdata_writer_state_counter_getNextMove2_getNextMove2_2 <= conv_std_logic_vector(conv_integer(nextId_field_rdata) - 1, nextId_field_wdata'length);
                    state_counter_getNextMove2_getNextMove2_1 <= state_counter_getNextMove2_getNextMove2_1 + 1;
                    state_counter_getNextMove2_getNextMove2_2 <= (others => '0');
                  when others => state_counter_getNextMove2_getNextMove2_2 <= (others => '0');
                end case;
              when 3 =>
                state_counter_getNextMove2_getNextMove2_1 <= (others => '0');
              when others => state_counter_getNextMove2_getNextMove2_1 <= (others => '0');
            end case;
          when 4 => 
            this_output_port_getNextMove2 <= conv_std_logic_vector(-1, this_output_port_getNextMove2'length);
            getNextMove2_method_state <= (others => '0');
          when 5 =>
            this_getNextMove2_method_busy <= '0';
            getNextMove2_method_state <= (others => '0');
          when others => getNextMove2_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --getNextMove2
  process(clk) --getNextMove1
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_getNextMove1_getNextMove1_0 <= (others => '0');
        code_getNextMove1_0 <= (others => '0');
        state_counter_getNextMove1_getNextMove1_1 <= (others => '0');
        state_counter_getNextMove1_getNextMove1_2 <= (others => '0');
        state_counter_getNextMove1_getNextMove1_3 <= (others => '0');
        getNextMove1_if_flag_getNextMove1_4_getNextMove1_2 <= '0';
        state_counter_getNextMove1_getNextMove1_5 <= (others => '0');
        state_counter_getNextMove1_getNextMove1_6 <= (others => '0');
        i_getNextMove1_6 <= (others => '0');
        state_counter_getNextMove1_getNextMove1_7 <= (others => '0');
        state_counter_getNextMove1_getNextMove1_8 <= (others => '0');
        j_getNextMove1_8 <= (others => '0');
        state_counter_getNextMove1_getNextMove1_9 <= (others => '0');
        state_counter_getNextMove1_getNextMove1_10 <= (others => '0');
        k_getNextMove1_10 <= (others => '0');
        state_counter_getNextMove1_getNextMove1_11 <= (others => '0');
        state_counter_getNextMove1_getNextMove1_12 <= (others => '0');
        getNextMove1_if_flag_getNextMove1_13_getNextMove1_11 <= '0';
        board_isValid_call_state_counter_getNextMove1_12 <= (others => '0');
        board_isValid_call_state_counter_getNextMove1_12 <= (others => '0');
        state_counter_getNextMove1_getNextMove1_14 <= (others => '0');
        board_move_call_state_counter_getNextMove1_14 <= (others => '0');
        board_move_call_state_counter_getNextMove1_14 <= (others => '0');
        this_encode_call_state_counter_getNextMove1_14 <= (others => '0');
        this_encode_call_state_counter_getNextMove1_14 <= (others => '0');
        this_getNextMove1_method_busy <= '0';
        getNextMove1_method_state <= (others => '0');
        board_move_method_request_field_wdata_reset <= '0';
        this_encode_method_request_field_wdata_reset <= '0';
        this_output_port_getNextMove1 <= (others => '0');
        board_isValid_method_request_field_wdata_reset <= '0';
      else
        case conv_integer(getNextMove1_method_state) is
          when 0 =>
            if(this_getNextMove1_method_request_field_rdata = '1') then
              this_getNextMove1_method_busy <= '1';
              getNextMove1_method_state <= getNextMove1_method_state + 1;
            else
              this_getNextMove1_method_busy <= '0';
            end if;
          when 1 =>
            if(this_getNextMove1_method_request_field_rdata = '0') then
              getNextMove1_method_state <= getNextMove1_method_state + 1;
            end if;
          when 2 => 
            code_getNextMove1_0 <= conv_std_logic_vector(0, code_getNextMove1_0'length);
            getNextMove1_method_state <= getNextMove1_method_state + 1;
          when 3 => 
            case conv_integer(state_counter_getNextMove1_getNextMove1_1) is
              when 0 => state_counter_getNextMove1_getNextMove1_1 <= state_counter_getNextMove1_getNextMove1_1 + 1;
              when 1 =>
                if (true) then
                  state_counter_getNextMove1_getNextMove1_1 <= state_counter_getNextMove1_getNextMove1_1 + 1;
                  state_counter_getNextMove1_getNextMove1_2 <= conv_std_logic_vector(1, state_counter_getNextMove1_getNextMove1_2'length);
                else
                  getNextMove1_method_state <= getNextMove1_method_state + 1;
                  state_counter_getNextMove1_getNextMove1_1 <= (others => '0');
                end if;
              when 2 =>
                case conv_integer(state_counter_getNextMove1_getNextMove1_2) is
                  when 0 => state_counter_getNextMove1_getNextMove1_2 <= state_counter_getNextMove1_getNextMove1_2 + 1;
                  when 1 =>
                    case conv_integer(state_counter_getNextMove1_getNextMove1_3) is
                      when 0 => state_counter_getNextMove1_getNextMove1_3 <= state_counter_getNextMove1_getNextMove1_3 + 1;
                      when 1 =>
                        if (conv_integer(nextId_field_rdata) < 0) then
                          getNextMove1_if_flag_getNextMove1_4_getNextMove1_2 <= '1';
                          state_counter_getNextMove1_getNextMove1_5 <= conv_std_logic_vector(1, state_counter_getNextMove1_getNextMove1_5'length);
                        else
                          getNextMove1_if_flag_getNextMove1_4_getNextMove1_2 <= '0';
                        end if;
                        state_counter_getNextMove1_getNextMove1_3 <= state_counter_getNextMove1_getNextMove1_3 + 1;
                      when 2 =>
                        if (getNextMove1_if_flag_getNextMove1_4_getNextMove1_2 = '1') then
                          case conv_integer(state_counter_getNextMove1_getNextMove1_5) is
                            when 0 => state_counter_getNextMove1_getNextMove1_5 <= state_counter_getNextMove1_getNextMove1_5 + 1;
                            when 1 =>
                              state_counter_getNextMove1_getNextMove1_5 <= (others => '0');
                              state_counter_getNextMove1_getNextMove1_3 <= (others => '0');
                              state_counter_getNextMove1_getNextMove1_2 <= (others => '0');
                              state_counter_getNextMove1_getNextMove1_1 <= (others => '0');
                              getNextMove1_method_state <= getNextMove1_method_state + 1;
                            when 2 =>
                              state_counter_getNextMove1_getNextMove1_3 <= state_counter_getNextMove1_getNextMove1_3 + 1;
                              state_counter_getNextMove1_getNextMove1_5 <= (others => '0');
                            when others => state_counter_getNextMove1_getNextMove1_5 <= (others => '0');
                          end case;
                        else
                          state_counter_getNextMove1_getNextMove1_3 <= state_counter_getNextMove1_getNextMove1_3 + 1;
                        end if;
                      when 3 =>
                        state_counter_getNextMove1_getNextMove1_3 <= (others => '0');
                        state_counter_getNextMove1_getNextMove1_2 <= state_counter_getNextMove1_getNextMove1_2 + 1;
                      when others =>
                        state_counter_getNextMove1_getNextMove1_3 <= (others => '0');
                    end case;
                  when 2 =>
                    case conv_integer(state_counter_getNextMove1_getNextMove1_6) is
                      when 0 => state_counter_getNextMove1_getNextMove1_6 <= state_counter_getNextMove1_getNextMove1_6 + 1;
                      when 1 =>
                        i_getNextMove1_6 <= conv_std_logic_vector(0, i_getNextMove1_6'length);
                        state_counter_getNextMove1_getNextMove1_6 <= state_counter_getNextMove1_getNextMove1_6 + 1;
                      when 2 =>
                        if (conv_integer(i_getNextMove1_6) < COLS) then
                          state_counter_getNextMove1_getNextMove1_6 <= state_counter_getNextMove1_getNextMove1_6 + 1;
                          state_counter_getNextMove1_getNextMove1_7 <= conv_std_logic_vector(1, state_counter_getNextMove1_getNextMove1_7'length);
                        else
                          state_counter_getNextMove1_getNextMove1_2 <= state_counter_getNextMove1_getNextMove1_2 + 1;
                          state_counter_getNextMove1_getNextMove1_6 <= (others => '0');
                        end if;
                      when 3 =>
                        case conv_integer(state_counter_getNextMove1_getNextMove1_7) is
                          when 0 => state_counter_getNextMove1_getNextMove1_7 <= state_counter_getNextMove1_getNextMove1_7 + 1;
                          when 1 =>
                            case conv_integer(state_counter_getNextMove1_getNextMove1_8) is
                              when 0 => state_counter_getNextMove1_getNextMove1_8 <= state_counter_getNextMove1_getNextMove1_8 + 1;
                              when 1 =>
                                j_getNextMove1_8 <= conv_std_logic_vector(0, j_getNextMove1_8'length);
                                state_counter_getNextMove1_getNextMove1_8 <= state_counter_getNextMove1_getNextMove1_8 + 1;
                              when 2 =>
                                if (conv_integer(j_getNextMove1_8) < ROWS) then
                                  state_counter_getNextMove1_getNextMove1_8 <= state_counter_getNextMove1_getNextMove1_8 + 1;
                                  state_counter_getNextMove1_getNextMove1_9 <= conv_std_logic_vector(1, state_counter_getNextMove1_getNextMove1_9'length);
                                else
                                  state_counter_getNextMove1_getNextMove1_7 <= state_counter_getNextMove1_getNextMove1_7 + 1;
                                  state_counter_getNextMove1_getNextMove1_8 <= (others => '0');
                                end if;
                              when 3 =>
                                case conv_integer(state_counter_getNextMove1_getNextMove1_9) is
                                  when 0 => state_counter_getNextMove1_getNextMove1_9 <= state_counter_getNextMove1_getNextMove1_9 + 1;
                                  when 1 =>
                                    case conv_integer(state_counter_getNextMove1_getNextMove1_10) is
                                      when 0 => state_counter_getNextMove1_getNextMove1_10 <= state_counter_getNextMove1_getNextMove1_10 + 1;
                                      when 1 =>
                                        k_getNextMove1_10 <= conv_std_logic_vector(0, k_getNextMove1_10'length);
                                        state_counter_getNextMove1_getNextMove1_10 <= state_counter_getNextMove1_getNextMove1_10 + 1;
                                      when 2 =>
                                        if (conv_integer(k_getNextMove1_10) < 8) then
                                          state_counter_getNextMove1_getNextMove1_10 <= state_counter_getNextMove1_getNextMove1_10 + 1;
                                          state_counter_getNextMove1_getNextMove1_11 <= conv_std_logic_vector(1, state_counter_getNextMove1_getNextMove1_11'length);
                                        else
                                          state_counter_getNextMove1_getNextMove1_9 <= state_counter_getNextMove1_getNextMove1_9 + 1;
                                          state_counter_getNextMove1_getNextMove1_10 <= (others => '0');
                                        end if;
                                      when 3 =>
                                        case conv_integer(state_counter_getNextMove1_getNextMove1_11) is
                                          when 0 => state_counter_getNextMove1_getNextMove1_11 <= state_counter_getNextMove1_getNextMove1_11 + 1;
                                          when 1 =>
                                            case conv_integer(state_counter_getNextMove1_getNextMove1_12) is
                                              when 0 => state_counter_getNextMove1_getNextMove1_12 <= state_counter_getNextMove1_getNextMove1_12 + 1;
                                              when 1 =>
                                                case conv_integer(board_isValid_call_state_counter_getNextMove1_12) is
                                                  when 0 =>
                                                    if (board_isValid_method_busy_field_wdata = '0') then
                                                      board_isValid_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 <= '1';
                                                      board_isValid_call_state_counter_getNextMove1_12 <= conv_std_logic_vector(1, board_isValid_call_state_counter_getNextMove1_12'length);
                                                    end if;
                                                  when 1 =>
                                                    board_input_port_isValid_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 <= conv_std_logic_vector(COLS - conv_integer(i_getNextMove1_6) - 1, board_input_port_isValid_x_field_wdata'length);
                                                    board_input_port_isValid_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 <= conv_std_logic_vector(ROWS - conv_integer(j_getNextMove1_8) - 1, board_input_port_isValid_y_field_wdata'length);
                                                    board_input_port_isValid_c_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 <= conv_std_logic_vector(conv_integer(myColor_field_rdata), board_input_port_isValid_c_field_wdata'length);
                                                    board_input_port_isValid_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 <= conv_std_logic_vector(conv_integer(nextId_field_rdata), board_input_port_isValid_id_field_wdata'length);
                                                    board_input_port_isValid_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 <= conv_std_logic_vector(conv_integer(k_getNextMove1_10), board_input_port_isValid_rot_field_wdata'length);
                                                    board_isValid_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_12 <= '0';
                                                      board_isValid_call_state_counter_getNextMove1_12 <= conv_std_logic_vector(2, board_isValid_call_state_counter_getNextMove1_12'length);
                                                  when 2 =>
                                                    if (board_isValid_method_request_field_wdata = '0' and board_isValid_method_busy_field_wdata = '0') then
                                                      board_isValid_call_state_counter_getNextMove1_12 <= (others => '0');
                                                      state_counter_getNextMove1_getNextMove1_12 <= state_counter_getNextMove1_getNextMove1_12 + 1;
                                                    end if;
                                                  when others => board_isValid_call_state_counter_getNextMove1_12 <= (others => '0');
                                                end case;
                                              when 2 =>
                                                if (board_output_port_isValid_field_rdata = '1') then
                                                  getNextMove1_if_flag_getNextMove1_13_getNextMove1_11 <= '1';
                                                  state_counter_getNextMove1_getNextMove1_14 <= conv_std_logic_vector(1, state_counter_getNextMove1_getNextMove1_14'length);
                                                else
                                                  getNextMove1_if_flag_getNextMove1_13_getNextMove1_11 <= '0';
                                                end if;
                                                state_counter_getNextMove1_getNextMove1_12 <= state_counter_getNextMove1_getNextMove1_12 + 1;
                                              when 3 =>
                                                if (getNextMove1_if_flag_getNextMove1_13_getNextMove1_11 = '1') then
                                                  case conv_integer(state_counter_getNextMove1_getNextMove1_14) is
                                                    when 0 => state_counter_getNextMove1_getNextMove1_14 <= state_counter_getNextMove1_getNextMove1_14 + 1;
                                                    when 1 =>
                                                      case conv_integer(board_move_call_state_counter_getNextMove1_14) is
                                                        when 0 =>
                                                          if (board_move_method_busy_field_wdata = '0') then
                                                            board_move_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= '1';
                                                            board_move_call_state_counter_getNextMove1_14 <= conv_std_logic_vector(1, board_move_call_state_counter_getNextMove1_14'length);
                                                          end if;
                                                        when 1 =>
                                                          board_input_port_move_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= conv_std_logic_vector(COLS - conv_integer(i_getNextMove1_6) - 1, board_input_port_move_x_field_wdata'length);
                                                          board_input_port_move_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= conv_std_logic_vector(ROWS - conv_integer(j_getNextMove1_8) - 1, board_input_port_move_y_field_wdata'length);
                                                          board_input_port_move_c_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= conv_std_logic_vector(conv_integer(myColor_field_rdata), board_input_port_move_c_field_wdata'length);
                                                          board_input_port_move_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= conv_std_logic_vector(conv_integer(nextId_field_rdata), board_input_port_move_id_field_wdata'length);
                                                          board_input_port_move_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= conv_std_logic_vector(conv_integer(k_getNextMove1_10), board_input_port_move_rot_field_wdata'length);
                                                          board_move_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= '0';
                                                            board_move_call_state_counter_getNextMove1_14 <= conv_std_logic_vector(2, board_move_call_state_counter_getNextMove1_14'length);
                                                        when 2 =>
                                                          if (board_move_method_request_field_wdata = '0' and board_move_method_busy_field_wdata = '0') then
                                                            board_move_call_state_counter_getNextMove1_14 <= (others => '0');
                                                            state_counter_getNextMove1_getNextMove1_14 <= state_counter_getNextMove1_getNextMove1_14 + 1;
                                                          end if;
                                                        when others => board_move_call_state_counter_getNextMove1_14 <= (others => '0');
                                                      end case;
                                                    when 2 =>
                                                      case conv_integer(this_encode_call_state_counter_getNextMove1_14) is
                                                        when 0 =>
                                                          if (this_encode_method_busy = '0') then
                                                            this_encode_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= '1';
                                                            this_encode_call_state_counter_getNextMove1_14 <= conv_std_logic_vector(1, this_encode_call_state_counter_getNextMove1_14'length);
                                                          end if;
                                                        when 1 =>
                                                          this_input_port_encode_x_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= conv_std_logic_vector(COLS - conv_integer(i_getNextMove1_6) - 1, this_input_port_encode_x_field_wdata'length);
                                                          this_input_port_encode_y_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= conv_std_logic_vector(ROWS - conv_integer(j_getNextMove1_8) - 1, this_input_port_encode_y_field_wdata'length);
                                                          this_input_port_encode_id_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= conv_std_logic_vector(conv_integer(nextId_field_rdata), this_input_port_encode_id_field_wdata'length);
                                                          this_input_port_encode_rot_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= conv_std_logic_vector(conv_integer(k_getNextMove1_10), this_input_port_encode_rot_field_wdata'length);
                                                          this_encode_method_request_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= '0';
                                                            this_encode_call_state_counter_getNextMove1_14 <= conv_std_logic_vector(2, this_encode_call_state_counter_getNextMove1_14'length);
                                                        when 2 =>
                                                          if (this_encode_method_request_field_wdata = '0' and this_encode_method_busy = '0') then
                                                            this_encode_call_state_counter_getNextMove1_14 <= (others => '0');
                                                            state_counter_getNextMove1_getNextMove1_14 <= state_counter_getNextMove1_getNextMove1_14 + 1;
                                                          end if;
                                                        when others => this_encode_call_state_counter_getNextMove1_14 <= (others => '0');
                                                      end case;
                                                    when 3 =>
                                                      code_getNextMove1_0 <= conv_std_logic_vector(conv_integer(this_output_port_encode), code_getNextMove1_0'length);
                                                      nextId_field_wdata_writer_state_counter_getNextMove1_getNextMove1_14 <= conv_std_logic_vector(conv_integer(nextId_field_rdata) - 1, nextId_field_wdata'length);
                                                      state_counter_getNextMove1_getNextMove1_14 <= state_counter_getNextMove1_getNextMove1_14 + 1;
                                                    when 4 =>
                                                      this_output_port_getNextMove1 <= conv_std_logic_vector(conv_integer(code_getNextMove1_0), this_output_port_getNextMove1'length);
                                                      state_counter_getNextMove1_getNextMove1_14 <= (others => '0');
                                                      state_counter_getNextMove1_getNextMove1_12 <= (others => '0');
                                                      state_counter_getNextMove1_getNextMove1_11 <= (others => '0');
                                                      state_counter_getNextMove1_getNextMove1_10 <= (others => '0');
                                                      state_counter_getNextMove1_getNextMove1_9 <= (others => '0');
                                                      state_counter_getNextMove1_getNextMove1_8 <= (others => '0');
                                                      state_counter_getNextMove1_getNextMove1_7 <= (others => '0');
                                                      state_counter_getNextMove1_getNextMove1_6 <= (others => '0');
                                                      state_counter_getNextMove1_getNextMove1_2 <= (others => '0');
                                                      state_counter_getNextMove1_getNextMove1_1 <= (others => '0');
                                                      getNextMove1_method_state <= (others => '0');
                                                    when 5 =>
                                                      state_counter_getNextMove1_getNextMove1_12 <= state_counter_getNextMove1_getNextMove1_12 + 1;
                                                      state_counter_getNextMove1_getNextMove1_14 <= (others => '0');
                                                    when others => state_counter_getNextMove1_getNextMove1_14 <= (others => '0');
                                                  end case;
                                                else
                                                  state_counter_getNextMove1_getNextMove1_12 <= state_counter_getNextMove1_getNextMove1_12 + 1;
                                                end if;
                                              when 4 =>
                                                state_counter_getNextMove1_getNextMove1_12 <= (others => '0');
                                                state_counter_getNextMove1_getNextMove1_11 <= state_counter_getNextMove1_getNextMove1_11 + 1;
                                              when others =>
                                                state_counter_getNextMove1_getNextMove1_12 <= (others => '0');
                                            end case;
                                          when 2 =>
                                            state_counter_getNextMove1_getNextMove1_10 <= state_counter_getNextMove1_getNextMove1_10 + 1;
                                            state_counter_getNextMove1_getNextMove1_11 <= (others => '0');
                                          when others => state_counter_getNextMove1_getNextMove1_11 <= (others => '0');
                                        end case;
                                      when 4 =>
                                          k_getNextMove1_10 <= conv_std_logic_vector(conv_integer(k_getNextMove1_10) + 1, k_getNextMove1_10'length);
                                          state_counter_getNextMove1_getNextMove1_10 <= conv_std_logic_vector(2, 32);
                                      when others => state_counter_getNextMove1_getNextMove1_10 <= (others => '0');
                                    end case;
                                  when 2 =>
                                    state_counter_getNextMove1_getNextMove1_8 <= state_counter_getNextMove1_getNextMove1_8 + 1;
                                    state_counter_getNextMove1_getNextMove1_9 <= (others => '0');
                                  when others => state_counter_getNextMove1_getNextMove1_9 <= (others => '0');
                                end case;
                              when 4 =>
                                  j_getNextMove1_8 <= conv_std_logic_vector(conv_integer(j_getNextMove1_8) + 1, j_getNextMove1_8'length);
                                  state_counter_getNextMove1_getNextMove1_8 <= conv_std_logic_vector(2, 32);
                              when others => state_counter_getNextMove1_getNextMove1_8 <= (others => '0');
                            end case;
                          when 2 =>
                            state_counter_getNextMove1_getNextMove1_6 <= state_counter_getNextMove1_getNextMove1_6 + 1;
                            state_counter_getNextMove1_getNextMove1_7 <= (others => '0');
                          when others => state_counter_getNextMove1_getNextMove1_7 <= (others => '0');
                        end case;
                      when 4 =>
                          i_getNextMove1_6 <= conv_std_logic_vector(conv_integer(i_getNextMove1_6) + 1, i_getNextMove1_6'length);
                          state_counter_getNextMove1_getNextMove1_6 <= conv_std_logic_vector(2, 32);
                      when others => state_counter_getNextMove1_getNextMove1_6 <= (others => '0');
                    end case;
                  when 3 =>
                    nextId_field_wdata_writer_state_counter_getNextMove1_getNextMove1_2 <= conv_std_logic_vector(conv_integer(nextId_field_rdata) - 1, nextId_field_wdata'length);
                    state_counter_getNextMove1_getNextMove1_1 <= state_counter_getNextMove1_getNextMove1_1 + 1;
                    state_counter_getNextMove1_getNextMove1_2 <= (others => '0');
                  when others => state_counter_getNextMove1_getNextMove1_2 <= (others => '0');
                end case;
              when 3 =>
                state_counter_getNextMove1_getNextMove1_1 <= (others => '0');
              when others => state_counter_getNextMove1_getNextMove1_1 <= (others => '0');
            end case;
          when 4 => 
            this_output_port_getNextMove1 <= conv_std_logic_vector(-1, this_output_port_getNextMove1'length);
            getNextMove1_method_state <= (others => '0');
          when 5 =>
            this_getNextMove1_method_busy <= '0';
            getNextMove1_method_state <= (others => '0');
          when others => getNextMove1_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --getNextMove1
  process(clk) --wait
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        d_notify_flag <= '0';
        this_wait_method_busy <= '0';
        wait_method_state <= (others => '0');
        state_counter_wait_wait_0 <= (others => '0');
      else
        case conv_integer(wait_method_state) is
          when 0 =>
            if(this_wait_method_request_field_rdata = '1') then
              this_wait_method_busy <= '1';
              wait_method_state <= wait_method_state + 1;
            else
              this_wait_method_busy <= '0';
            end if;
          when 1 =>
            if(this_wait_method_request_field_rdata = '0') then
              wait_method_state <= wait_method_state + 1;
            end if;
          when 2 => 
            if (d_notify_flag = '0' and notify_flag = '1') then
              wait_method_state <= wait_method_state + 1;
            else
              d_notify_flag <= notify_flag;
            end if;
          when 3 =>
            this_wait_method_busy <= '0';
            wait_method_state <= (others => '0');
          when others => wait_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --wait
  process(clk) --encode
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_encode_encode_0 <= (others => '0');
        this_encode_method_busy <= '0';
        encode_method_state <= (others => '0');
        this_output_port_encode <= (others => '0');
      else
        case conv_integer(encode_method_state) is
          when 0 =>
            if(this_encode_method_request_field_rdata = '1') then
              this_encode_method_busy <= '1';
              encode_method_state <= encode_method_state + 1;
            else
              this_encode_method_busy <= '0';
            end if;
          when 1 =>
            if(this_encode_method_request_field_rdata = '0') then
              encode_method_state <= encode_method_state + 1;
            end if;
          when 2 => 
            this_output_port_encode <= conv_std_logic_vector((conv_integer(conv_std_logic_vector((conv_integer(this_input_port_encode_x_field_rdata(31 - 24 downto 0) & conv_std_logic_vector(0, 24))), 32) and conv_std_logic_vector(-16777216, 32))) + (conv_integer(conv_std_logic_vector((conv_integer(this_input_port_encode_y_field_rdata(31 - 16 downto 0) & conv_std_logic_vector(0, 16))), 32) and conv_std_logic_vector(16711680, 32))) + (conv_integer(conv_std_logic_vector((conv_integer(this_input_port_encode_id_field_rdata(31 - 8 downto 0) & conv_std_logic_vector(0, 8))), 32) and conv_std_logic_vector(65280, 32))) + (conv_integer(this_input_port_encode_rot_field_rdata and conv_std_logic_vector(255, 32))), this_output_port_encode'length);
            encode_method_state <= (others => '0');
          when 3 =>
            this_encode_method_busy <= '0';
            encode_method_state <= (others => '0');
          when others => encode_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --encode
  process(clk) --getFirstMoveCode
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_getFirstMoveCode_getFirstMoveCode_0 <= (others => '0');
        id_getFirstMoveCode_0 <= (others => '0');
        rot_getFirstMoveCode_0 <= (others => '0');
        board_move_call_state_counter_getFirstMoveCode_0 <= (others => '0');
        board_move_call_state_counter_getFirstMoveCode_0 <= (others => '0');
        this_encode_call_state_counter_getFirstMoveCode_0 <= (others => '0');
        this_encode_call_state_counter_getFirstMoveCode_0 <= (others => '0');
        this_getFirstMoveCode_method_busy <= '0';
        getFirstMoveCode_method_state <= (others => '0');
        board_move_method_request_field_wdata_reset <= '0';
        this_encode_method_request_field_wdata_reset <= '0';
        output_port_getFirstMoveCode <= (others => '0');
      else
        case conv_integer(getFirstMoveCode_method_state) is
          when 0 =>
            if(this_getFirstMoveCode_method_request = '1') then
              this_getFirstMoveCode_method_busy <= '1';
              getFirstMoveCode_method_state <= getFirstMoveCode_method_state + 1;
            else
              this_getFirstMoveCode_method_busy <= '0';
            end if;
          when 1 =>
            if(this_getFirstMoveCode_method_request = '0') then
              getFirstMoveCode_method_state <= getFirstMoveCode_method_state + 1;
            end if;
          when 2 => 
            id_getFirstMoveCode_0 <= conv_std_logic_vector(117 - 97, id_getFirstMoveCode_0'length);
            rot_getFirstMoveCode_0 <= conv_std_logic_vector(0, rot_getFirstMoveCode_0'length);
            getFirstMoveCode_method_state <= getFirstMoveCode_method_state + 1;
          when 3 => 
            case conv_integer(board_move_call_state_counter_getFirstMoveCode_0) is
              when 0 =>
                if (board_move_method_busy_field_wdata = '0') then
                  board_move_method_request_field_wdata_writer_getFirstMoveCode_method_state <= '1';
                  board_move_call_state_counter_getFirstMoveCode_0 <= conv_std_logic_vector(1, board_move_call_state_counter_getFirstMoveCode_0'length);
                end if;
              when 1 =>
                board_input_port_move_x_field_wdata_writer_getFirstMoveCode_method_state <= conv_std_logic_vector(conv_integer(input_port_getFirstMoveCode_x), board_input_port_move_x_field_wdata'length);
                board_input_port_move_y_field_wdata_writer_getFirstMoveCode_method_state <= conv_std_logic_vector(conv_integer(input_port_getFirstMoveCode_y), board_input_port_move_y_field_wdata'length);
                board_input_port_move_c_field_wdata_writer_getFirstMoveCode_method_state <= conv_std_logic_vector(conv_integer(myColor_field_rdata), board_input_port_move_c_field_wdata'length);
                board_input_port_move_id_field_wdata_writer_getFirstMoveCode_method_state <= conv_std_logic_vector(conv_integer(id_getFirstMoveCode_0), board_input_port_move_id_field_wdata'length);
                board_input_port_move_rot_field_wdata_writer_getFirstMoveCode_method_state <= conv_std_logic_vector(conv_integer(rot_getFirstMoveCode_0), board_input_port_move_rot_field_wdata'length);
                board_move_method_request_field_wdata_writer_getFirstMoveCode_method_state <= '0';
                  board_move_call_state_counter_getFirstMoveCode_0 <= conv_std_logic_vector(2, board_move_call_state_counter_getFirstMoveCode_0'length);
              when 2 =>
                if (board_move_method_request_field_wdata = '0' and board_move_method_busy_field_wdata = '0') then
                  board_move_call_state_counter_getFirstMoveCode_0 <= (others => '0');
                  getFirstMoveCode_method_state <= getFirstMoveCode_method_state + 1;
                end if;
              when others => board_move_call_state_counter_getFirstMoveCode_0 <= (others => '0');
            end case;
          when 4 => 
            nextId_field_wdata_writer_getFirstMoveCode_method_state <= conv_std_logic_vector(conv_integer(id_getFirstMoveCode_0) - 1, nextId_field_wdata'length);
            getFirstMoveCode_method_state <= getFirstMoveCode_method_state + 1;
          when 5 => 
            case conv_integer(this_encode_call_state_counter_getFirstMoveCode_0) is
              when 0 =>
                if (this_encode_method_busy = '0') then
                  this_encode_method_request_field_wdata_writer_getFirstMoveCode_method_state <= '1';
                  this_encode_call_state_counter_getFirstMoveCode_0 <= conv_std_logic_vector(1, this_encode_call_state_counter_getFirstMoveCode_0'length);
                end if;
              when 1 =>
                this_input_port_encode_x_field_wdata_writer_getFirstMoveCode_method_state <= conv_std_logic_vector(conv_integer(input_port_getFirstMoveCode_x), this_input_port_encode_x_field_wdata'length);
                this_input_port_encode_y_field_wdata_writer_getFirstMoveCode_method_state <= conv_std_logic_vector(conv_integer(input_port_getFirstMoveCode_y), this_input_port_encode_y_field_wdata'length);
                this_input_port_encode_id_field_wdata_writer_getFirstMoveCode_method_state <= conv_std_logic_vector(conv_integer(id_getFirstMoveCode_0), this_input_port_encode_id_field_wdata'length);
                this_input_port_encode_rot_field_wdata_writer_getFirstMoveCode_method_state <= conv_std_logic_vector(conv_integer(rot_getFirstMoveCode_0), this_input_port_encode_rot_field_wdata'length);
                this_encode_method_request_field_wdata_writer_getFirstMoveCode_method_state <= '0';
                  this_encode_call_state_counter_getFirstMoveCode_0 <= conv_std_logic_vector(2, this_encode_call_state_counter_getFirstMoveCode_0'length);
              when 2 =>
                if (this_encode_method_request_field_wdata = '0' and this_encode_method_busy = '0') then
                  this_encode_call_state_counter_getFirstMoveCode_0 <= (others => '0');
                  getFirstMoveCode_method_state <= getFirstMoveCode_method_state + 1;
                end if;
              when others => this_encode_call_state_counter_getFirstMoveCode_0 <= (others => '0');
            end case;
          when 6 => 
            output_port_getFirstMoveCode <= conv_std_logic_vector(conv_integer(this_output_port_encode), output_port_getFirstMoveCode'length);
            getFirstMoveCode_method_state <= (others => '0');
          when 7 =>
            this_getFirstMoveCode_method_busy <= '0';
            getFirstMoveCode_method_state <= (others => '0');
          when others => getFirstMoveCode_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --getFirstMoveCode
  process(clk) --setTurnCode
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_setTurnCode_setTurnCode_0 <= (others => '0');
        state_counter_setTurnCode_setTurnCode_1 <= (others => '0');
        setTurnCode_if_flag_setTurnCode_2_setTurnCode_0 <= '0';
        state_counter_setTurnCode_setTurnCode_3 <= (others => '0');
        state_counter_setTurnCode_setTurnCode_4 <= (others => '0');
        this_setTurnCode_method_busy <= '0';
        setTurnCode_method_state <= (others => '0');
        turnCode_field_wdata_reset <= (others => '0');
        myColor_field_wdata_reset <= (others => '0');
        opponentColor_field_wdata_reset <= (others => '0');
      else
        case conv_integer(setTurnCode_method_state) is
          when 0 =>
            if(this_setTurnCode_method_request = '1') then
              this_setTurnCode_method_busy <= '1';
              setTurnCode_method_state <= setTurnCode_method_state + 1;
            else
              this_setTurnCode_method_busy <= '0';
            end if;
          when 1 =>
            if(this_setTurnCode_method_request = '0') then
              setTurnCode_method_state <= setTurnCode_method_state + 1;
            end if;
          when 2 => 
            turnCode_field_wdata_writer_setTurnCode_method_state <= conv_std_logic_vector(conv_integer(input_port_setTurnCode_v), turnCode_field_wdata'length);
            setTurnCode_method_state <= setTurnCode_method_state + 1;
          when 3 => 
            case conv_integer(state_counter_setTurnCode_setTurnCode_1) is
              when 0 => state_counter_setTurnCode_setTurnCode_1 <= state_counter_setTurnCode_setTurnCode_1 + 1;
              when 1 =>
                if (conv_integer(input_port_setTurnCode_v) = 1) then
                  setTurnCode_if_flag_setTurnCode_2_setTurnCode_0 <= '1';
                  state_counter_setTurnCode_setTurnCode_3 <= conv_std_logic_vector(1, state_counter_setTurnCode_setTurnCode_3'length);
                else
                  setTurnCode_if_flag_setTurnCode_2_setTurnCode_0 <= '0';
                  state_counter_setTurnCode_setTurnCode_4 <= conv_std_logic_vector(1, state_counter_setTurnCode_setTurnCode_4'length);
                end if;
                state_counter_setTurnCode_setTurnCode_1 <= state_counter_setTurnCode_setTurnCode_1 + 1;
              when 2 =>
                if (setTurnCode_if_flag_setTurnCode_2_setTurnCode_0 = '1') then
                  case conv_integer(state_counter_setTurnCode_setTurnCode_3) is
                    when 0 => state_counter_setTurnCode_setTurnCode_3 <= state_counter_setTurnCode_setTurnCode_3 + 1;
                    when 1 =>
                      myColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_3 <= conv_std_logic_vector(ORANGE, myColor_field_wdata'length);
                      opponentColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_3 <= conv_std_logic_vector(BLUE, opponentColor_field_wdata'length);
                      state_counter_setTurnCode_setTurnCode_1 <= state_counter_setTurnCode_setTurnCode_1 + 1;
                      state_counter_setTurnCode_setTurnCode_3 <= (others => '0');
                    when others => state_counter_setTurnCode_setTurnCode_3 <= (others => '0');
                  end case;
                else
                  case conv_integer(state_counter_setTurnCode_setTurnCode_4) is
                    when 0 => state_counter_setTurnCode_setTurnCode_4 <= state_counter_setTurnCode_setTurnCode_4 + 1;
                    when 1 =>
                      myColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_4 <= conv_std_logic_vector(BLUE, myColor_field_wdata'length);
                      opponentColor_field_wdata_writer_state_counter_setTurnCode_setTurnCode_4 <= conv_std_logic_vector(ORANGE, opponentColor_field_wdata'length);
                      state_counter_setTurnCode_setTurnCode_1 <= state_counter_setTurnCode_setTurnCode_1 + 1;
                      state_counter_setTurnCode_setTurnCode_4 <= (others => '0');
                    when others => state_counter_setTurnCode_setTurnCode_4 <= (others => '0');
                  end case;
                end if;
              when 3 =>
                state_counter_setTurnCode_setTurnCode_1 <= (others => '0');
                setTurnCode_method_state <= setTurnCode_method_state + 1;
              when others =>
                state_counter_setTurnCode_setTurnCode_1 <= (others => '0');
            end case;
          when 4 =>
            this_setTurnCode_method_busy <= '0';
            setTurnCode_method_state <= (others => '0');
          when others => setTurnCode_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --setTurnCode
  process(clk) --getNextMove
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_getNextMove_getNextMove_0 <= (others => '0');
        state_counter_getNextMove_getNextMove_1 <= (others => '0');
        getNextMove_if_flag_getNextMove_2_getNextMove_0 <= '0';
        state_counter_getNextMove_getNextMove_3 <= (others => '0');
        state_counter_getNextMove_getNextMove_4 <= (others => '0');
        getNextMove_if_flag_getNextMove_5_getNextMove_0 <= '0';
        state_counter_getNextMove_getNextMove_6 <= (others => '0');
        this_getNextMove1_call_state_counter_getNextMove_6 <= (others => '0');
        this_getNextMove1_call_state_counter_getNextMove_6 <= (others => '0');
        state_counter_getNextMove_getNextMove_7 <= (others => '0');
        this_getNextMove2_call_state_counter_getNextMove_7 <= (others => '0');
        this_getNextMove2_call_state_counter_getNextMove_7 <= (others => '0');
        this_getNextMove_method_busy <= '0';
        getNextMove_method_state <= (others => '0');
        output_port_getNextMove <= (others => '0');
        this_getNextMove1_method_request_field_wdata_reset <= '0';
        this_getNextMove2_method_request_field_wdata_reset <= '0';
      else
        case conv_integer(getNextMove_method_state) is
          when 0 =>
            if(this_getNextMove_method_request = '1') then
              this_getNextMove_method_busy <= '1';
              getNextMove_method_state <= getNextMove_method_state + 1;
            else
              this_getNextMove_method_busy <= '0';
            end if;
          when 1 =>
            if(this_getNextMove_method_request = '0') then
              getNextMove_method_state <= getNextMove_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(state_counter_getNextMove_getNextMove_1) is
              when 0 => state_counter_getNextMove_getNextMove_1 <= state_counter_getNextMove_getNextMove_1 + 1;
              when 1 =>
                if (conv_integer(nextId_field_rdata) < 0) then
                  getNextMove_if_flag_getNextMove_2_getNextMove_0 <= '1';
                  state_counter_getNextMove_getNextMove_3 <= conv_std_logic_vector(1, state_counter_getNextMove_getNextMove_3'length);
                else
                  getNextMove_if_flag_getNextMove_2_getNextMove_0 <= '0';
                end if;
                state_counter_getNextMove_getNextMove_1 <= state_counter_getNextMove_getNextMove_1 + 1;
              when 2 =>
                if (getNextMove_if_flag_getNextMove_2_getNextMove_0 = '1') then
                  case conv_integer(state_counter_getNextMove_getNextMove_3) is
                    when 0 => state_counter_getNextMove_getNextMove_3 <= state_counter_getNextMove_getNextMove_3 + 1;
                    when 1 =>
                      output_port_getNextMove <= conv_std_logic_vector(-1, output_port_getNextMove'length);
                      state_counter_getNextMove_getNextMove_3 <= (others => '0');
                      state_counter_getNextMove_getNextMove_1 <= (others => '0');
                      getNextMove_method_state <= (others => '0');
                    when 2 =>
                      state_counter_getNextMove_getNextMove_1 <= state_counter_getNextMove_getNextMove_1 + 1;
                      state_counter_getNextMove_getNextMove_3 <= (others => '0');
                    when others => state_counter_getNextMove_getNextMove_3 <= (others => '0');
                  end case;
                else
                  state_counter_getNextMove_getNextMove_1 <= state_counter_getNextMove_getNextMove_1 + 1;
                end if;
              when 3 =>
                state_counter_getNextMove_getNextMove_1 <= (others => '0');
                getNextMove_method_state <= getNextMove_method_state + 1;
              when others =>
                state_counter_getNextMove_getNextMove_1 <= (others => '0');
            end case;
          when 3 => 
            case conv_integer(state_counter_getNextMove_getNextMove_4) is
              when 0 => state_counter_getNextMove_getNextMove_4 <= state_counter_getNextMove_getNextMove_4 + 1;
              when 1 =>
                if (conv_integer(turnCode_field_rdata) = 1) then
                  getNextMove_if_flag_getNextMove_5_getNextMove_0 <= '1';
                  state_counter_getNextMove_getNextMove_6 <= conv_std_logic_vector(1, state_counter_getNextMove_getNextMove_6'length);
                else
                  getNextMove_if_flag_getNextMove_5_getNextMove_0 <= '0';
                  state_counter_getNextMove_getNextMove_7 <= conv_std_logic_vector(1, state_counter_getNextMove_getNextMove_7'length);
                end if;
                state_counter_getNextMove_getNextMove_4 <= state_counter_getNextMove_getNextMove_4 + 1;
              when 2 =>
                if (getNextMove_if_flag_getNextMove_5_getNextMove_0 = '1') then
                  case conv_integer(state_counter_getNextMove_getNextMove_6) is
                    when 0 => state_counter_getNextMove_getNextMove_6 <= state_counter_getNextMove_getNextMove_6 + 1;
                    when 1 =>
                      case conv_integer(this_getNextMove1_call_state_counter_getNextMove_6) is
                        when 0 =>
                          if (this_getNextMove1_method_busy = '0') then
                            this_getNextMove1_method_request_field_wdata_writer_state_counter_getNextMove_getNextMove_6 <= '1';
                            this_getNextMove1_call_state_counter_getNextMove_6 <= conv_std_logic_vector(1, this_getNextMove1_call_state_counter_getNextMove_6'length);
                          end if;
                        when 1 =>
                          this_getNextMove1_method_request_field_wdata_writer_state_counter_getNextMove_getNextMove_6 <= '0';
                            this_getNextMove1_call_state_counter_getNextMove_6 <= conv_std_logic_vector(2, this_getNextMove1_call_state_counter_getNextMove_6'length);
                        when 2 =>
                          if (this_getNextMove1_method_request_field_wdata = '0' and this_getNextMove1_method_busy = '0') then
                            this_getNextMove1_call_state_counter_getNextMove_6 <= (others => '0');
                            state_counter_getNextMove_getNextMove_6 <= state_counter_getNextMove_getNextMove_6 + 1;
                          end if;
                        when others => this_getNextMove1_call_state_counter_getNextMove_6 <= (others => '0');
                      end case;
                    when 2 =>
                      output_port_getNextMove <= conv_std_logic_vector(conv_integer(this_output_port_getNextMove1), output_port_getNextMove'length);
                      state_counter_getNextMove_getNextMove_6 <= (others => '0');
                      state_counter_getNextMove_getNextMove_4 <= (others => '0');
                      getNextMove_method_state <= (others => '0');
                    when 3 =>
                      state_counter_getNextMove_getNextMove_4 <= state_counter_getNextMove_getNextMove_4 + 1;
                      state_counter_getNextMove_getNextMove_6 <= (others => '0');
                    when others => state_counter_getNextMove_getNextMove_6 <= (others => '0');
                  end case;
                else
                  case conv_integer(state_counter_getNextMove_getNextMove_7) is
                    when 0 => state_counter_getNextMove_getNextMove_7 <= state_counter_getNextMove_getNextMove_7 + 1;
                    when 1 =>
                      case conv_integer(this_getNextMove2_call_state_counter_getNextMove_7) is
                        when 0 =>
                          if (this_getNextMove2_method_busy = '0') then
                            this_getNextMove2_method_request_field_wdata_writer_state_counter_getNextMove_getNextMove_7 <= '1';
                            this_getNextMove2_call_state_counter_getNextMove_7 <= conv_std_logic_vector(1, this_getNextMove2_call_state_counter_getNextMove_7'length);
                          end if;
                        when 1 =>
                          this_getNextMove2_method_request_field_wdata_writer_state_counter_getNextMove_getNextMove_7 <= '0';
                            this_getNextMove2_call_state_counter_getNextMove_7 <= conv_std_logic_vector(2, this_getNextMove2_call_state_counter_getNextMove_7'length);
                        when 2 =>
                          if (this_getNextMove2_method_request_field_wdata = '0' and this_getNextMove2_method_busy = '0') then
                            this_getNextMove2_call_state_counter_getNextMove_7 <= (others => '0');
                            state_counter_getNextMove_getNextMove_7 <= state_counter_getNextMove_getNextMove_7 + 1;
                          end if;
                        when others => this_getNextMove2_call_state_counter_getNextMove_7 <= (others => '0');
                      end case;
                    when 2 =>
                      output_port_getNextMove <= conv_std_logic_vector(conv_integer(this_output_port_getNextMove2), output_port_getNextMove'length);
                      state_counter_getNextMove_getNextMove_7 <= (others => '0');
                      state_counter_getNextMove_getNextMove_4 <= (others => '0');
                      getNextMove_method_state <= (others => '0');
                    when 3 =>
                      state_counter_getNextMove_getNextMove_4 <= state_counter_getNextMove_getNextMove_4 + 1;
                      state_counter_getNextMove_getNextMove_7 <= (others => '0');
                    when others => state_counter_getNextMove_getNextMove_7 <= (others => '0');
                  end case;
                end if;
              when 3 =>
                state_counter_getNextMove_getNextMove_4 <= (others => '0');
                getNextMove_method_state <= getNextMove_method_state + 1;
              when others =>
                state_counter_getNextMove_getNextMove_4 <= (others => '0');
            end case;
          when 4 =>
            this_getNextMove_method_busy <= '0';
            getNextMove_method_state <= (others => '0');
          when others => getNextMove_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --getNextMove
  process(clk) --notify
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        notify_flag <= '0';
        this_notify_method_busy <= '0';
        notify_method_state <= (others => '0');
        state_counter_notify_notify_0 <= (others => '0');
      else
        case conv_integer(notify_method_state) is
          when 0 =>
            if(this_notify_method_request = '1') then
              this_notify_method_busy <= '1';
              notify_method_state <= notify_method_state + 1;
            else
              this_notify_method_busy <= '0';
            end if;
          when 1 =>
            if(this_notify_method_request = '0') then
              notify_method_state <= notify_method_state + 1;
            end if;
          when 2 => 
            notify_flag <= '1';
            notify_method_state <= notify_method_state + 1;
          when 3 => 
            notify_flag <= '0';
            notify_method_state <= notify_method_state + 1;
          when 4 =>
            this_notify_method_busy <= '0';
            notify_method_state <= (others => '0');
          when others => notify_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --notify
  process(clk) --init
  begin
    if (clk'event and clk = '1') then
      if (reset = '1') then
        state_counter_init_init_0 <= (others => '0');
        board_init_call_state_counter_init_0 <= (others => '0');
        board_init_call_state_counter_init_0 <= (others => '0');
        this_init_method_busy <= '0';
        init_method_state <= (others => '0');
        board_init_method_request_field_wdata_reset <= '0';
      else
        case conv_integer(init_method_state) is
          when 0 =>
            if(this_init_method_request = '1') then
              this_init_method_busy <= '1';
              init_method_state <= init_method_state + 1;
            else
              this_init_method_busy <= '0';
            end if;
          when 1 =>
            if(this_init_method_request = '0') then
              init_method_state <= init_method_state + 1;
            end if;
          when 2 => 
            case conv_integer(board_init_call_state_counter_init_0) is
              when 0 =>
                if (board_init_method_busy_field_wdata = '0') then
                  board_init_method_request_field_wdata_writer_init_method_state <= '1';
                  board_init_call_state_counter_init_0 <= conv_std_logic_vector(1, board_init_call_state_counter_init_0'length);
                end if;
              when 1 =>
                board_init_method_request_field_wdata_writer_init_method_state <= '0';
                  board_init_call_state_counter_init_0 <= conv_std_logic_vector(2, board_init_call_state_counter_init_0'length);
              when 2 =>
                if (board_init_method_request_field_wdata = '0' and board_init_method_busy_field_wdata = '0') then
                  board_init_call_state_counter_init_0 <= (others => '0');
                  init_method_state <= init_method_state + 1;
                end if;
              when others => board_init_call_state_counter_init_0 <= (others => '0');
            end case;
          when 3 =>
            this_init_method_busy <= '0';
            init_method_state <= (others => '0');
          when others => init_method_state <= (others => '0');
        end case;
      end if;
    end if;
  end process; --init
end RTL;
